/**
 */
package de.mdelab.mlstorypatterns;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import de.mdelab.mlcore.MlcorePackage;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each operation of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.mdelab.mlstorypatterns.MlstorypatternsFactory
 * @model kind="package"
 * @generated
 */
public interface MlstorypatternsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "mlstorypatterns";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.mdelab.de/mlstorypatterns/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "mlstorypatterns";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	MlstorypatternsPackage eINSTANCE = de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl
			.init();

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl
	 * <em>Story Pattern</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlstorypatterns.impl.StoryPatternImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPattern()
	 * @generated
	 */
	int STORY_PATTERN = 0;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__NAME = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Story Pattern Links</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__STORY_PATTERN_LINKS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Story Pattern Objects</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__STORY_PATTERN_OBJECTS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The feature id for the '<em><b>Link Order Constraints</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__LINK_ORDER_CONSTRAINTS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__CONSTRAINTS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 5;

	/**
	 * The feature id for the '<em><b>Negative Application Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 6;

	/**
	 * The feature id for the '<em><b>Containing Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN__CONTAINING_PATTERN = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 7;

	/**
	 * The number of structural features of the '<em>Story Pattern</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 8;

	/**
	 * The operation id for the '<em>Story Pattern Not Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN___STORY_PATTERN_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Story Pattern Bound Node</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN___STORY_PATTERN_BOUND_NODE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Story Pattern</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl <em>Story Pattern Element</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPatternElement()
	 * @generated
	 */
	int STORY_PATTERN_ELEMENT = 1;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT__MODIFIER = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT__MATCH_TYPE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The number of structural features of the '<em>Story Pattern Element</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The number of operations of the '<em>Story Pattern Element</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_ELEMENT_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl <em>Abstract Story Pattern Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getAbstractStoryPatternObject()
	 * @generated
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT = 2;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__UUID = STORY_PATTERN_ELEMENT__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__ANNOTATIONS = STORY_PATTERN_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__MODIFIER = STORY_PATTERN_ELEMENT__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__MATCH_TYPE = STORY_PATTERN_ELEMENT__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__NAME = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__TYPE = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Outgoing Links</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Incoming Links</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 3;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 4;

	/**
	 * The number of structural features of the '<em>Abstract Story Pattern Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT_FEATURE_COUNT = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_TYPE__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Unique Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_UNIQUE_NAME__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAME__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Abstract Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_ABSTRACT_TYPE__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object NAC Modified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAC_MODIFIED__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 4;

	/**
	 * The number of operations of the '<em>Abstract Story Pattern Object</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 5;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl <em>Story Pattern Object</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPatternObject()
	 * @generated
	 */
	int STORY_PATTERN_OBJECT = 3;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__UUID = ABSTRACT_STORY_PATTERN_OBJECT__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__ANNOTATIONS = ABSTRACT_STORY_PATTERN_OBJECT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__MODIFIER = ABSTRACT_STORY_PATTERN_OBJECT__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__MATCH_TYPE = ABSTRACT_STORY_PATTERN_OBJECT__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__NAME = ABSTRACT_STORY_PATTERN_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__TYPE = ABSTRACT_STORY_PATTERN_OBJECT__TYPE;

	/**
	 * The feature id for the '<em><b>Outgoing Links</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__OUTGOING_LINKS = ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS;

	/**
	 * The feature id for the '<em><b>Incoming Links</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__INCOMING_LINKS = ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__STORY_PATTERN = ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN;

	/**
	 * The feature id for the '<em><b>Binding Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__BINDING_TYPE = ABSTRACT_STORY_PATTERN_OBJECT_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__CONSTRAINTS = ABSTRACT_STORY_PATTERN_OBJECT_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Assignment Expression</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION = ABSTRACT_STORY_PATTERN_OBJECT_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Attribute Assignments</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS = ABSTRACT_STORY_PATTERN_OBJECT_FEATURE_COUNT
			+ 3;

	/**
	 * The number of structural features of the '<em>Story Pattern Object</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT_FEATURE_COUNT = ABSTRACT_STORY_PATTERN_OBJECT_FEATURE_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_TYPE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Unique Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_UNIQUE_NAME__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_UNIQUE_NAME__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAME__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAME__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object Abstract Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_ABSTRACT_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_ABSTRACT_TYPE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Object NAC Modified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAC_MODIFIED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAC_MODIFIED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Story Pattern Object Assignment Bound</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_ASSIGNMENT_BOUND__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Story Pattern Object Data Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DATA_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Story Pattern Object Incoming Link</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_INCOMING_LINK__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Story Pattern Object Created Unbound</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_UNBOUND__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Story Pattern Object Created Constraints</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_CONSTRAINTS__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Story Pattern Object Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Story Pattern Object NAC Unbound</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_NAC_UNBOUND__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 6;

	/**
	 * The number of operations of the '<em>Story Pattern Object</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_OBJECT_OPERATION_COUNT = ABSTRACT_STORY_PATTERN_OBJECT_OPERATION_COUNT
			+ 7;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl <em>Attribute Assignment</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getAttributeAssignment()
	 * @generated
	 */
	int ATTRIBUTE_ASSIGNMENT = 4;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Story Pattern Object</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Assignment Expression</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Feature</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT__FEATURE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The number of structural features of the '<em>Attribute Assignment</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Attribute Assignment Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_FEATURE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Attribute Assignment Expression</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_EXPRESSION__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Attribute Assignment Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_TYPE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The number of operations of the '<em>Attribute Assignment</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_ASSIGNMENT_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 3;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl <em>Abstract Story Pattern Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getAbstractStoryPatternLink()
	 * @generated
	 */
	int ABSTRACT_STORY_PATTERN_LINK = 5;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__UUID = STORY_PATTERN_ELEMENT__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__ANNOTATIONS = STORY_PATTERN_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__MODIFIER = STORY_PATTERN_ELEMENT__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__MATCH_TYPE = STORY_PATTERN_ELEMENT__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__SOURCE = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__TARGET = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 2;

	/**
	 * The number of structural features of the '<em>Abstract Story Pattern Link</em>' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT = STORY_PATTERN_ELEMENT_FEATURE_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link NAC Modifier</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Target Pattern</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 6;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 7;

	/**
	 * The number of operations of the '<em>Abstract Story Pattern Link</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT = STORY_PATTERN_ELEMENT_OPERATION_COUNT
			+ 8;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl <em>Story Pattern Link</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPatternLink()
	 * @generated
	 */
	int STORY_PATTERN_LINK = 6;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__UUID = ABSTRACT_STORY_PATTERN_LINK__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__ANNOTATIONS = ABSTRACT_STORY_PATTERN_LINK__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__MODIFIER = ABSTRACT_STORY_PATTERN_LINK__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__MATCH_TYPE = ABSTRACT_STORY_PATTERN_LINK__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__SOURCE = ABSTRACT_STORY_PATTERN_LINK__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__TARGET = ABSTRACT_STORY_PATTERN_LINK__TARGET;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__STORY_PATTERN = ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN;

	/**
	 * The feature id for the '<em><b>Feature</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__FEATURE = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Link Position Constraint</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Outgoing Link Order Constraints</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Incoming Link Order Constraints</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 3;

	/**
	 * The number of structural features of the '<em>Story Pattern Link</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK_FEATURE_COUNT = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link NAC Modifier</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Target Pattern</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Story Pattern Link Source Type Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Story Pattern Link Source Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Story Pattern Link Ordered Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_LINK_ORDERED_FEATURE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Story Pattern Link Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_LINK_FEATURE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Story Pattern Link Position Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_LINK_POSITION_CONSTRAINT__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Story Pattern Link Target Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK___STORY_PATTERN_LINK_TARGET_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 5;

	/**
	 * The number of operations of the '<em>Story Pattern Link</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_PATTERN_LINK_OPERATION_COUNT = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 6;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.ContainmentLinkImpl <em>Containment Link</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.ContainmentLinkImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getContainmentLink()
	 * @generated
	 */
	int CONTAINMENT_LINK = 7;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__UUID = ABSTRACT_STORY_PATTERN_LINK__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__ANNOTATIONS = ABSTRACT_STORY_PATTERN_LINK__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__MODIFIER = ABSTRACT_STORY_PATTERN_LINK__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__MATCH_TYPE = ABSTRACT_STORY_PATTERN_LINK__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__SOURCE = ABSTRACT_STORY_PATTERN_LINK__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__TARGET = ABSTRACT_STORY_PATTERN_LINK__TARGET;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK__STORY_PATTERN = ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN;

	/**
	 * The number of structural features of the '<em>Containment Link</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK_FEATURE_COUNT = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link NAC Modifier</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Target Pattern</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Containment Link Source Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK___CONTAINMENT_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 0;

	/**
	 * The number of operations of the '<em>Containment Link</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_LINK_OPERATION_COUNT = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.ExpressionLinkImpl <em>Expression Link</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.ExpressionLinkImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getExpressionLink()
	 * @generated
	 */
	int EXPRESSION_LINK = 8;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__UUID = ABSTRACT_STORY_PATTERN_LINK__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__ANNOTATIONS = ABSTRACT_STORY_PATTERN_LINK__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__MODIFIER = ABSTRACT_STORY_PATTERN_LINK__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__MATCH_TYPE = ABSTRACT_STORY_PATTERN_LINK__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__SOURCE = ABSTRACT_STORY_PATTERN_LINK__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__TARGET = ABSTRACT_STORY_PATTERN_LINK__TARGET;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__STORY_PATTERN = ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK__EXPRESSION = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 0;

	/**
	 * The number of structural features of the '<em>Expression Link</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK_FEATURE_COUNT = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link NAC Modifier</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Target Pattern</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Expression Link Expression</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK___EXPRESSION_LINK_EXPRESSION__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 0;

	/**
	 * The number of operations of the '<em>Expression Link</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_LINK_OPERATION_COUNT = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.MapEntryLinkImpl <em>Map Entry Link</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.MapEntryLinkImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getMapEntryLink()
	 * @generated
	 */
	int MAP_ENTRY_LINK = 9;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__UUID = ABSTRACT_STORY_PATTERN_LINK__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__ANNOTATIONS = ABSTRACT_STORY_PATTERN_LINK__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Modifier</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__MODIFIER = ABSTRACT_STORY_PATTERN_LINK__MODIFIER;

	/**
	 * The feature id for the '<em><b>Match Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__MATCH_TYPE = ABSTRACT_STORY_PATTERN_LINK__MATCH_TYPE;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__SOURCE = ABSTRACT_STORY_PATTERN_LINK__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__TARGET = ABSTRACT_STORY_PATTERN_LINK__TARGET;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__STORY_PATTERN = ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN;

	/**
	 * The feature id for the '<em><b>Feature</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__FEATURE = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Value Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK__VALUE_TARGET = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 1;

	/**
	 * The number of structural features of the '<em>Map Entry Link</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK_FEATURE_COUNT = ABSTRACT_STORY_PATTERN_LINK_FEATURE_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Story Pattern Element Optional</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link NAC Modifier</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Source Target Pattern</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Destroyed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Abstract Story Pattern Link Target Created</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Map Entry Link Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___MAP_ENTRY_LINK_FEATURE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Map Entry Link Source Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Map Entry Link Source Type Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 2;

	/**
	 * The number of operations of the '<em>Map Entry Link</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAP_ENTRY_LINK_OPERATION_COUNT = ABSTRACT_STORY_PATTERN_LINK_OPERATION_COUNT
			+ 3;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl <em>Link Order Constraint</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getLinkOrderConstraint()
	 * @generated
	 */
	int LINK_ORDER_CONSTRAINT = 10;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Constraint Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Predecessor Link</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Successor Link</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT__STORY_PATTERN = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The number of structural features of the '<em>Link Order Constraint</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Link Order Constraint Predecessor Position</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_POSITION__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Link Order Constraint Successor</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Link Order Constraint Successor Position</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR_POSITION__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Link Order Constraint Predecessor</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Link Order Constraint Predecessor Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_FEATURE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Link Order Constraint Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_TYPE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Link Order Constraint Matching Feature</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_MATCHING_FEATURE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 6;

	/**
	 * The number of operations of the '<em>Link Order Constraint</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ORDER_CONSTRAINT_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 7;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.ModifierEnum <em>Modifier Enum</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.ModifierEnum
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getModifierEnum()
	 * @generated
	 */
	int MODIFIER_ENUM = 11;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.MatchTypeEnum <em>Match Type Enum</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.MatchTypeEnum
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getMatchTypeEnum()
	 * @generated
	 */
	int MATCH_TYPE_ENUM = 12;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.BindingTypeEnum <em>Binding Type Enum</em>}' enum.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.BindingTypeEnum
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getBindingTypeEnum()
	 * @generated
	 */
	int BINDING_TYPE_ENUM = 13;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.LinkPositionConstraintEnum <em>Link Position Constraint Enum</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.LinkPositionConstraintEnum
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getLinkPositionConstraintEnum()
	 * @generated
	 */
	int LINK_POSITION_CONSTRAINT_ENUM = 14;

	/**
	 * The meta object id for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraintEnum <em>Link Order Constraint Enum</em>}' enum.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraintEnum
	 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getLinkOrderConstraintEnum()
	 * @generated
	 */
	int LINK_ORDER_CONSTRAINT_ENUM = 15;

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.StoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Story Pattern</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern
	 * @generated
	 */
	EClass getStoryPattern();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternLinks
	 * <em>Story Pattern Links</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Story Pattern Links</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternLinks()
	 * @see #getStoryPattern()
	 * @generated
	 */
	EReference getStoryPattern_StoryPatternLinks();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternObjects <em>Story Pattern Objects</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Story Pattern Objects</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternObjects()
	 * @see #getStoryPattern()
	 * @generated
	 */
	EReference getStoryPattern_StoryPatternObjects();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlstorypatterns.StoryPattern#getLinkOrderConstraints <em>Link Order Constraints</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Link Order Constraints</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getLinkOrderConstraints()
	 * @see #getStoryPattern()
	 * @generated
	 */
	EReference getStoryPattern_LinkOrderConstraints();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlstorypatterns.StoryPattern#getConstraints <em>Constraints</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Constraints</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getConstraints()
	 * @see #getStoryPattern()
	 * @generated
	 */
	EReference getStoryPattern_Constraints();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlstorypatterns.StoryPattern#getNegativeApplicationConditions <em>Negative Application Conditions</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Negative Application Conditions</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getNegativeApplicationConditions()
	 * @see #getStoryPattern()
	 * @generated
	 */
	EReference getStoryPattern_NegativeApplicationConditions();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlstorypatterns.StoryPattern#getContainingPattern
	 * <em>Containing Pattern</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Containing Pattern</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getContainingPattern()
	 * @see #getStoryPattern()
	 * @generated
	 */
	EReference getStoryPattern_ContainingPattern();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPattern#StoryPatternNotEmpty(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Not Empty</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Not Empty</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#StoryPatternNotEmpty(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPattern__StoryPatternNotEmpty__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPattern#StoryPatternBoundNode(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Bound Node</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Bound Node</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPattern#StoryPatternBoundNode(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPattern__StoryPatternBoundNode__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.StoryPatternElement <em>Story Pattern Element</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Story Pattern Element</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternElement
	 * @generated
	 */
	EClass getStoryPatternElement();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlstorypatterns.StoryPatternElement#getModifier <em>Modifier</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Modifier</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternElement#getModifier()
	 * @see #getStoryPatternElement()
	 * @generated
	 */
	EAttribute getStoryPatternElement_Modifier();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlstorypatterns.StoryPatternElement#getMatchType <em>Match Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Match Type</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternElement#getMatchType()
	 * @see #getStoryPatternElement()
	 * @generated
	 */
	EAttribute getStoryPatternElement_MatchType();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternElement#StoryPatternElementOptional(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Element Optional</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Element Optional</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternElement#StoryPatternElementOptional(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternElement__StoryPatternElementOptional__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject <em>Abstract Story Pattern Object</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Abstract Story Pattern Object</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject
	 * @generated
	 */
	EClass getAbstractStoryPatternObject();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getOutgoingLinks <em>Outgoing Links</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Outgoing Links</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getOutgoingLinks()
	 * @see #getAbstractStoryPatternObject()
	 * @generated
	 */
	EReference getAbstractStoryPatternObject_OutgoingLinks();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getIncomingLinks <em>Incoming Links</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Links</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getIncomingLinks()
	 * @see #getAbstractStoryPatternObject()
	 * @generated
	 */
	EReference getAbstractStoryPatternObject_IncomingLinks();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Story Pattern</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getStoryPattern()
	 * @see #getAbstractStoryPatternObject()
	 * @generated
	 */
	EReference getAbstractStoryPatternObject_StoryPattern();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Object Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Object Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectUniqueName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Object Unique Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Object Unique Name</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectUniqueName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectUniqueName__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Object Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Object Name</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectName__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectAbstractType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Object Abstract Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Object Abstract Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectAbstractType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectAbstractType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectNACModified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Object NAC Modified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Object NAC Modified</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#AbstractStoryPatternObjectNACModified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectNACModified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.StoryPatternObject <em>Story Pattern Object</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Story Pattern Object</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject
	 * @generated
	 */
	EClass getStoryPatternObject();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlstorypatterns.StoryPatternObject#getBindingType <em>Binding Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Binding Type</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#getBindingType()
	 * @see #getStoryPatternObject()
	 * @generated
	 */
	EAttribute getStoryPatternObject_BindingType();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlstorypatterns.StoryPatternObject#getConstraints <em>Constraints</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Constraints</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#getConstraints()
	 * @see #getStoryPatternObject()
	 * @generated
	 */
	EReference getStoryPatternObject_Constraints();

	/**
	 * Returns the meta object for the containment reference '{@link de.mdelab.mlstorypatterns.StoryPatternObject#getAssignmentExpression <em>Assignment Expression</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference '<em>Assignment Expression</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#getAssignmentExpression()
	 * @see #getStoryPatternObject()
	 * @generated
	 */
	EReference getStoryPatternObject_AssignmentExpression();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlstorypatterns.StoryPatternObject#getAttributeAssignments <em>Attribute Assignments</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Attribute Assignments</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#getAttributeAssignments()
	 * @see #getStoryPatternObject()
	 * @generated
	 */
	EReference getStoryPatternObject_AttributeAssignments();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectAssignmentBound(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object Assignment Bound</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object Assignment Bound</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectAssignmentBound(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectAssignmentBound__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectDataType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object Data Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object Data Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectDataType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectDataType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectIncomingLink(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object Incoming Link</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object Incoming Link</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectIncomingLink(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectIncomingLink__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectCreatedUnbound(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object Created Unbound</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object Created Unbound</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectCreatedUnbound(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectCreatedUnbound__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectCreatedConstraints(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object Created Constraints</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object Created Constraints</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectCreatedConstraints(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectCreatedConstraints__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectDestroyed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object Destroyed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object Destroyed</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectDestroyed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectDestroyed__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectNACUnbound(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Object NAC Unbound</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Object NAC Unbound</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#StoryPatternObjectNACUnbound(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternObject__StoryPatternObjectNACUnbound__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.AttributeAssignment <em>Attribute Assignment</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Attribute Assignment</em>'.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment
	 * @generated
	 */
	EClass getAttributeAssignment();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlstorypatterns.AttributeAssignment#getStoryPatternObject <em>Story Pattern Object</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the container reference '<em>Story Pattern Object</em>'.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment#getStoryPatternObject()
	 * @see #getAttributeAssignment()
	 * @generated
	 */
	EReference getAttributeAssignment_StoryPatternObject();

	/**
	 * Returns the meta object for the containment reference '{@link de.mdelab.mlstorypatterns.AttributeAssignment#getAssignmentExpression <em>Assignment Expression</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference '<em>Assignment Expression</em>'.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment#getAssignmentExpression()
	 * @see #getAttributeAssignment()
	 * @generated
	 */
	EReference getAttributeAssignment_AssignmentExpression();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.AttributeAssignment#getFeature <em>Feature</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature</em>'.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment#getFeature()
	 * @see #getAttributeAssignment()
	 * @generated
	 */
	EReference getAttributeAssignment_Feature();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AttributeAssignment#AttributeAssignmentFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Attribute Assignment Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Attribute Assignment Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment#AttributeAssignmentFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAttributeAssignment__AttributeAssignmentFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AttributeAssignment#AttributeAssignmentExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Attribute Assignment Expression</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Attribute Assignment Expression</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment#AttributeAssignmentExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAttributeAssignment__AttributeAssignmentExpression__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AttributeAssignment#AttributeAssignmentType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Attribute Assignment Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Attribute Assignment Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment#AttributeAssignmentType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAttributeAssignment__AttributeAssignmentType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink <em>Abstract Story Pattern Link</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Abstract Story Pattern Link</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink
	 * @generated
	 */
	EClass getAbstractStoryPatternLink();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getSource()
	 * @see #getAbstractStoryPatternLink()
	 * @generated
	 */
	EReference getAbstractStoryPatternLink_Source();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getTarget()
	 * @see #getAbstractStoryPatternLink()
	 * @generated
	 */
	EReference getAbstractStoryPatternLink_Target();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Story Pattern</em>'.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getStoryPattern()
	 * @see #getAbstractStoryPatternLink()
	 * @generated
	 */
	EReference getAbstractStoryPatternLink_StoryPattern();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkNACModifier(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link NAC Modifier</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link NAC Modifier</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkNACModifier(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkNACModifier__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSource(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Source</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Source</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSource(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSource__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSourceDestroyed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Source Destroyed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Source Destroyed</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSourceDestroyed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceDestroyed__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkTarget(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Target</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Target</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkTarget(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkTarget__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSourceCreated(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Source Created</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Source Created</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSourceCreated(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceCreated__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSourceTargetPattern(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Source Target Pattern</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Source Target Pattern</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkSourceTargetPattern(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceTargetPattern__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkTargetDestroyed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Target Destroyed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Target Destroyed</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkTargetDestroyed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetDestroyed__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkTargetCreated(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Abstract Story Pattern Link Target Created</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Abstract Story Pattern Link Target Created</em>' operation.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#AbstractStoryPatternLinkTargetCreated(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetCreated__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlstorypatterns.StoryPatternLink
	 * <em>Story Pattern Link</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for class '<em>Story Pattern Link</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink
	 * @generated
	 */
	EClass getStoryPatternLink();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.StoryPatternLink#getFeature <em>Feature</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#getFeature()
	 * @see #getStoryPatternLink()
	 * @generated
	 */
	EReference getStoryPatternLink_Feature();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlstorypatterns.StoryPatternLink#getLinkPositionConstraint <em>Link Position Constraint</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the attribute '<em>Link Position Constraint</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#getLinkPositionConstraint()
	 * @see #getStoryPatternLink()
	 * @generated
	 */
	EAttribute getStoryPatternLink_LinkPositionConstraint();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlstorypatterns.StoryPatternLink#getOutgoingLinkOrderConstraints <em>Outgoing Link Order Constraints</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the reference list '<em>Outgoing Link Order Constraints</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#getOutgoingLinkOrderConstraints()
	 * @see #getStoryPatternLink()
	 * @generated
	 */
	EReference getStoryPatternLink_OutgoingLinkOrderConstraints();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlstorypatterns.StoryPatternLink#getIncomingLinkOrderConstraints <em>Incoming Link Order Constraints</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Link Order Constraints</em>'.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#getIncomingLinkOrderConstraints()
	 * @see #getStoryPatternLink()
	 * @generated
	 */
	EReference getStoryPatternLink_IncomingLinkOrderConstraints();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkSourceTypeFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Link Source Type Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Link Source Type Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkSourceTypeFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternLink__StoryPatternLinkSourceTypeFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkSourceType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Link Source Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Link Source Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkSourceType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternLink__StoryPatternLinkSourceType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkOrderedFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Link Ordered Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Link Ordered Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkOrderedFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternLink__StoryPatternLinkOrderedFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Link Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Link Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternLink__StoryPatternLinkFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkPositionConstraint(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Link Position Constraint</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Link Position Constraint</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkPositionConstraint(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternLink__StoryPatternLinkPositionConstraint__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkTargetType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Link Target Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Link Target Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink#StoryPatternLinkTargetType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryPatternLink__StoryPatternLinkTargetType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlstorypatterns.ContainmentLink
	 * <em>Containment Link</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for class '<em>Containment Link</em>'.
	 * @see de.mdelab.mlstorypatterns.ContainmentLink
	 * @generated
	 */
	EClass getContainmentLink();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.ContainmentLink#ContainmentLinkSourceType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Containment Link Source Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Containment Link Source Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.ContainmentLink#ContainmentLinkSourceType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getContainmentLink__ContainmentLinkSourceType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.ExpressionLink <em>Expression Link</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expression Link</em>'.
	 * @see de.mdelab.mlstorypatterns.ExpressionLink
	 * @generated
	 */
	EClass getExpressionLink();

	/**
	 * Returns the meta object for the containment reference '{@link de.mdelab.mlstorypatterns.ExpressionLink#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expression</em>'.
	 * @see de.mdelab.mlstorypatterns.ExpressionLink#getExpression()
	 * @see #getExpressionLink()
	 * @generated
	 */
	EReference getExpressionLink_Expression();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.ExpressionLink#ExpressionLinkExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Expression Link Expression</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Expression Link Expression</em>' operation.
	 * @see de.mdelab.mlstorypatterns.ExpressionLink#ExpressionLinkExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExpressionLink__ExpressionLinkExpression__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.MapEntryLink <em>Map Entry Link</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Map Entry Link</em>'.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink
	 * @generated
	 */
	EClass getMapEntryLink();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.MapEntryLink#getFeature <em>Feature</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature</em>'.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink#getFeature()
	 * @see #getMapEntryLink()
	 * @generated
	 */
	EReference getMapEntryLink_Feature();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.MapEntryLink#getValueTarget <em>Value Target</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Value Target</em>'.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink#getValueTarget()
	 * @see #getMapEntryLink()
	 * @generated
	 */
	EReference getMapEntryLink_ValueTarget();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.MapEntryLink#MapEntryLinkFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Map Entry Link Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Map Entry Link Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink#MapEntryLinkFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getMapEntryLink__MapEntryLinkFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.MapEntryLink#MapEntryLinkSourceType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Map Entry Link Source Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Map Entry Link Source Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink#MapEntryLinkSourceType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getMapEntryLink__MapEntryLinkSourceType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.MapEntryLink#MapEntryLinkSourceTypeFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Map Entry Link Source Type Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Map Entry Link Source Type Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink#MapEntryLinkSourceTypeFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getMapEntryLink__MapEntryLinkSourceTypeFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint <em>Link Order Constraint</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Link Order Constraint</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint
	 * @generated
	 */
	EClass getLinkOrderConstraint();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#getConstraintType <em>Constraint Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Constraint Type</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#getConstraintType()
	 * @see #getLinkOrderConstraint()
	 * @generated
	 */
	EAttribute getLinkOrderConstraint_ConstraintType();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlstorypatterns.LinkOrderConstraint#getPredecessorLink
	 * <em>Predecessor Link</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the reference '<em>Predecessor Link</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#getPredecessorLink()
	 * @see #getLinkOrderConstraint()
	 * @generated
	 */
	EReference getLinkOrderConstraint_PredecessorLink();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#getSuccessorLink <em>Successor Link</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Successor Link</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#getSuccessorLink()
	 * @see #getLinkOrderConstraint()
	 * @generated
	 */
	EReference getLinkOrderConstraint_SuccessorLink();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Story Pattern</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#getStoryPattern()
	 * @see #getLinkOrderConstraint()
	 * @generated
	 */
	EReference getLinkOrderConstraint_StoryPattern();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintPredecessorPosition(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Predecessor Position</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Predecessor Position</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintPredecessorPosition(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintPredecessorPosition__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintSuccessor(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Successor</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Successor</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintSuccessor(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintSuccessor__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintSuccessorPosition(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Successor Position</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Successor Position</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintSuccessorPosition(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintSuccessorPosition__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintPredecessor(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Predecessor</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Predecessor</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintPredecessor(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintPredecessor__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintPredecessorFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Predecessor Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Predecessor Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintPredecessorFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintPredecessorFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Type</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintMatchingFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Link Order Constraint Matching Feature</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Link Order Constraint Matching Feature</em>' operation.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#LinkOrderConstraintMatchingFeature(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLinkOrderConstraint__LinkOrderConstraintMatchingFeature__DiagnosticChain_Map();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlstorypatterns.ModifierEnum <em>Modifier Enum</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Modifier Enum</em>'.
	 * @see de.mdelab.mlstorypatterns.ModifierEnum
	 * @generated
	 */
	EEnum getModifierEnum();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlstorypatterns.MatchTypeEnum <em>Match Type Enum</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Match Type Enum</em>'.
	 * @see de.mdelab.mlstorypatterns.MatchTypeEnum
	 * @generated
	 */
	EEnum getMatchTypeEnum();

	/**
	 * Returns the meta object for enum '
	 * {@link de.mdelab.mlstorypatterns.BindingTypeEnum
	 * <em>Binding Type Enum</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for enum '<em>Binding Type Enum</em>'.
	 * @see de.mdelab.mlstorypatterns.BindingTypeEnum
	 * @generated
	 */
	EEnum getBindingTypeEnum();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlstorypatterns.LinkPositionConstraintEnum <em>Link Position Constraint Enum</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for enum '<em>Link Position Constraint Enum</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkPositionConstraintEnum
	 * @generated
	 */
	EEnum getLinkPositionConstraintEnum();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlstorypatterns.LinkOrderConstraintEnum <em>Link Order Constraint Enum</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for enum '<em>Link Order Constraint Enum</em>'.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraintEnum
	 * @generated
	 */
	EEnum getLinkOrderConstraintEnum();

	/**
	 * Returns the factory that creates the instances of the model. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MlstorypatternsFactory getMlstorypatternsFactory();

	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
	 * represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each operation of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl <em>Story Pattern</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.StoryPatternImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPattern()
		 * @generated
		 */
		EClass STORY_PATTERN = eINSTANCE.getStoryPattern();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN__STORY_PATTERN_LINKS = eINSTANCE
				.getStoryPattern_StoryPatternLinks();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Objects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN__STORY_PATTERN_OBJECTS = eINSTANCE
				.getStoryPattern_StoryPatternObjects();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraints</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN__LINK_ORDER_CONSTRAINTS = eINSTANCE
				.getStoryPattern_LinkOrderConstraints();

		/**
		 * The meta object literal for the '<em><b>Constraints</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN__CONSTRAINTS = eINSTANCE
				.getStoryPattern_Constraints();

		/**
		 * The meta object literal for the '<em><b>Negative Application Conditions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS = eINSTANCE
				.getStoryPattern_NegativeApplicationConditions();

		/**
		 * The meta object literal for the '<em><b>Containing Pattern</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN__CONTAINING_PATTERN = eINSTANCE
				.getStoryPattern_ContainingPattern();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Not Empty</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN___STORY_PATTERN_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPattern__StoryPatternNotEmpty__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Bound Node</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN___STORY_PATTERN_BOUND_NODE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPattern__StoryPatternBoundNode__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl <em>Story Pattern Element</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPatternElement()
		 * @generated
		 */
		EClass STORY_PATTERN_ELEMENT = eINSTANCE.getStoryPatternElement();

		/**
		 * The meta object literal for the '<em><b>Modifier</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STORY_PATTERN_ELEMENT__MODIFIER = eINSTANCE
				.getStoryPatternElement_Modifier();

		/**
		 * The meta object literal for the '<em><b>Match Type</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STORY_PATTERN_ELEMENT__MATCH_TYPE = eINSTANCE
				.getStoryPatternElement_MatchType();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Element Optional</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_ELEMENT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternElement__StoryPatternElementOptional__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl <em>Abstract Story Pattern Object</em>}' class.
		 * <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getAbstractStoryPatternObject()
		 * @generated
		 */
		EClass ABSTRACT_STORY_PATTERN_OBJECT = eINSTANCE
				.getAbstractStoryPatternObject();

		/**
		 * The meta object literal for the '<em><b>Outgoing Links</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS = eINSTANCE
				.getAbstractStoryPatternObject_OutgoingLinks();

		/**
		 * The meta object literal for the '<em><b>Incoming Links</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS = eINSTANCE
				.getAbstractStoryPatternObject_IncomingLinks();

		/**
		 * The meta object literal for the '<em><b>Story Pattern</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN = eINSTANCE
				.getAbstractStoryPatternObject_StoryPattern();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Object Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternObject__AbstractStoryPatternObjectType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Object Unique Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_UNIQUE_NAME__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternObject__AbstractStoryPatternObjectUniqueName__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Object Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAME__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternObject__AbstractStoryPatternObjectName__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Object Abstract Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_ABSTRACT_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternObject__AbstractStoryPatternObjectAbstractType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Object NAC Modified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAC_MODIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternObject__AbstractStoryPatternObjectNACModified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl <em>Story Pattern Object</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPatternObject()
		 * @generated
		 */
		EClass STORY_PATTERN_OBJECT = eINSTANCE.getStoryPatternObject();

		/**
		 * The meta object literal for the '<em><b>Binding Type</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STORY_PATTERN_OBJECT__BINDING_TYPE = eINSTANCE
				.getStoryPatternObject_BindingType();

		/**
		 * The meta object literal for the '<em><b>Constraints</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN_OBJECT__CONSTRAINTS = eINSTANCE
				.getStoryPatternObject_Constraints();

		/**
		 * The meta object literal for the '<em><b>Assignment Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION = eINSTANCE
				.getStoryPatternObject_AssignmentExpression();

		/**
		 * The meta object literal for the '<em><b>Attribute Assignments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS = eINSTANCE
				.getStoryPatternObject_AttributeAssignments();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object Assignment Bound</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_ASSIGNMENT_BOUND__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectAssignmentBound__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object Data Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DATA_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectDataType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object Incoming Link</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_INCOMING_LINK__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectIncomingLink__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object Created Unbound</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_UNBOUND__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectCreatedUnbound__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object Created Constraints</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_CONSTRAINTS__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectCreatedConstraints__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object Destroyed</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DESTROYED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectDestroyed__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object NAC Unbound</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_NAC_UNBOUND__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternObject__StoryPatternObjectNACUnbound__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl <em>Attribute Assignment</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getAttributeAssignment()
		 * @generated
		 */
		EClass ATTRIBUTE_ASSIGNMENT = eINSTANCE.getAttributeAssignment();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Object</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT = eINSTANCE
				.getAttributeAssignment_StoryPatternObject();

		/**
		 * The meta object literal for the '<em><b>Assignment Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION = eINSTANCE
				.getAttributeAssignment_AssignmentExpression();

		/**
		 * The meta object literal for the '<em><b>Feature</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATTRIBUTE_ASSIGNMENT__FEATURE = eINSTANCE
				.getAttributeAssignment_Feature();

		/**
		 * The meta object literal for the '<em><b>Attribute Assignment Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAttributeAssignment__AttributeAssignmentFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Attribute Assignment Expression</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_EXPRESSION__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAttributeAssignment__AttributeAssignmentExpression__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Attribute Assignment Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAttributeAssignment__AttributeAssignmentType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl <em>Abstract Story Pattern Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getAbstractStoryPatternLink()
		 * @generated
		 */
		EClass ABSTRACT_STORY_PATTERN_LINK = eINSTANCE
				.getAbstractStoryPatternLink();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_STORY_PATTERN_LINK__SOURCE = eINSTANCE
				.getAbstractStoryPatternLink_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_STORY_PATTERN_LINK__TARGET = eINSTANCE
				.getAbstractStoryPatternLink_Target();

		/**
		 * The meta object literal for the '<em><b>Story Pattern</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN = eINSTANCE
				.getAbstractStoryPatternLink_StoryPattern();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link NAC Modifier</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkNACModifier__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Source</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkSource__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Source Destroyed</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceDestroyed__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Target</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkTarget__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Source Created</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceCreated__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Source Target Pattern</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceTargetPattern__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Target Destroyed</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetDestroyed__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Abstract Story Pattern Link Target Created</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetCreated__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl <em>Story Pattern Link</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getStoryPatternLink()
		 * @generated
		 */
		EClass STORY_PATTERN_LINK = eINSTANCE.getStoryPatternLink();

		/**
		 * The meta object literal for the '<em><b>Feature</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN_LINK__FEATURE = eINSTANCE
				.getStoryPatternLink_Feature();

		/**
		 * The meta object literal for the '
		 * <em><b>Link Position Constraint</b></em>' attribute feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT = eINSTANCE
				.getStoryPatternLink_LinkPositionConstraint();

		/**
		 * The meta object literal for the '<em><b>Outgoing Link Order Constraints</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS = eINSTANCE
				.getStoryPatternLink_OutgoingLinkOrderConstraints();

		/**
		 * The meta object literal for the '<em><b>Incoming Link Order Constraints</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS = eINSTANCE
				.getStoryPatternLink_IncomingLinkOrderConstraints();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Link Source Type Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternLink__StoryPatternLinkSourceTypeFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Link Source Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternLink__StoryPatternLinkSourceType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Link Ordered Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_LINK___STORY_PATTERN_LINK_ORDERED_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternLink__StoryPatternLinkOrderedFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Link Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_LINK___STORY_PATTERN_LINK_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternLink__StoryPatternLinkFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Link Position Constraint</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_LINK___STORY_PATTERN_LINK_POSITION_CONSTRAINT__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternLink__StoryPatternLinkPositionConstraint__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Link Target Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_PATTERN_LINK___STORY_PATTERN_LINK_TARGET_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryPatternLink__StoryPatternLinkTargetType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.ContainmentLinkImpl <em>Containment Link</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.ContainmentLinkImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getContainmentLink()
		 * @generated
		 */
		EClass CONTAINMENT_LINK = eINSTANCE.getContainmentLink();

		/**
		 * The meta object literal for the '<em><b>Containment Link Source Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation CONTAINMENT_LINK___CONTAINMENT_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getContainmentLink__ContainmentLinkSourceType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.ExpressionLinkImpl <em>Expression Link</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.ExpressionLinkImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getExpressionLink()
		 * @generated
		 */
		EClass EXPRESSION_LINK = eINSTANCE.getExpressionLink();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference EXPRESSION_LINK__EXPRESSION = eINSTANCE
				.getExpressionLink_Expression();

		/**
		 * The meta object literal for the '<em><b>Expression Link Expression</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation EXPRESSION_LINK___EXPRESSION_LINK_EXPRESSION__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getExpressionLink__ExpressionLinkExpression__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.MapEntryLinkImpl <em>Map Entry Link</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.MapEntryLinkImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getMapEntryLink()
		 * @generated
		 */
		EClass MAP_ENTRY_LINK = eINSTANCE.getMapEntryLink();

		/**
		 * The meta object literal for the '<em><b>Feature</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference MAP_ENTRY_LINK__FEATURE = eINSTANCE
				.getMapEntryLink_Feature();

		/**
		 * The meta object literal for the '<em><b>Value Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference MAP_ENTRY_LINK__VALUE_TARGET = eINSTANCE
				.getMapEntryLink_ValueTarget();

		/**
		 * The meta object literal for the '<em><b>Map Entry Link Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MAP_ENTRY_LINK___MAP_ENTRY_LINK_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getMapEntryLink__MapEntryLinkFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Map Entry Link Source Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getMapEntryLink__MapEntryLinkSourceType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Map Entry Link Source Type Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getMapEntryLink__MapEntryLinkSourceTypeFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl <em>Link Order Constraint</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getLinkOrderConstraint()
		 * @generated
		 */
		EClass LINK_ORDER_CONSTRAINT = eINSTANCE.getLinkOrderConstraint();

		/**
		 * The meta object literal for the '<em><b>Constraint Type</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE = eINSTANCE
				.getLinkOrderConstraint_ConstraintType();

		/**
		 * The meta object literal for the '<em><b>Predecessor Link</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK = eINSTANCE
				.getLinkOrderConstraint_PredecessorLink();

		/**
		 * The meta object literal for the '<em><b>Successor Link</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK = eINSTANCE
				.getLinkOrderConstraint_SuccessorLink();

		/**
		 * The meta object literal for the '<em><b>Story Pattern</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference LINK_ORDER_CONSTRAINT__STORY_PATTERN = eINSTANCE
				.getLinkOrderConstraint_StoryPattern();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Predecessor Position</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_POSITION__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintPredecessorPosition__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Successor</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintSuccessor__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Successor Position</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR_POSITION__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintSuccessorPosition__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Predecessor</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintPredecessor__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Predecessor Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintPredecessorFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Link Order Constraint Matching Feature</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_MATCHING_FEATURE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getLinkOrderConstraint__LinkOrderConstraintMatchingFeature__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.ModifierEnum <em>Modifier Enum</em>}' enum.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.ModifierEnum
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getModifierEnum()
		 * @generated
		 */
		EEnum MODIFIER_ENUM = eINSTANCE.getModifierEnum();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.MatchTypeEnum <em>Match Type Enum</em>}' enum.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.MatchTypeEnum
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getMatchTypeEnum()
		 * @generated
		 */
		EEnum MATCH_TYPE_ENUM = eINSTANCE.getMatchTypeEnum();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.BindingTypeEnum <em>Binding Type Enum</em>}' enum.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.BindingTypeEnum
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getBindingTypeEnum()
		 * @generated
		 */
		EEnum BINDING_TYPE_ENUM = eINSTANCE.getBindingTypeEnum();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.LinkPositionConstraintEnum <em>Link Position Constraint Enum</em>}' enum.
		 * <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.LinkPositionConstraintEnum
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getLinkPositionConstraintEnum()
		 * @generated
		 */
		EEnum LINK_POSITION_CONSTRAINT_ENUM = eINSTANCE
				.getLinkPositionConstraintEnum();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlstorypatterns.LinkOrderConstraintEnum <em>Link Order Constraint Enum</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.mdelab.mlstorypatterns.LinkOrderConstraintEnum
		 * @see de.mdelab.mlstorypatterns.impl.MlstorypatternsPackageImpl#getLinkOrderConstraintEnum()
		 * @generated
		 */
		EEnum LINK_ORDER_CONSTRAINT_ENUM = eINSTANCE
				.getLinkOrderConstraintEnum();

	}

} // MlstorypatternsPackage
