package de.mdelab.mlstorypatterns;

import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.ETypedElement;

public class MlstorypatternsUtils {

// DB: Issue 1619: Moved to de.mdelab.mlexpressions

//	private static List<String>	expressionLanguages	= null;
//
//	public static List<String> getAvailableExpressionLanguages()
//	{
//		if (MlstorypatternsUtils.expressionLanguages == null)
//		{
//			MlstorypatternsUtils.expressionLanguages = new ArrayList<String>();
//
//			if (Platform.getExtensionRegistry() != null)
//			{
//				final IConfigurationElement[] configurationElements = Platform.getExtensionRegistry().getConfigurationElementsFor(
//						MlstorypatternsConstants.EXPRESSION_LANGUAGES_EXTENSION_POINT_ID);
//
//				for (final IConfigurationElement configurationElement : configurationElements)
//				{
//					final String s = configurationElement
//							.getAttribute(MlstorypatternsConstants.EXPRESSION_LANGUAGES_EXPRESSION_LANGUAGE_ATTRIBUTE_NAME);
//
//					if (s != null && !"".equals(s))
//					{
//						MlstorypatternsUtils.expressionLanguages.add(s);
//					}
//				}
//			}
//		}
//
//		return MlstorypatternsUtils.expressionLanguages;
//	}

	public static EStructuralFeature getConnectingEStructuralFeature(final EClass srcClass, final EClassifier dstClassifier)
	{
		EList<EClass> typeList;
		if (dstClassifier instanceof EClass)
		{
			typeList = ((EClass) dstClassifier).getEAllSuperTypes();
		}
		else
		{
			typeList = ECollections.emptyEList();
		}

		final EList<EStructuralFeature> featureList = srcClass.getEAllStructuralFeatures();
		EClassifier classifier;
		EStructuralFeature resultFeature = null;
		for (final EStructuralFeature feature : featureList)
		{
			classifier = feature.getEType();
			if (classifier.equals(dstClassifier) || typeList.contains(classifier))
			{
				if (resultFeature == null)
				{
					resultFeature = feature;
				}
				else
				{
					return null;
				}
			}
		}

		return resultFeature;
	}

	public static StoryPatternLink getStoryPatternLinkInCase(final AbstractStoryPatternObject source,
			final AbstractStoryPatternObject target, final EReference reference)
	{
		final StoryPattern san = source.getStoryPattern();

		for (final AbstractStoryPatternLink link : san.getStoryPatternLinks())
		{
			if (link instanceof StoryPatternLink && link.getSource().equals(source) && link.getTarget().equals(target)
					&& ((StoryPatternLink) link).getFeature().equals(reference))
			{
				return (StoryPatternLink) link;
			}

		}

		return null;
	}

	public static EReference getMapTypedEReference(final EClass srcClass, final EClassifier dstClassifier)
	{
		EList<EClass> typeList;
		if (dstClassifier instanceof EClass)
		{
			typeList = ((EClass) dstClassifier).getEAllSuperTypes();
		}
		else
		{
			typeList = ECollections.emptyEList();
		}

		final EList<EReference> refList = srcClass.getEAllReferences();
		EReference resultRef = null;
		EClassifier classifier;

		for (final EReference eReference : refList)
		{
			if (eReference.getEGenericType().getETypeArguments() != null && eReference.getEGenericType().getETypeArguments().size() > 0
					&& eReference.getEGenericType().getETypeArguments().get(0).getEClassifier() != null)
			{
				classifier = eReference.getEGenericType().getETypeArguments().get(0).getEClassifier();
			}
			else
			{
				continue;
			}

			if (eReference.getUpperBound() == ETypedElement.UNBOUNDED_MULTIPLICITY && eReference.isContainment()
					&& eReference.getEType().getInstanceTypeName().equals("java.util.Map$Entry")
					&& (dstClassifier.equals(classifier) || typeList.contains(classifier)))
			{

				if (resultRef == null)
				{
					resultRef = eReference;
				}
				else
				{
					return null;
				}
			}
		}

		return resultRef;
	}
}
