/**
 */
package de.mdelab.mlstorypatterns;

import org.eclipse.emf.common.util.EList;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlexpressions.MLExpression;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Story Pattern</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A StoryPattern contains a graph transformation rule.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternLinks <em>Story Pattern Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternObjects <em>Story Pattern Objects</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPattern#getLinkOrderConstraints <em>Link Order Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPattern#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPattern#getNegativeApplicationConditions <em>Negative Application Conditions</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPattern#getContainingPattern <em>Containing Pattern</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='StoryPatternBoundNode'"
 * @generated
 */
public interface StoryPattern
		extends
			MLElementWithUUID,
			MLAnnotatedElement,
			MLNamedElement {
	/**
	 * Returns the value of the '<em><b>Story Pattern Links</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Story Pattern Links</em>' containment
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Story Pattern Links</em>' containment reference list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern_StoryPatternLinks()
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getStoryPattern
	 * @model opposite="storyPattern" containment="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!storyPatternLinks'"
	 * @generated
	 */
	EList<AbstractStoryPatternLink> getStoryPatternLinks();

	/**
	 * Returns the value of the '<em><b>Story Pattern Objects</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Story Pattern Objects</em>' containment
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Story Pattern Objects</em>' containment reference list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern_StoryPatternObjects()
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getStoryPattern
	 * @model opposite="storyPattern" containment="true" required="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!storyPatternObjects'"
	 * @generated
	 */
	EList<AbstractStoryPatternObject> getStoryPatternObjects();

	/**
	 * Returns the value of the '<em><b>Link Order Constraints</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlstorypatterns.LinkOrderConstraint}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Link Order Constraints</em>' containment
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Link Order Constraints</em>' containment reference list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern_LinkOrderConstraints()
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint#getStoryPattern
	 * @model opposite="storyPattern" containment="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!linkOrderConstraints'"
	 * @generated
	 */
	EList<LinkOrderConstraint> getLinkOrderConstraints();

	/**
	 * Returns the value of the '<em><b>Constraints</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link de.mdelab.mlexpressions.MLExpression}. <!-- begin-user-doc -->
	 * <!-- end-user-doc --> <!-- begin-model-doc --> Additional constraints
	 * that have to be satsified by a valid match. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Constraints</em>' containment reference
	 *         list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern_Constraints()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<MLExpression> getConstraints();

	/**
	 * Returns the value of the '<em><b>Negative Application Conditions</b></em>
	 * ' containment reference list. The list contents are of type
	 * {@link de.mdelab.mlstorypatterns.StoryPattern}. It is bidirectional and
	 * its opposite is '
	 * {@link de.mdelab.mlstorypatterns.StoryPattern#getContainingPattern
	 * <em>Containing Pattern</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * --> <!-- begin-model-doc --> Negative application conditions are story
	 * patterns for which no match may be found, so that the whole story pattern
	 * can be matched. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Negative Application Conditions</em>'
	 *         containment reference list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern_NegativeApplicationConditions()
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getContainingPattern
	 * @model opposite="containingPattern" containment="true" ordered="false"
	 * @generated
	 */
	EList<StoryPattern> getNegativeApplicationConditions();

	/**
	 * Returns the value of the '<em><b>Containing Pattern</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.StoryPattern#getNegativeApplicationConditions <em>Negative Application Conditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Containing Pattern</em>' container reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Containing Pattern</em>' container reference.
	 * @see #setContainingPattern(StoryPattern)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPattern_ContainingPattern()
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getNegativeApplicationConditions
	 * @model opposite="negativeApplicationConditions" resolveProxies="false" transient="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!containingPattern'"
	 * @generated
	 */
	StoryPattern getContainingPattern();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.StoryPattern#getContainingPattern <em>Containing Pattern</em>}' container reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Containing Pattern</em>' container reference.
	 * @see #getContainingPattern()
	 * @generated
	 */
	void setContainingPattern(StoryPattern value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='/**\n *\n * inv StoryPatternNotEmpty:\n *   let\n *     severity : Integer[1] = \'StoryPattern::StoryPatternNotEmpty\'.getSeverity()\n *   in\n *     if severity &lt;= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if not self.storyPatternObjects-&gt;isEmpty()\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else Tuple{message = \'Story pattern \' +\n *               self.toString() + \' may not be empty.\', status = status}\n *           endif\n *       in\n *         \'StoryPattern::StoryPatternNotEmpty\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n \052/\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%&gt;.getExecutor(this);\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.IdResolver%&gt; idResolver = executor.getIdResolver();\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR_StoryPattern_c_c_StoryPatternNotEmpty);\nfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.INT_0).booleanValue();\n/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_3;\nif (le) {\n\tsymbol_3 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt;&gt; storyPatternObjects = this.getStoryPatternObjects();\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; BOXED_storyPatternObjects = idResolver.createSetOfAll(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.SET_CLSSid_AbstractStoryPatternObject, storyPatternObjects);\n\tfinal /*@NonInvalid\052/ boolean isEmpty = &lt;%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%&gt;.INSTANCE.evaluate(BOXED_storyPatternObjects).booleanValue();\n\tfinal /*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; not = &lt;%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%&gt;.INSTANCE.evaluate(isEmpty);\n\tif (not == null) {\n\t\tthrow new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(\"Null if condition\");\n\t}\n\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\tif (not) {\n\t\tstatus = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid\052/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; toString = &lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%&gt;.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; sum = &lt;%org.eclipse.ocl.pivot.library.string.StringConcatOperation%&gt;.INSTANCE.evaluate(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR_Story_32_pattern_32, toString);\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; sum_0 = &lt;%org.eclipse.ocl.pivot.library.string.StringConcatOperation%&gt;.INSTANCE.evaluate(sum, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR__32_may_32_not_32_be_32_empty);\n\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR_StoryPattern_c_c_StoryPatternNotEmpty, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;'"
	 * @generated
	 */
	boolean StoryPatternNotEmpty(DiagnosticChain diagnostics,
			Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='/**\n *\n * inv StoryPatternBoundNode:\n *   let\n *     severity : Integer[1] = \'StoryPattern::StoryPatternBoundNode\'.getSeverity()\n *   in\n *     if severity &lt;= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.containingPattern = null implies\n *             self.storyPatternObjects-&gt;select(e |\n *               e.oclIsKindOf(StoryPatternObject))\n *             -&gt;exists(e |\n *               e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::BOUND or\n *               e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::CAN_BE_BOUND) or\n *             self.storyPatternObjects-&gt;forAll(e | e.modifier = ModifierEnum::CREATE and e.matchType = MatchTypeEnum::DEFAULT)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern \' +\n *               self.toString() + \' must contain at least one bound or only created objects.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPattern::StoryPatternBoundNode\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n \052/\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%&gt;.getExecutor(this);\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.IdResolver%&gt; idResolver = executor.getIdResolver();\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR_StoryPattern_c_c_StoryPatternBoundNode);\nfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.INT_0).booleanValue();\n/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_3;\nif (le) {\n\tsymbol_3 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlstorypatterns.StoryPattern%&gt; containingPattern = this.getContainingPattern();\n\tfinal /*@NonInvalid\052/ boolean eq = containingPattern == null;\n\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt;&gt; storyPatternObjects_0 = this.getStoryPatternObjects();\n\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; BOXED_storyPatternObjects_0 = idResolver.createSetOfAll(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.SET_CLSSid_AbstractStoryPatternObject, storyPatternObjects_0);\n\t\t/*@Caught\052/ /*@Nullable\052/ &lt;%java.lang.Object%&gt; CAUGHT_exists;\n\t\ttry {\n\t\t\t/*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt;.Accumulator accumulator = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createSetAccumulatorValue(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.SET_CLSSid_AbstractStoryPatternObject);\n\t\t\t/*@NonNull\052/ &lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_e_0 = BOXED_storyPatternObjects_0.iterator();\n\t\t\t/*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; select;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\tselect = accumulator;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt; e_0 = (&lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt;)ITERATOR_e_0.next();\n\t\t\t\t/**\n\t\t\t\t * e.oclIsKindOf(StoryPatternObject)\n\t\t\t\t \052/\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.Class%&gt; TYP_mlstorypatterns_c_c_StoryPatternObject = idResolver.getClass(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.CLSSid_StoryPatternObject, null);\n\t\t\t\tfinal /*@NonInvalid\052/ boolean oclIsKindOf = &lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%&gt;.INSTANCE.evaluate(executor, e_0, TYP_mlstorypatterns_c_c_StoryPatternObject).booleanValue();\n\t\t\t\t//\n\t\t\t\tif (oclIsKindOf == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\taccumulator.add(e_0);\n\t\t\t\t}\n\t\t\t}\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t/*@NonNull\052/ &lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_e_1 = select.iterator();\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; exists;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\tif (accumulator_0 == null) {\n\t\t\t\t\t\texists = null;\n\t\t\t\t\t}\n\t\t\t\t\telse if (accumulator_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\texists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator_0;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt; e_1 = (&lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt;)ITERATOR_e_1.next();\n\t\t\t\t/**\n\t\t\t\t *\n\t\t\t\t * e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::BOUND or\n\t\t\t\t * e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::CAN_BE_BOUND\n\t\t\t\t \052/\n\t\t\t\t/*@Caught\052/ /*@Nullable\052/ &lt;%java.lang.Object%&gt; CAUGHT_or;\n\t\t\t\ttry {\n\t\t\t\t\t/*@Caught\052/ /*@NonNull\052/ &lt;%java.lang.Object%&gt; CAUGHT_eq_0;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.Class%&gt; TYP_mlstorypatterns_c_c_StoryPatternObject_0 = idResolver.getClass(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.CLSSid_StoryPatternObject, null);\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%de.mdelab.mlstorypatterns.StoryPatternObject%&gt; oclAsType = &lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState((&lt;%de.mdelab.mlstorypatterns.StoryPatternObject%&gt;)&lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%&gt;.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternObject_0));\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%de.mdelab.mlstorypatterns.BindingTypeEnum%&gt; bindingType = oclAsType.getBindingType();\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_bindingType = &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ENUMid_BindingTypeEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(bindingType.getName()));\n\t\t\t\t\t\tfinal /*@Thrown\052/ boolean eq_0 = BOXED_bindingType == &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ELITid_BOUND;\n\t\t\t\t\t\tCAUGHT_eq_0 = eq_0;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\t\tCAUGHT_eq_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\t/*@Caught\052/ /*@NonNull\052/ &lt;%java.lang.Object%&gt; CAUGHT_eq_1;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.Class%&gt; TYP_mlstorypatterns_c_c_StoryPatternObject_1 = idResolver.getClass(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.CLSSid_StoryPatternObject, null);\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%de.mdelab.mlstorypatterns.StoryPatternObject%&gt; oclAsType_0 = &lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState((&lt;%de.mdelab.mlstorypatterns.StoryPatternObject%&gt;)&lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%&gt;.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternObject_1));\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%de.mdelab.mlstorypatterns.BindingTypeEnum%&gt; bindingType_0 = oclAsType_0.getBindingType();\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_bindingType_0 = &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ENUMid_BindingTypeEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(bindingType_0.getName()));\n\t\t\t\t\t\tfinal /*@Thrown\052/ boolean eq_1 = BOXED_bindingType_0 == &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ELITid_CAN_BE_BOUND;\n\t\t\t\t\t\tCAUGHT_eq_1 = eq_1;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\t\tCAUGHT_eq_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown\052/ &lt;%java.lang.Boolean%&gt; or = &lt;%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%&gt;.INSTANCE.evaluate(CAUGHT_eq_0, CAUGHT_eq_1);\n\t\t\t\t\tCAUGHT_or = or;\n\t\t\t\t}\n\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\tCAUGHT_or = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\t//\n\t\t\t\tif (CAUGHT_or == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\texists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_or == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_or == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\tif (accumulator_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\taccumulator_0 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_or instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\taccumulator_0 = CAUGHT_or;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator_0 = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"exists\");\n\t\t\t\t}\n\t\t\t}\n\t\t\tCAUGHT_exists = exists;\n\t\t}\n\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\tCAUGHT_exists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t}\n\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t/*@NonNull\052/ &lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_e_2 = BOXED_storyPatternObjects_0.iterator();\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; forAll;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_2.hasNext()) {\n\t\t\t\tif (accumulator_1 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\tforAll = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator_1;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt; e_2 = (&lt;%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%&gt;)ITERATOR_e_2.next();\n\t\t\t/**\n\t\t\t * e.modifier = ModifierEnum::CREATE and e.matchType = MatchTypeEnum::DEFAULT\n\t\t\t \052/\n\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlstorypatterns.ModifierEnum%&gt; modifier = e_2.getModifier();\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_modifier = &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ENUMid_ModifierEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(modifier.getName()));\n\t\t\tfinal /*@NonInvalid\052/ boolean eq_2 = BOXED_modifier == &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ELITid_CREATE;\n\t\t\t/*@NonInvalid\052/ boolean and;\n\t\t\tif (eq_2) {\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlstorypatterns.MatchTypeEnum%&gt; matchType = e_2.getMatchType();\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_matchType = &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ENUMid_MatchTypeEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(matchType.getName()));\n\t\t\t\tfinal /*@NonInvalid\052/ boolean eq_3 = BOXED_matchType == &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.ELITid_DEFAULT;\n\t\t\t\tand = eq_3;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t}\n\t\t\t//\n\t\t\tif (and == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\tforAll = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (and == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator_1 = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"forAll\");\n\t\t\t}\n\t\t}\n\t\tfinal /*@Thrown\052/ &lt;%java.lang.Boolean%&gt; or_0 = &lt;%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%&gt;.INSTANCE.evaluate(CAUGHT_exists, forAll);\n\t\timplies = or_0;\n\t}\n\telse {\n\t\timplies = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t}\n\tif (implies == null) {\n\t\tthrow new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(\"Null if condition\");\n\t}\n\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\tif (implies) {\n\t\tstatus = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid\052/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; toString = &lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%&gt;.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; sum = &lt;%org.eclipse.ocl.pivot.library.string.StringConcatOperation%&gt;.INSTANCE.evaluate(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR_Story_32_pattern_32, toString);\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; sum_0 = &lt;%org.eclipse.ocl.pivot.library.string.StringConcatOperation%&gt;.INSTANCE.evaluate(sum, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR__32_must_32_contain_32_at_32_least_32_one_32_bound_32_or_32_only_32_created_32_objects);\n\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.STR_StoryPattern_c_c_StoryPatternBoundNode, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, &lt;%de.mdelab.mlstorypatterns.MlstorypatternsTables%&gt;.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;'"
	 * @generated
	 */
	boolean StoryPatternBoundNode(DiagnosticChain diagnostics,
			Map<Object, Object> context);

} // StoryPattern
