package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel4EditPart;

public class CustomLinkPositionConstraintLabelEditPart extends WrappingLabel4EditPart
{

	public CustomLinkPositionConstraintLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		if (event.getNotifier() instanceof StoryPatternLink)
		{
			adaptColorAndLabelText();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColorAndLabelText();
	}

	protected void adaptColorAndLabelText()
	{
		EditPartUtil.adaptColor(getFigure(), ((StoryPatternElement) ((View) getModel()).getElement()).getModifier());

		StoryPatternLink link = (StoryPatternLink) ((View) getModel()).getElement();

		String string = "";

		if (link.getLinkPositionConstraint() != null)
		{
			switch (link.getLinkPositionConstraint())
			{
				case FIRST:
				{
					string = "{first}";
					break;
				}
				case LAST:
				{
					string = "{last}";
					break;
				}
				default:
				{
					//throw new UnsupportedOperationException();
				}
			}
		}
		setLabelText(string);
	}
}
