package de.mdelab.mlstorypatterns.diagram.custom.edit.parts; 

import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlstorypatterns.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MlstorypatternsEditPartFactory;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectNameEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel2EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel3EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel4EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel6EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel7EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel8EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabelEditPart;
import de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry;

public class CustomMlstorypatternsEditPartFactory extends MlstorypatternsEditPartFactory
{

	@Override
	public EditPart createEditPart(EditPart context, Object model)
	{
		if (model instanceof View)
		{
			View view = (View) model;
			switch (MlstorypatternsVisualIDRegistry.getVisualID(view))
			{
			case AttributeAssignmentEditPart.VISUAL_ID:
				return new CustomAttributeAssignmentEditPart(view);
				
			case MLStringExpressionEditPart.VISUAL_ID:
				return new CustomMLStringExpressionEditPart(view);

			/*	case CallActionExpressionEditPart.VISUAL_ID:
					return new CustomCallActionExpressionEditPart(view);

				case CallActionExpression2EditPart.VISUAL_ID:
					return new CustomCallActionExpression2EditPart(view);

				case CallActionExpression3EditPart.VISUAL_ID:
					return new CustomCallActionExpression3EditPart(view);*/


				case LinkOrderConstraintEditPart.VISUAL_ID:
					return new CustomLinkOrderConstraintLabelEditPart(view);

				case ContainmentLinkEditPart.VISUAL_ID:
					return new CustomStoryPatternContainmentLinkEditPart(view);

				case StoryPatternLinkEditPart.VISUAL_ID:
					return new CustomStoryPatternLinkEditPart(view);

				case WrappingLabel3EditPart.VISUAL_ID:
					return new CustomStoryPatternLinkFeatureNameLabelEditPart(view);

				case WrappingLabel4EditPart.VISUAL_ID:
					return new CustomLinkPositionConstraintLabelEditPart(view);

				//case StoryPatternObjectEditPart.VISUAL_ID:
					//return new CustomStoryPatternObjectEditPart(view);

				case StoryPatternObjectNameEditPart.VISUAL_ID:
					return new CustomStoryPatternObjectNameLabelEditPart(view);

				case WrappingLabelEditPart.VISUAL_ID:
					return new CustomStoryPatternObjectModifierLabelEditPart(view);
			//	case WrappingLabelEditPart.VISUAL_ID:
			//		return new CustomExpressionLabelEditPart(view);

				case WrappingLabel2EditPart.VISUAL_ID:
					return new CustomStoryPatternObjectClassifierLabelEditPart(view);

				//case StoryPatternLinkEditPart.VISUAL_ID:
				//	return new CustomStoryPatternExpressionLinkEditPart(view);

				case ExpressionLinkEditPart.VISUAL_ID:
					return new CustomExpressionLinkEditPart(view);
					
				case MapEntryLinkEditPart.VISUAL_ID:
					return new CustomMapEntryLinkEditPart(view);

				case WrappingLabel6EditPart.VISUAL_ID:
					return new CustomMapEntryLinkFeatureNameLabelEditPart(view);

				case MapEntryLinkValueTargetEditPart.VISUAL_ID:
					return new CustomMapEntryLinkValueTargetEditPart(view);

				case WrappingLabel7EditPart.VISUAL_ID:
					return new CustomMapEntryLinkKeyLabelEditPart(view);

				case WrappingLabel8EditPart.VISUAL_ID:
					return new CustomMapEntryLinkValueLinkLabelEditPart(view);


			}
		}
		return super.createEditPart(context, model);
	}
}
