package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;

import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.diagram.custom.figures.CrossFigure;

public class EditPartUtil {

	public static void adaptColor(	final IFigure figure, 
									final ModifierEnum spMod ) {
		switch (spMod) {
			case CREATE: {
				figure.setForegroundColor(MlstorypatternsDiagramConstants.MODIFIER_CREATE_COLOR);
				break;
			}
			case DESTROY: {
				figure.setForegroundColor(MlstorypatternsDiagramConstants.MODIFIER_DESTROY_COLOR);
				break;
			}
			case NONE: {
				figure.setForegroundColor(MlstorypatternsDiagramConstants.MODIFIER_NONE_COLOR);
				break;
			}
			default: {
				figure.setForegroundColor(MlstorypatternsDiagramConstants.MODIFIER_NONE_COLOR);
				break;
			}
		}
	}

	public static void adaptLineStyle(	final PolylineConnectionEx figure, 
										final MatchTypeEnum spMatch ) {
		for ( final Object o : figure.getChildren() ) {
			if (o instanceof CrossFigure) {
				figure.getChildren().remove(o);
				break;
			}
		}

		switch (spMatch)
		{
		/*	case NONE:
			{
				figure.setLineStyle(SWT.LINE_SOLID);
				break;
			}*/
			case OPTIONAL:
			{
				figure.setLineStyle(SWT.LINE_CUSTOM);
				figure.setLineDash(new int[]
				{
						15, 10
				});
				break;
			}
	/*		case NEGATIVE:
			{
				CrossFigure crossFigure = new CrossFigure();

				Dimension size = new Dimension(20, 20);
				crossFigure.setMinimumSize(size);
				crossFigure.setMaximumSize(size);
				crossFigure.setPreferredSize(size);

				figure.add(crossFigure, new ConnectionLocator(figure, ConnectionLocator.MIDDLE));
			}*/
			default:
			{
				figure.setLineStyle(SWT.LINE_SOLID);
				break;
			}
		}
	}

	public static String adaptStoryPatternElementModifierText(	final IGraphicalEditPart editPart )	{
		final StoryPatternElement spo = (StoryPatternElement) ((View) editPart.getModel()).getElement();

		switch (spo.getModifier()) {
			case CREATE: {
				return "<<create>>";
			}
			case DESTROY: {
				return "<<destroy>>";
			}
			default: {
				return "";
			}
		}
	}

	/**
	 * DB: Issue #1802 Generalized parameter to EObject
	 * @param nElem
	 * @return
	 */
	public static String getFilterId( EObject nElem ) {
		return nElem.eClass().getName() + ": ";
	}
}
