/**
 */
package de.mdelab.mlstorypatterns.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Abstract Story Pattern Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl#getSource <em>Source</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractStoryPatternLinkImpl
		extends
			StoryPatternElementImpl
		implements
			AbstractStoryPatternLink {
	/**
	 * The cached value of the '{@link #getSource() <em>Source</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
	protected AbstractStoryPatternObject source;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected AbstractStoryPatternObject target;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractStoryPatternLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.ABSTRACT_STORY_PATTERN_LINK;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AbstractStoryPatternObject getSource() {
		return source;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSource(
			AbstractStoryPatternObject newSource, NotificationChain msgs) {
		AbstractStoryPatternObject oldSource = source;
		source = newSource;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE,
					oldSource, newSource);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSource(AbstractStoryPatternObject newSource) {
		if (newSource != source) {
			NotificationChain msgs = null;
			if (source != null)
				msgs = ((InternalEObject) source).eInverseRemove(this,
						MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
						AbstractStoryPatternObject.class, msgs);
			if (newSource != null)
				msgs = ((InternalEObject) newSource).eInverseAdd(this,
						MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
						AbstractStoryPatternObject.class, msgs);
			msgs = basicSetSource(newSource, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE,
					newSource, newSource));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AbstractStoryPatternObject getTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTarget(
			AbstractStoryPatternObject newTarget, NotificationChain msgs) {
		AbstractStoryPatternObject oldTarget = target;
		target = newTarget;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET,
					oldTarget, newTarget);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTarget(AbstractStoryPatternObject newTarget) {
		if (newTarget != target) {
			NotificationChain msgs = null;
			if (target != null)
				msgs = ((InternalEObject) target).eInverseRemove(this,
						MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
						AbstractStoryPatternObject.class, msgs);
			if (newTarget != null)
				msgs = ((InternalEObject) newTarget).eInverseAdd(this,
						MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
						AbstractStoryPatternObject.class, msgs);
			msgs = basicSetTarget(newTarget, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET,
					newTarget, newTarget));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newStoryPattern,
				MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN
						&& newStoryPattern != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern).eInverseAdd(this,
						MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS,
						StoryPattern.class, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN,
					newStoryPattern, newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkNACModifier(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkNACModifier:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkNACModifier'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.storyPattern.containingPattern <> null implies self.modifier = ModifierEnum::NONE
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern link ' +
		 *               self.toString() + ' in a NAC may not be modified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkNACModifier'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkNACModifier);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPattern storyPattern = this
					.getStoryPattern();
			final /*@NonInvalid*/ StoryPattern containingPattern = storyPattern
					.getContainingPattern();
			final /*@NonInvalid*/ boolean ne = containingPattern != null;
			/*@NonInvalid*/ boolean implies;
			if (ne) {
				final /*@NonInvalid*/ ModifierEnum modifier = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_NONE;
				implies = eq;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_in_32_a_32_NAC_32_may_32_not_32_be_32_modified);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkNACModifier,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkSource(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkSource:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkSource'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Source of story pattern link ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkSource'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSource);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSource,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkSourceDestroyed(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkSourceDestroyed:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceDestroyed'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.source.modifier = ModifierEnum::DESTROY implies self.modifier = ModifierEnum::DESTROY
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern link ' +
		 *               self.toString() + ' must be destroyed because its source is destroyed.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceDestroyed'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceDestroye);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject source = this
					.getSource();
			final /*@NonInvalid*/ ModifierEnum modifier = source.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_DESTROY;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ ModifierEnum modifier_0 = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier_0 = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier_0.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == MlstorypatternsTables.ELITid_DESTROY;
				implies = eq_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_destroyed_32_because_32_its_32_source_32_is_32_destroyed);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceDestroye,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkTarget(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkTarget:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkTarget'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.target <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Target of story pattern link ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkTarget'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTarget);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTarget,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkSourceCreated(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkSourceCreated:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceCreated'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.source.modifier = ModifierEnum::CREATE implies self.modifier = ModifierEnum::CREATE
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern link ' +
		 *               self.toString() + ' must be created because its source is created.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceCreated'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceCreated);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject source = this
					.getSource();
			final /*@NonInvalid*/ ModifierEnum modifier = source.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_CREATE;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ ModifierEnum modifier_0 = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier_0 = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier_0.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == MlstorypatternsTables.ELITid_CREATE;
				implies = eq_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_created_32_because_32_its_32_source_32_is_32_created);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceCreated,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkSourceTargetPattern(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkSourceTargetPattern:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceTargetPattern'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.target <> null implies
		 *             (self.source.storyPattern = self.storyPattern or self.source.storyPattern = self.storyPattern.containingPattern
		 *             ) and
		 *             (self.target.storyPattern = self.storyPattern or self.target.storyPattern = self.storyPattern.containingPattern
		 *             )
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Source and target of story pattern link ' +
		 *               self.toString() + ' must reside in the same story pattern or its containing pattern.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceTargetPattern'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceTargetPa);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject source_0 = this
					.getSource();
			final /*@NonInvalid*/ StoryPattern storyPattern_0 = this
					.getStoryPattern();
			final /*@NonInvalid*/ StoryPattern storyPattern_1 = source_0
					.getStoryPattern();
			final /*@NonInvalid*/ boolean eq = storyPattern_1
					.equals(storyPattern_0);
			/*@NonInvalid*/ boolean or;
			if (eq) {
				or = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ StoryPattern containingPattern = storyPattern_0
						.getContainingPattern();
				final /*@NonInvalid*/ boolean eq_0 = storyPattern_1
						.equals(containingPattern);
				or = eq_0;
			}
			/*@NonInvalid*/ boolean and;
			if (or) {
				final /*@NonInvalid*/ AbstractStoryPatternObject target_0 = this
						.getTarget();
				final /*@NonInvalid*/ StoryPattern storyPattern_5 = target_0
						.getStoryPattern();
				final /*@NonInvalid*/ boolean eq_1 = storyPattern_5
						.equals(storyPattern_0);
				/*@NonInvalid*/ boolean or_0;
				if (eq_1) {
					or_0 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ StoryPattern containingPattern_0 = storyPattern_0
							.getContainingPattern();
					final /*@NonInvalid*/ boolean eq_2 = storyPattern_5
							.equals(containingPattern_0);
					or_0 = eq_2;
				}
				and = or_0;
			} else {
				and = ValueUtil.FALSE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (and) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Source_32_and_32_target_32_of_32_story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_reside_32_in_32_the_32_same_32_story_32_pattern_32_or_32_its_32_containing_32_pattern);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceTargetPa,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkTargetDestroyed(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkTargetDestroyed:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetDestroyed'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.target <> null and self.target.modifier = ModifierEnum::DESTROY implies self.modifier = ModifierEnum::DESTROY
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern link ' +
		 *               self.toString() + ' must be destroyed because its target is destroyed.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetDestroyed'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetDestroye);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject target = this
					.getTarget();
			final /*@NonInvalid*/ ModifierEnum modifier = target.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_DESTROY;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ ModifierEnum modifier_0 = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier_0 = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier_0.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == MlstorypatternsTables.ELITid_DESTROY;
				implies = eq_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_destroyed_32_because_32_its_32_target_32_is_32_destroyed);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetDestroye,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternLinkTargetCreated(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternLinkTargetCreated:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetCreated'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.target <> null and self.target.modifier = ModifierEnum::CREATE implies self.modifier = ModifierEnum::CREATE
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern link ' +
		 *               self.toString() + ' must be created because its target is created.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetCreated'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetCreated);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject target = this
					.getTarget();
			final /*@NonInvalid*/ ModifierEnum modifier = target.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_CREATE;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ ModifierEnum modifier_0 = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier_0 = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier_0.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == MlstorypatternsTables.ELITid_CREATE;
				implies = eq_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_created_32_because_32_its_32_target_32_is_32_created);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetCreated,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE :
				if (source != null)
					msgs = ((InternalEObject) source).eInverseRemove(this,
							MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
							AbstractStoryPatternObject.class, msgs);
				return basicSetSource((AbstractStoryPatternObject) otherEnd,
						msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET :
				if (target != null)
					msgs = ((InternalEObject) target).eInverseRemove(this,
							MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
							AbstractStoryPatternObject.class, msgs);
				return basicSetTarget((AbstractStoryPatternObject) otherEnd,
						msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStoryPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE :
				return basicSetSource(null, msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET :
				return basicSetTarget(null, msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				return eInternalContainer().eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS,
						StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE :
				return getSource();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET :
				return getTarget();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				return getStoryPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE :
				setSource((AbstractStoryPatternObject) newValue);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET :
				setTarget((AbstractStoryPatternObject) newValue);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				setStoryPattern((StoryPattern) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE :
				setSource((AbstractStoryPatternObject) null);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET :
				setTarget((AbstractStoryPatternObject) null);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				setStoryPattern((StoryPattern) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE :
				return source != null;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET :
				return target != null;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN :
				return getStoryPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkNACModifier(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkSource(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkSourceDestroyed(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkTarget(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkSourceCreated(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkSourceTargetPattern(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkTargetDestroyed(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternLinkTargetCreated(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // AbstractStoryPatternLinkImpl
