/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanAndOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanNotOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Abstract Story Pattern Object</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getType <em>Type</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getOutgoingLinks <em>Outgoing Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getIncomingLinks <em>Incoming Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractStoryPatternObjectImpl
		extends
			StoryPatternElementImpl
		implements
			AbstractStoryPatternObject {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected EClassifier type;

	/**
	 * The cached value of the '{@link #getOutgoingLinks() <em>Outgoing Links</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getOutgoingLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternLink> outgoingLinks;

	/**
	 * The cached value of the '{@link #getIncomingLinks() <em>Incoming Links</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getIncomingLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternLink> incomingLinks;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractStoryPatternObjectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.ABSTRACT_STORY_PATTERN_OBJECT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME,
					oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClassifier getType() {
		if (type != null && type.eIsProxy()) {
			InternalEObject oldType = (InternalEObject) type;
			type = (EClassifier) eResolveProxy(oldType);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE,
							oldType, type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EClassifier basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setType(EClassifier newType) {
		EClassifier oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE,
					oldType, type));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternLink> getOutgoingLinks() {
		if (outgoingLinks == null) {
			outgoingLinks = new EObjectWithInverseEList<AbstractStoryPatternLink>(
					AbstractStoryPatternLink.class, this,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE);
		}
		return outgoingLinks;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternLink> getIncomingLinks() {
		if (incomingLinks == null) {
			incomingLinks = new EObjectWithInverseEList<AbstractStoryPatternLink>(
					AbstractStoryPatternLink.class, this,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET);
		}
		return incomingLinks;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newStoryPattern,
				MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN
						&& newStoryPattern != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern).eInverseAdd(this,
						MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS,
						StoryPattern.class, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN,
					newStoryPattern, newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternObjectType(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternObjectType:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternObject::AbstractStoryPatternObjectType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.type <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ' must have a type.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternObject::AbstractStoryPatternObjectType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ EClassifier type = this.getType();
			final /*@NonInvalid*/ boolean ne = type != null;
			/*@NonInvalid*/ Boolean status;
			if (ne) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_have_32_a_32_type);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternObjectUniqueName(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternObjectUniqueName:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternObject::AbstractStoryPatternObjectUniqueName'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if
		 *             self.storyPattern.storyPatternObjects->select(e | e.name = self.name)
		 *             ->size() = 1
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Name of story pattern object ' +
		 *               self.toString() + ' must be unique.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternObject::AbstractStoryPatternObjectUniqueName'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectUniqueName);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPattern storyPattern = this
					.getStoryPattern();
			final /*@NonInvalid*/ List<AbstractStoryPatternObject> storyPatternObjects = storyPattern
					.getStoryPatternObjects();
			final /*@NonInvalid*/ SetValue BOXED_storyPatternObjects = idResolver
					.createSetOfAll(
							MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternObject,
							storyPatternObjects);
			/*@Thrown*/ SetValue.Accumulator accumulator = ValueUtil
					.createSetAccumulatorValue(
							MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternObject);
			/*@NonNull*/ Iterator<Object> ITERATOR_e_0 = BOXED_storyPatternObjects
					.iterator();
			/*@NonInvalid*/ SetValue select;
			while (true) {
				if (!ITERATOR_e_0.hasNext()) {
					select = accumulator;
					break;
				}
				/*@NonInvalid*/ AbstractStoryPatternObject e_0 = (AbstractStoryPatternObject) ITERATOR_e_0
						.next();
				/**
				 * e.name = self.name
				 */
				final /*@NonInvalid*/ String name = e_0.getName();
				final /*@NonInvalid*/ String name_0 = this.getName();
				final /*@NonInvalid*/ boolean eq = (name != null)
						? name.equals(name_0)
						: (name_0 == null);
				//
				if (eq == ValueUtil.TRUE_VALUE) {
					accumulator.add(e_0);
				}
			}
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(select);
			final /*@NonInvalid*/ boolean eq_0 = size
					.equals(MlstorypatternsTables.INT_1);
			/*@NonInvalid*/ Boolean status;
			if (eq_0) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Name_32_of_32_story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_unique);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectUniqueName,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternObjectName(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternObjectName:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternObject::AbstractStoryPatternObjectName'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.name <> null and self.name <> ''
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ' must have a name.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternObject::AbstractStoryPatternObjectName'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectName);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ String name_0 = this.getName();
			final /*@NonInvalid*/ boolean ne = name_0 != null;
			/*@NonInvalid*/ boolean and;
			if (ne) {
				final /*@NonInvalid*/ boolean ne_0 = !MlstorypatternsTables.STR_
						.equals(name_0);
				and = ne_0;
			} else {
				and = ValueUtil.FALSE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (and) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_have_32_a_32_name);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectName,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternObjectAbstractType(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternObjectAbstractType:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternObject::AbstractStoryPatternObjectAbstractType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.type <> null and
		 *             self.type.oclIsKindOf(ecore::EClass) and self.modifier = ModifierEnum::CREATE implies
		 *             not self.type.oclAsType(ecore::EClass).abstract
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Created story pattern object ' +
		 *               self.toString() + ' must not have an abstract type.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternObject::AbstractStoryPatternObjectAbstractType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectAbstractTy);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_4;
		if (le) {
			symbol_4 = ValueUtil.TRUE_VALUE;
		} else {
			/*@Caught*/ /*@Nullable*/ Object CAUGHT_and_0;
			try {
				/*@Caught*/ /*@NonNull*/ Object CAUGHT_and;
				try {
					final /*@NonInvalid*/ EClassifier type_0 = this.getType();
					final /*@NonInvalid*/ boolean ne = type_0 != null;
					/*@Thrown*/ boolean and;
					if (ne) {
						final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass = idResolver
								.getClass(MlstorypatternsTables.CLSSid_EClass,
										null);
						final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
								.evaluate(executor, type_0,
										TYP_ecore_c_c_EClass)
								.booleanValue();
						and = oclIsKindOf;
					} else {
						and = ValueUtil.FALSE_VALUE;
					}
					CAUGHT_and = and;
				} catch (Exception e) {
					CAUGHT_and = ValueUtil.createInvalidValue(e);
				}
				final /*@NonInvalid*/ ModifierEnum modifier = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_CREATE;
				final /*@Thrown*/ Boolean and_0 = BooleanAndOperation.INSTANCE
						.evaluate(CAUGHT_and, eq);
				CAUGHT_and_0 = and_0;
			} catch (Exception e) {
				CAUGHT_and_0 = ValueUtil.createInvalidValue(e);
			}
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_symbol_0;
			try {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EClass, null);
				final /*@NonInvalid*/ EClassifier type_1 = this.getType();
				final /*@Thrown*/ EClass oclAsType = ClassUtil.nonNullState(
						(EClass) OclAnyOclAsTypeOperation.INSTANCE.evaluate(
								executor, type_1, TYP_ecore_c_c_EClass_0));
				final /*@Thrown*/ boolean symbol_0 = oclAsType.isAbstract();
				CAUGHT_symbol_0 = symbol_0;
			} catch (Exception e) {
				CAUGHT_symbol_0 = ValueUtil.createInvalidValue(e);
			}
			final /*@NonInvalid*/ Boolean not = BooleanNotOperation.INSTANCE
					.evaluate(CAUGHT_symbol_0);
			final /*@Thrown*/ Boolean implies = BooleanImpliesOperation.INSTANCE
					.evaluate(CAUGHT_and_0, not);
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_1 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_3;
			if (symbol_1) {
				symbol_3 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Created_32_story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_not_32_have_32_an_32_abstract_32_type);
				final /*@NonInvalid*/ TupleValue symbol_2 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_3 = symbol_2;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectAbstractTy,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_3,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_4 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_4;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AbstractStoryPatternObjectNACModified(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AbstractStoryPatternObjectNACModified:
		 *   let
		 *     severity : Integer[1] = 'AbstractStoryPatternObject::AbstractStoryPatternObjectNACModified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.storyPattern.containingPattern <> null implies self.modifier = ModifierEnum::NONE
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ' in NAC must not be modified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AbstractStoryPatternObject::AbstractStoryPatternObjectNACModified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectNACModifie);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPattern storyPattern = this
					.getStoryPattern();
			final /*@NonInvalid*/ StoryPattern containingPattern = storyPattern
					.getContainingPattern();
			final /*@NonInvalid*/ boolean ne = containingPattern != null;
			/*@NonInvalid*/ boolean implies;
			if (ne) {
				final /*@NonInvalid*/ ModifierEnum modifier = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_NONE;
				implies = eq;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_in_32_NAC_32_must_32_not_32_be_32_modified);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectNACModifie,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoingLinks())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncomingLinks())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStoryPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
				return ((InternalEList<?>) getOutgoingLinks())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
				return ((InternalEList<?>) getIncomingLinks())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				return eInternalContainer().eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS,
						StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME :
				return getName();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE :
				if (resolve)
					return getType();
				return basicGetType();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
				return getOutgoingLinks();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
				return getIncomingLinks();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				return getStoryPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME :
				setName((String) newValue);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE :
				setType((EClassifier) newValue);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
				getOutgoingLinks().clear();
				getOutgoingLinks().addAll(
						(Collection<? extends AbstractStoryPatternLink>) newValue);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
				getIncomingLinks().clear();
				getIncomingLinks().addAll(
						(Collection<? extends AbstractStoryPatternLink>) newValue);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				setStoryPattern((StoryPattern) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME :
				setName(NAME_EDEFAULT);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE :
				setType((EClassifier) null);
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
				getOutgoingLinks().clear();
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
				getIncomingLinks().clear();
				return;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				setStoryPattern((StoryPattern) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME :
				return NAME_EDEFAULT == null
						? name != null
						: !NAME_EDEFAULT.equals(name);
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE :
				return type != null;
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
				return outgoingLinks != null && !outgoingLinks.isEmpty();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
				return incomingLinks != null && !incomingLinks.isEmpty();
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				return getStoryPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME :
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default :
					return -1;
			}
		}
		if (baseClass == MLTypedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE :
					return MlcorePackage.ML_TYPED_ELEMENT__TYPE;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_NAMED_ELEMENT__NAME :
					return MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME;
				default :
					return -1;
			}
		}
		if (baseClass == MLTypedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_TYPED_ELEMENT__TYPE :
					return MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_TYPE__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternObjectType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_UNIQUE_NAME__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternObjectUniqueName(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAME__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternObjectName(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_ABSTRACT_TYPE__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternObjectAbstractType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAC_MODIFIED__DIAGNOSTICCHAIN_MAP :
				return AbstractStoryPatternObjectNACModified(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // AbstractStoryPatternObjectImpl
