/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Attribute Assignment</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getStoryPatternObject <em>Story Pattern Object</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getAssignmentExpression <em>Assignment Expression</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getFeature <em>Feature</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AttributeAssignmentImpl extends MLElementWithUUIDImpl
		implements
			AttributeAssignment {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The cached value of the '{@link #getAssignmentExpression()
	 * <em>Assignment Expression</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssignmentExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression assignmentExpression;

	/**
	 * The cached value of the '{@link #getFeature() <em>Feature</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFeature()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature feature;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AttributeAssignmentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternObject getStoryPatternObject() {
		if (eContainerFeatureID() != MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT)
			return null;
		return (StoryPatternObject) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPatternObject(
			StoryPatternObject newStoryPatternObject, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newStoryPatternObject,
				MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPatternObject(
			StoryPatternObject newStoryPatternObject) {
		if (newStoryPatternObject != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT
						&& newStoryPatternObject != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPatternObject))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPatternObject != null)
				msgs = ((InternalEObject) newStoryPatternObject).eInverseAdd(
						this,
						MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
						StoryPatternObject.class, msgs);
			msgs = basicSetStoryPatternObject(newStoryPatternObject, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT,
					newStoryPatternObject, newStoryPatternObject));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getAssignmentExpression() {
		return assignmentExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAssignmentExpression(
			MLExpression newAssignmentExpression, NotificationChain msgs) {
		MLExpression oldAssignmentExpression = assignmentExpression;
		assignmentExpression = newAssignmentExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
					oldAssignmentExpression, newAssignmentExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAssignmentExpression(MLExpression newAssignmentExpression) {
		if (newAssignmentExpression != assignmentExpression) {
			NotificationChain msgs = null;
			if (assignmentExpression != null)
				msgs = ((InternalEObject) assignmentExpression).eInverseRemove(
						this,
						EOPPOSITE_FEATURE_BASE
								- MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
						null, msgs);
			if (newAssignmentExpression != null)
				msgs = ((InternalEObject) newAssignmentExpression).eInverseAdd(
						this,
						EOPPOSITE_FEATURE_BASE
								- MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
						null, msgs);
			msgs = basicSetAssignmentExpression(newAssignmentExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
					newAssignmentExpression, newAssignmentExpression));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EStructuralFeature getFeature() {
		if (feature != null && feature.eIsProxy()) {
			InternalEObject oldFeature = (InternalEObject) feature;
			feature = (EStructuralFeature) eResolveProxy(oldFeature);
			if (feature != oldFeature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE,
							oldFeature, feature));
			}
		}
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EStructuralFeature basicGetFeature() {
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFeature(EStructuralFeature newFeature) {
		EStructuralFeature oldFeature = feature;
		feature = newFeature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE,
					oldFeature, feature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AttributeAssignmentFeature(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AttributeAssignmentFeature:
		 *   let
		 *     severity : Integer[1] = 'AttributeAssignment::AttributeAssignmentFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.feature <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Feature of attribute assignment ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AttributeAssignment::AttributeAssignmentFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AttributeAssignment_c_c_AttributeAssignmentFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AttributeAssignment_c_c_AttributeAssignmentFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AttributeAssignmentExpression(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AttributeAssignmentExpression:
		 *   let
		 *     severity : Integer[1] = 'AttributeAssignment::AttributeAssignmentExpression'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.assignmentExpression <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Assignment expression of attribute assignment ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AttributeAssignment::AttributeAssignmentExpression'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AttributeAssignment_c_c_AttributeAssignmentExpression);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AttributeAssignment_c_c_AttributeAssignmentExpression,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean AttributeAssignmentType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AttributeAssignmentType:
		 *   let
		 *     severity : Integer[1] = 'AttributeAssignment::AttributeAssignmentType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.feature <> null and self.storyPatternObject.type <> null and
		 *             self.storyPatternObject.type.oclIsKindOf(ecore::EClass) implies
		 *             self.storyPatternObject.type.oclAsType(ecore::EClass)
		 *             .eAllStructuralFeatures->includes(self.feature)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Feature of attribute assignment ' +
		 *               self.toString() + ' must belong to the story pattern object\'s type.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AttributeAssignment::AttributeAssignmentType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_AttributeAssignment_c_c_AttributeAssignmentType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_and;
			try {
				final /*@NonInvalid*/ StoryPatternObject storyPatternObject_0 = this
						.getStoryPatternObject();
				final /*@NonInvalid*/ EClassifier type_0 = storyPatternObject_0
						.getType();
				final /*@NonInvalid*/ boolean ne = type_0 != null;
				/*@Thrown*/ boolean and;
				if (ne) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
							.getClass(MlstorypatternsTables.CLSSid_EClass,
									null);
					final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0)
							.booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				CAUGHT_and = and;
			} catch (Exception e) {
				CAUGHT_and = ValueUtil.createInvalidValue(e);
			}
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_includes;
			try {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_1 = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EClass, null);
				final /*@NonInvalid*/ StoryPatternObject storyPatternObject_1 = this
						.getStoryPatternObject();
				final /*@NonInvalid*/ EClassifier type_1 = storyPatternObject_1
						.getType();
				final /*@Thrown*/ EClass oclAsType = ClassUtil.nonNullState(
						(EClass) OclAnyOclAsTypeOperation.INSTANCE.evaluate(
								executor, type_1, TYP_ecore_c_c_EClass_1));
				final /*@Thrown*/ List<EStructuralFeature> eAllStructuralFeatures = oclAsType
						.getEAllStructuralFeatures();
				final /*@Thrown*/ OrderedSetValue BOXED_eAllStructuralFeatures = idResolver
						.createOrderedSetOfAll(
								MlstorypatternsTables.ORD_CLSSid_EStructuralFeature,
								eAllStructuralFeatures);
				final /*@NonInvalid*/ EStructuralFeature feature = this
						.getFeature();
				final /*@Thrown*/ boolean includes = CollectionIncludesOperation.INSTANCE
						.evaluate(BOXED_eAllStructuralFeatures, feature)
						.booleanValue();
				CAUGHT_includes = includes;
			} catch (Exception e) {
				CAUGHT_includes = ValueUtil.createInvalidValue(e);
			}
			final /*@Thrown*/ Boolean implies = BooleanImpliesOperation.INSTANCE
					.evaluate(CAUGHT_and, CAUGHT_includes);
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Feature_32_of_32_attribute_32_assignment_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_belong_32_to_32_the_32_story_32_pattern_32_object_39_s_32_type);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_AttributeAssignment_c_c_AttributeAssignmentType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStoryPatternObject((StoryPatternObject) otherEnd,
						msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				return basicSetStoryPatternObject(null, msgs);
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION :
				return basicSetAssignmentExpression(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				return eInternalContainer().eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
						StoryPatternObject.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
				return getAnnotations();
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				return getStoryPatternObject();
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION :
				return getAssignmentExpression();
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE :
				if (resolve)
					return getFeature();
				return basicGetFeature();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				setStoryPatternObject((StoryPatternObject) newValue);
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION :
				setAssignmentExpression((MLExpression) newValue);
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE :
				setFeature((EStructuralFeature) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				setStoryPatternObject((StoryPatternObject) null);
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION :
				setAssignmentExpression((MLExpression) null);
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE :
				setFeature((EStructuralFeature) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
				return getStoryPatternObject() != null;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION :
				return assignmentExpression != null;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE :
				return feature != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_FEATURE__DIAGNOSTICCHAIN_MAP :
				return AttributeAssignmentFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_EXPRESSION__DIAGNOSTICCHAIN_MAP :
				return AttributeAssignmentExpression(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_TYPE__DIAGNOSTICCHAIN_MAP :
				return AttributeAssignmentType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // AttributeAssignmentImpl
