/**
 */
package de.mdelab.mlstorypatterns.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Map Entry Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.MapEntryLinkImpl#getFeature <em>Feature</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.MapEntryLinkImpl#getValueTarget <em>Value Target</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MapEntryLinkImpl extends AbstractStoryPatternLinkImpl
		implements
			MapEntryLink {
	/**
	 * The cached value of the '{@link #getFeature() <em>Feature</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFeature()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature feature;

	/**
	 * The cached value of the '{@link #getValueTarget() <em>Value Target</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getValueTarget()
	 * @generated
	 * @ordered
	 */
	protected AbstractStoryPatternObject valueTarget;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected MapEntryLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.MAP_ENTRY_LINK;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EStructuralFeature getFeature() {
		if (feature != null && feature.eIsProxy()) {
			InternalEObject oldFeature = (InternalEObject) feature;
			feature = (EStructuralFeature) eResolveProxy(oldFeature);
			if (feature != oldFeature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE,
							oldFeature, feature));
			}
		}
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EStructuralFeature basicGetFeature() {
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFeature(EStructuralFeature newFeature) {
		EStructuralFeature oldFeature = feature;
		feature = newFeature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE, oldFeature,
					feature));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AbstractStoryPatternObject getValueTarget() {
		return valueTarget;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setValueTarget(AbstractStoryPatternObject newValueTarget) {
		AbstractStoryPatternObject oldValueTarget = valueTarget;
		valueTarget = newValueTarget;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.MAP_ENTRY_LINK__VALUE_TARGET,
					oldValueTarget, valueTarget));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean MapEntryLinkFeature(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv MapEntryLinkFeature:
		 *   let
		 *     severity : Integer[1] = 'MapEntryLink::MapEntryLinkFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.feature <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The feature of map entry link ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'MapEntryLink::MapEntryLinkFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_MapEntryLink_c_c_MapEntryLinkFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_MapEntryLink_c_c_MapEntryLinkFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean MapEntryLinkSourceType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv MapEntryLinkSourceType:
		 *   let
		 *     severity : Integer[1] = 'MapEntryLink::MapEntryLinkSourceType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.source.type <> null implies
		 *             self.source.type.oclIsKindOf(ecore::EClass)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The type of the source of map entry link ' +
		 *               self.toString() + ' must be an EClass.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'MapEntryLink::MapEntryLinkSourceType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_MapEntryLink_c_c_MapEntryLinkSourceType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject source_0 = this
					.getSource();
			final /*@NonInvalid*/ EClassifier type_0 = source_0.getType();
			final /*@NonInvalid*/ boolean ne = type_0 != null;
			/*@Thrown*/ boolean implies;
			if (ne) {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EClass, null);
				final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
						.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0)
						.booleanValue();
				implies = oclIsKindOf;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_type_32_of_32_the_32_source_32_of_32_map_32_entry_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_an_32_EClass);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_MapEntryLink_c_c_MapEntryLinkSourceType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean MapEntryLinkSourceTypeFeature(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv MapEntryLinkSourceTypeFeature:
		 *   let
		 *     severity : Integer[1] = 'MapEntryLink::MapEntryLinkSourceTypeFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.source.type <> null and
		 *             self.source.type.oclIsKindOf(ecore::EClass) implies
		 *             self.source.type.oclAsType(ecore::EClass)
		 *             .eAllStructuralFeatures->includes(self.feature)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The feature of map entry link ' +
		 *               self.toString() + ' must belong to its source object\'s type.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'MapEntryLink::MapEntryLinkSourceTypeFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_MapEntryLink_c_c_MapEntryLinkSourceTypeFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_and;
			try {
				final /*@NonInvalid*/ AbstractStoryPatternObject source_0 = this
						.getSource();
				final /*@NonInvalid*/ EClassifier type_0 = source_0.getType();
				final /*@NonInvalid*/ boolean ne = type_0 != null;
				/*@Thrown*/ boolean and;
				if (ne) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
							.getClass(MlstorypatternsTables.CLSSid_EClass,
									null);
					final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0)
							.booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				CAUGHT_and = and;
			} catch (Exception e) {
				CAUGHT_and = ValueUtil.createInvalidValue(e);
			}
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_includes;
			try {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_1 = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EClass, null);
				final /*@NonInvalid*/ AbstractStoryPatternObject source_1 = this
						.getSource();
				final /*@NonInvalid*/ EClassifier type_1 = source_1.getType();
				final /*@Thrown*/ EClass oclAsType = ClassUtil.nonNullState(
						(EClass) OclAnyOclAsTypeOperation.INSTANCE.evaluate(
								executor, type_1, TYP_ecore_c_c_EClass_1));
				final /*@Thrown*/ List<EStructuralFeature> eAllStructuralFeatures = oclAsType
						.getEAllStructuralFeatures();
				final /*@Thrown*/ OrderedSetValue BOXED_eAllStructuralFeatures = idResolver
						.createOrderedSetOfAll(
								MlstorypatternsTables.ORD_CLSSid_EStructuralFeature,
								eAllStructuralFeatures);
				final /*@NonInvalid*/ EStructuralFeature feature = this
						.getFeature();
				final /*@Thrown*/ boolean includes = CollectionIncludesOperation.INSTANCE
						.evaluate(BOXED_eAllStructuralFeatures, feature)
						.booleanValue();
				CAUGHT_includes = includes;
			} catch (Exception e) {
				CAUGHT_includes = ValueUtil.createInvalidValue(e);
			}
			final /*@Thrown*/ Boolean implies = BooleanImpliesOperation.INSTANCE
					.evaluate(CAUGHT_and, CAUGHT_includes);
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_feature_32_of_32_map_32_entry_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_belong_32_to_32_its_32_source_32_object_39_s_32_type);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_MapEntryLink_c_c_MapEntryLinkSourceTypeFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE :
				if (resolve)
					return getFeature();
				return basicGetFeature();
			case MlstorypatternsPackage.MAP_ENTRY_LINK__VALUE_TARGET :
				return getValueTarget();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE :
				setFeature((EStructuralFeature) newValue);
				return;
			case MlstorypatternsPackage.MAP_ENTRY_LINK__VALUE_TARGET :
				setValueTarget((AbstractStoryPatternObject) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE :
				setFeature((EStructuralFeature) null);
				return;
			case MlstorypatternsPackage.MAP_ENTRY_LINK__VALUE_TARGET :
				setValueTarget((AbstractStoryPatternObject) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE :
				return feature != null;
			case MlstorypatternsPackage.MAP_ENTRY_LINK__VALUE_TARGET :
				return valueTarget != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.MAP_ENTRY_LINK___MAP_ENTRY_LINK_FEATURE__DIAGNOSTICCHAIN_MAP :
				return MapEntryLinkFeature((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP :
				return MapEntryLinkSourceType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP :
				return MapEntryLinkSourceTypeFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // MapEntryLinkImpl
