/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanNotOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanOrOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.BindingTypeEnum;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getStoryPatternLinks <em>Story Pattern Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getStoryPatternObjects <em>Story Pattern Objects</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getLinkOrderConstraints <em>Link Order Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getNegativeApplicationConditions <em>Negative Application Conditions</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getContainingPattern <em>Containing Pattern</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StoryPatternImpl extends MLElementWithUUIDImpl
		implements
			StoryPattern {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStoryPatternLinks()
	 * <em>Story Pattern Links</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStoryPatternLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternLink> storyPatternLinks;

	/**
	 * The cached value of the '{@link #getStoryPatternObjects()
	 * <em>Story Pattern Objects</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStoryPatternObjects()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternObject> storyPatternObjects;

	/**
	 * The cached value of the '{@link #getLinkOrderConstraints()
	 * <em>Link Order Constraints</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getLinkOrderConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<LinkOrderConstraint> linkOrderConstraints;

	/**
	 * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression> constraints;

	/**
	 * The cached value of the '{@link #getNegativeApplicationConditions() <em>Negative Application Conditions</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNegativeApplicationConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<StoryPattern> negativeApplicationConditions;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternLink> getStoryPatternLinks() {
		if (storyPatternLinks == null) {
			storyPatternLinks = new EObjectContainmentWithInverseEList<AbstractStoryPatternLink>(
					AbstractStoryPatternLink.class, this,
					MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN);
		}
		return storyPatternLinks;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternObject> getStoryPatternObjects() {
		if (storyPatternObjects == null) {
			storyPatternObjects = new EObjectContainmentWithInverseEList<AbstractStoryPatternObject>(
					AbstractStoryPatternObject.class, this,
					MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN);
		}
		return storyPatternObjects;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<LinkOrderConstraint> getLinkOrderConstraints() {
		if (linkOrderConstraints == null) {
			linkOrderConstraints = new EObjectContainmentWithInverseEList<LinkOrderConstraint>(
					LinkOrderConstraint.class, this,
					MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN);
		}
		return linkOrderConstraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLExpression> getConstraints() {
		if (constraints == null) {
			constraints = new EObjectContainmentEList<MLExpression>(
					MLExpression.class, this,
					MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS);
		}
		return constraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<StoryPattern> getNegativeApplicationConditions() {
		if (negativeApplicationConditions == null) {
			negativeApplicationConditions = new EObjectContainmentWithInverseEList<StoryPattern>(
					StoryPattern.class, this,
					MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS,
					MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN);
		}
		return negativeApplicationConditions;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getContainingPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContainingPattern(
			StoryPattern newContainingPattern, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newContainingPattern,
				MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setContainingPattern(StoryPattern newContainingPattern) {
		if (newContainingPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN
						&& newContainingPattern != null)) {
			if (EcoreUtil.isAncestor(this, newContainingPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContainingPattern != null)
				msgs = ((InternalEObject) newContainingPattern).eInverseAdd(
						this,
						MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS,
						StoryPattern.class, msgs);
			msgs = basicSetContainingPattern(newContainingPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN,
					newContainingPattern, newContainingPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternNotEmpty(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternNotEmpty:
		 *   let
		 *     severity : Integer[1] = 'StoryPattern::StoryPatternNotEmpty'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if not self.storyPatternObjects->isEmpty()
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else Tuple{message = 'Story pattern ' +
		 *               self.toString() + ' may not be empty.', status = status}
		 *           endif
		 *       in
		 *         'StoryPattern::StoryPatternNotEmpty'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPattern_c_c_StoryPatternNotEmpty);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<AbstractStoryPatternObject> storyPatternObjects = this
					.getStoryPatternObjects();
			final /*@NonInvalid*/ SetValue BOXED_storyPatternObjects = idResolver
					.createSetOfAll(
							MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternObject,
							storyPatternObjects);
			final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
					.evaluate(BOXED_storyPatternObjects).booleanValue();
			final /*@NonInvalid*/ Boolean not = BooleanNotOperation.INSTANCE
					.evaluate(isEmpty);
			if (not == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (not) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlstorypatternsTables.STR_Story_32_pattern_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_may_32_not_32_be_32_empty);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPattern_c_c_StoryPatternNotEmpty,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternBoundNode(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternBoundNode:
		 *   let
		 *     severity : Integer[1] = 'StoryPattern::StoryPatternBoundNode'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.containingPattern = null implies
		 *             self.storyPatternObjects->select(e |
		 *               e.oclIsKindOf(StoryPatternObject))
		 *             ->exists(e |
		 *               e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::BOUND or
		 *               e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::CAN_BE_BOUND) or
		 *             self.storyPatternObjects->forAll(e | e.modifier = ModifierEnum::CREATE and e.matchType = MatchTypeEnum::DEFAULT)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern ' +
		 *               self.toString() + ' must contain at least one bound or only created objects.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPattern::StoryPatternBoundNode'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPattern_c_c_StoryPatternBoundNode);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPattern containingPattern = this
					.getContainingPattern();
			final /*@NonInvalid*/ boolean eq = containingPattern == null;
			/*@Thrown*/ Boolean implies;
			if (eq) {
				final /*@NonInvalid*/ List<AbstractStoryPatternObject> storyPatternObjects_0 = this
						.getStoryPatternObjects();
				final /*@NonInvalid*/ SetValue BOXED_storyPatternObjects_0 = idResolver
						.createSetOfAll(
								MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternObject,
								storyPatternObjects_0);
				/*@Caught*/ /*@Nullable*/ Object CAUGHT_exists;
				try {
					/*@Thrown*/ SetValue.Accumulator accumulator = ValueUtil
							.createSetAccumulatorValue(
									MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternObject);
					/*@NonNull*/ Iterator<Object> ITERATOR_e_0 = BOXED_storyPatternObjects_0
							.iterator();
					/*@NonInvalid*/ SetValue select;
					while (true) {
						if (!ITERATOR_e_0.hasNext()) {
							select = accumulator;
							break;
						}
						/*@NonInvalid*/ AbstractStoryPatternObject e_0 = (AbstractStoryPatternObject) ITERATOR_e_0
								.next();
						/**
						 * e.oclIsKindOf(StoryPatternObject)
						 */
						final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_StoryPatternObject = idResolver
								.getClass(
										MlstorypatternsTables.CLSSid_StoryPatternObject,
										null);
						final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
								.evaluate(executor, e_0,
										TYP_mlstorypatterns_c_c_StoryPatternObject)
								.booleanValue();
						//
						if (oclIsKindOf == ValueUtil.TRUE_VALUE) {
							accumulator.add(e_0);
						}
					}
					/*@Thrown*/ Object accumulator_0 = ValueUtil.FALSE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_1 = select
							.iterator();
					/*@Thrown*/ Boolean exists;
					while (true) {
						if (!ITERATOR_e_1.hasNext()) {
							if (accumulator_0 == null) {
								exists = null;
							} else if (accumulator_0 == ValueUtil.FALSE_VALUE) {
								exists = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator_0;
							}
							break;
						}
						/*@NonInvalid*/ AbstractStoryPatternObject e_1 = (AbstractStoryPatternObject) ITERATOR_e_1
								.next();
						/**
						 *
						 * e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::BOUND or
						 * e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::CAN_BE_BOUND
						 */
						/*@Caught*/ /*@Nullable*/ Object CAUGHT_or;
						try {
							/*@Caught*/ /*@NonNull*/ Object CAUGHT_eq_0;
							try {
								final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_StoryPatternObject_0 = idResolver
										.getClass(
												MlstorypatternsTables.CLSSid_StoryPatternObject,
												null);
								final /*@Thrown*/ StoryPatternObject oclAsType = ClassUtil
										.nonNullState(
												(StoryPatternObject) OclAnyOclAsTypeOperation.INSTANCE
														.evaluate(executor, e_1,
																TYP_mlstorypatterns_c_c_StoryPatternObject_0));
								final /*@Thrown*/ BindingTypeEnum bindingType = oclAsType
										.getBindingType();
								final /*@Thrown*/ EnumerationLiteralId BOXED_bindingType = MlstorypatternsTables.ENUMid_BindingTypeEnum
										.getEnumerationLiteralId(
												ClassUtil.nonNullState(
														bindingType.getName()));
								final /*@Thrown*/ boolean eq_0 = BOXED_bindingType == MlstorypatternsTables.ELITid_BOUND;
								CAUGHT_eq_0 = eq_0;
							} catch (Exception e) {
								CAUGHT_eq_0 = ValueUtil.createInvalidValue(e);
							}
							/*@Caught*/ /*@NonNull*/ Object CAUGHT_eq_1;
							try {
								final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_StoryPatternObject_1 = idResolver
										.getClass(
												MlstorypatternsTables.CLSSid_StoryPatternObject,
												null);
								final /*@Thrown*/ StoryPatternObject oclAsType_0 = ClassUtil
										.nonNullState(
												(StoryPatternObject) OclAnyOclAsTypeOperation.INSTANCE
														.evaluate(executor, e_1,
																TYP_mlstorypatterns_c_c_StoryPatternObject_1));
								final /*@Thrown*/ BindingTypeEnum bindingType_0 = oclAsType_0
										.getBindingType();
								final /*@Thrown*/ EnumerationLiteralId BOXED_bindingType_0 = MlstorypatternsTables.ENUMid_BindingTypeEnum
										.getEnumerationLiteralId(ClassUtil
												.nonNullState(bindingType_0
														.getName()));
								final /*@Thrown*/ boolean eq_1 = BOXED_bindingType_0 == MlstorypatternsTables.ELITid_CAN_BE_BOUND;
								CAUGHT_eq_1 = eq_1;
							} catch (Exception e) {
								CAUGHT_eq_1 = ValueUtil.createInvalidValue(e);
							}
							final /*@Thrown*/ Boolean or = BooleanOrOperation.INSTANCE
									.evaluate(CAUGHT_eq_0, CAUGHT_eq_1);
							CAUGHT_or = or;
						} catch (Exception e) {
							CAUGHT_or = ValueUtil.createInvalidValue(e);
						}
						//
						if (CAUGHT_or == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							exists = ValueUtil.TRUE_VALUE;
							break; // Stop immediately
						} else if (CAUGHT_or == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							; // Carry on
						} else if (CAUGHT_or == null) { // Abnormal null body evaluation result
							if (accumulator_0 == ValueUtil.FALSE_VALUE) {
								accumulator_0 = null; // Cache a null failure
							}
						} else if (CAUGHT_or instanceof InvalidValueException) { // Abnormal exception evaluation result
							accumulator_0 = CAUGHT_or; // Cache an exception failure
						} else { // Impossible badly typed result
							accumulator_0 = new InvalidValueException(
									PivotMessages.NonBooleanBody, "exists");
						}
					}
					CAUGHT_exists = exists;
				} catch (Exception e) {
					CAUGHT_exists = ValueUtil.createInvalidValue(e);
				}
				/*@Thrown*/ Object accumulator_1 = ValueUtil.TRUE_VALUE;
				/*@NonNull*/ Iterator<Object> ITERATOR_e_2 = BOXED_storyPatternObjects_0
						.iterator();
				/*@NonInvalid*/ Boolean forAll;
				while (true) {
					if (!ITERATOR_e_2.hasNext()) {
						if (accumulator_1 == ValueUtil.TRUE_VALUE) {
							forAll = ValueUtil.TRUE_VALUE;
						} else {
							throw (InvalidValueException) accumulator_1;
						}
						break;
					}
					/*@NonInvalid*/ AbstractStoryPatternObject e_2 = (AbstractStoryPatternObject) ITERATOR_e_2
							.next();
					/**
					 * e.modifier = ModifierEnum::CREATE and e.matchType = MatchTypeEnum::DEFAULT
					 */
					final /*@NonInvalid*/ ModifierEnum modifier = e_2
							.getModifier();
					final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
							.getEnumerationLiteralId(
									ClassUtil.nonNullState(modifier.getName()));
					final /*@NonInvalid*/ boolean eq_2 = BOXED_modifier == MlstorypatternsTables.ELITid_CREATE;
					/*@NonInvalid*/ boolean and;
					if (eq_2) {
						final /*@NonInvalid*/ MatchTypeEnum matchType = e_2
								.getMatchType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_matchType = MlstorypatternsTables.ENUMid_MatchTypeEnum
								.getEnumerationLiteralId(ClassUtil
										.nonNullState(matchType.getName()));
						final /*@NonInvalid*/ boolean eq_3 = BOXED_matchType == MlstorypatternsTables.ELITid_DEFAULT;
						and = eq_3;
					} else {
						and = ValueUtil.FALSE_VALUE;
					}
					//
					if (and == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						forAll = ValueUtil.FALSE_VALUE;
						break; // Stop immediately
					} else if (and == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator_1 = new InvalidValueException(
								PivotMessages.NonBooleanBody, "forAll");
					}
				}
				final /*@Thrown*/ Boolean or_0 = BooleanOrOperation.INSTANCE
						.evaluate(CAUGHT_exists, forAll);
				implies = or_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlstorypatternsTables.STR_Story_32_pattern_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_contain_32_at_32_least_32_one_32_bound_32_or_32_only_32_created_32_objects);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPattern_c_c_StoryPatternBoundNode,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getStoryPatternLinks())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getStoryPatternObjects())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getLinkOrderConstraints())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getNegativeApplicationConditions())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetContainingPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS :
				return ((InternalEList<?>) getStoryPatternLinks())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS :
				return ((InternalEList<?>) getStoryPatternObjects())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS :
				return ((InternalEList<?>) getLinkOrderConstraints())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS :
				return ((InternalEList<?>) getConstraints())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS :
				return ((InternalEList<?>) getNegativeApplicationConditions())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				return basicSetContainingPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				return eInternalContainer().eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS,
						StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
				return getAnnotations();
			case MlstorypatternsPackage.STORY_PATTERN__NAME :
				return getName();
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS :
				return getStoryPatternLinks();
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS :
				return getStoryPatternObjects();
			case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS :
				return getLinkOrderConstraints();
			case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS :
				return getConstraints();
			case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS :
				return getNegativeApplicationConditions();
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				return getContainingPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__NAME :
				setName((String) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS :
				getStoryPatternLinks().clear();
				getStoryPatternLinks().addAll(
						(Collection<? extends AbstractStoryPatternLink>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS :
				getStoryPatternObjects().clear();
				getStoryPatternObjects().addAll(
						(Collection<? extends AbstractStoryPatternObject>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS :
				getLinkOrderConstraints().clear();
				getLinkOrderConstraints().addAll(
						(Collection<? extends LinkOrderConstraint>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS :
				getConstraints().clear();
				getConstraints()
						.addAll((Collection<? extends MLExpression>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS :
				getNegativeApplicationConditions().clear();
				getNegativeApplicationConditions()
						.addAll((Collection<? extends StoryPattern>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				setContainingPattern((StoryPattern) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN__NAME :
				setName(NAME_EDEFAULT);
				return;
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS :
				getStoryPatternLinks().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS :
				getStoryPatternObjects().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS :
				getLinkOrderConstraints().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS :
				getConstraints().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS :
				getNegativeApplicationConditions().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				setContainingPattern((StoryPattern) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN__NAME :
				return NAME_EDEFAULT == null
						? name != null
						: !NAME_EDEFAULT.equals(name);
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS :
				return storyPatternLinks != null
						&& !storyPatternLinks.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS :
				return storyPatternObjects != null
						&& !storyPatternObjects.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS :
				return linkOrderConstraints != null
						&& !linkOrderConstraints.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS :
				return constraints != null && !constraints.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS :
				return negativeApplicationConditions != null
						&& !negativeApplicationConditions.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN :
				return getContainingPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.STORY_PATTERN__NAME :
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS;
				default :
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_NAMED_ELEMENT__NAME :
					return MlstorypatternsPackage.STORY_PATTERN__NAME;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.STORY_PATTERN___STORY_PATTERN_NOT_EMPTY__DIAGNOSTICCHAIN_MAP :
				return StoryPatternNotEmpty((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN___STORY_PATTERN_BOUND_NODE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternBoundNode((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // StoryPatternImpl
