/**
 */
package de.mdelab.mlstorypatterns.impl;

import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import java.util.Collection;

import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanAndOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanOrOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.LinkPositionConstraintEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getFeature <em>Feature</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getLinkPositionConstraint <em>Link Position Constraint</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getOutgoingLinkOrderConstraints <em>Outgoing Link Order Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getIncomingLinkOrderConstraints <em>Incoming Link Order Constraints</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StoryPatternLinkImpl extends AbstractStoryPatternLinkImpl
		implements
			StoryPatternLink {
	/**
	 * The cached value of the '{@link #getFeature() <em>Feature</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFeature()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature feature;

	/**
	 * The default value of the '{@link #getLinkPositionConstraint() <em>Link Position Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkPositionConstraint()
	 * @generated
	 * @ordered
	 */
	protected static final LinkPositionConstraintEnum LINK_POSITION_CONSTRAINT_EDEFAULT = LinkPositionConstraintEnum.UNCONSTRAINED;

	/**
	 * The cached value of the '{@link #getLinkPositionConstraint() <em>Link Position Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkPositionConstraint()
	 * @generated
	 * @ordered
	 */
	protected LinkPositionConstraintEnum linkPositionConstraint = LINK_POSITION_CONSTRAINT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOutgoingLinkOrderConstraints()
	 * <em>Outgoing Link Order Constraints</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOutgoingLinkOrderConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<LinkOrderConstraint> outgoingLinkOrderConstraints;

	/**
	 * The cached value of the '{@link #getIncomingLinkOrderConstraints()
	 * <em>Incoming Link Order Constraints</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIncomingLinkOrderConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<LinkOrderConstraint> incomingLinkOrderConstraints;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN_LINK;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EStructuralFeature getFeature() {
		if (feature != null && feature.eIsProxy()) {
			InternalEObject oldFeature = (InternalEObject) feature;
			feature = (EStructuralFeature) eResolveProxy(oldFeature);
			if (feature != oldFeature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE,
							oldFeature, feature));
			}
		}
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EStructuralFeature basicGetFeature() {
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFeature(EStructuralFeature newFeature) {
		EStructuralFeature oldFeature = feature;
		feature = newFeature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE,
					oldFeature, feature));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinkPositionConstraintEnum getLinkPositionConstraint() {
		return linkPositionConstraint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setLinkPositionConstraint(
			LinkPositionConstraintEnum newLinkPositionConstraint) {
		LinkPositionConstraintEnum oldLinkPositionConstraint = linkPositionConstraint;
		linkPositionConstraint = newLinkPositionConstraint == null
				? LINK_POSITION_CONSTRAINT_EDEFAULT
				: newLinkPositionConstraint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT,
					oldLinkPositionConstraint, linkPositionConstraint));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<LinkOrderConstraint> getOutgoingLinkOrderConstraints() {
		if (outgoingLinkOrderConstraints == null) {
			outgoingLinkOrderConstraints = new EObjectWithInverseEList<LinkOrderConstraint>(
					LinkOrderConstraint.class, this,
					MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK);
		}
		return outgoingLinkOrderConstraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<LinkOrderConstraint> getIncomingLinkOrderConstraints() {
		if (incomingLinkOrderConstraints == null) {
			incomingLinkOrderConstraints = new EObjectWithInverseEList<LinkOrderConstraint>(
					LinkOrderConstraint.class, this,
					MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK);
		}
		return incomingLinkOrderConstraints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternLinkSourceTypeFeature(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternLinkSourceTypeFeature:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternLink::StoryPatternLinkSourceTypeFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.source.type <> null and
		 *             self.source.type.oclIsKindOf(ecore::EClass) implies
		 *             self.source.type.oclAsType(ecore::EClass)
		 *             .eAllStructuralFeatures->includes(self.feature)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The feature of story pattern link ' +
		 *               self.toString() + ' must belong to its source object\'s type.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternLink::StoryPatternLinkSourceTypeFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkSourceTypeFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_and;
			try {
				final /*@NonInvalid*/ AbstractStoryPatternObject source_0 = this
						.getSource();
				final /*@NonInvalid*/ EClassifier type_0 = source_0.getType();
				final /*@NonInvalid*/ boolean ne = type_0 != null;
				/*@Thrown*/ boolean and;
				if (ne) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
							.getClass(MlstorypatternsTables.CLSSid_EClass,
									null);
					final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0)
							.booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				CAUGHT_and = and;
			} catch (Exception e) {
				CAUGHT_and = ValueUtil.createInvalidValue(e);
			}
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_includes;
			try {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_1 = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EClass, null);
				final /*@NonInvalid*/ AbstractStoryPatternObject source_1 = this
						.getSource();
				final /*@NonInvalid*/ EClassifier type_1 = source_1.getType();
				final /*@Thrown*/ EClass oclAsType = ClassUtil.nonNullState(
						(EClass) OclAnyOclAsTypeOperation.INSTANCE.evaluate(
								executor, type_1, TYP_ecore_c_c_EClass_1));
				final /*@Thrown*/ List<EStructuralFeature> eAllStructuralFeatures = oclAsType
						.getEAllStructuralFeatures();
				final /*@Thrown*/ OrderedSetValue BOXED_eAllStructuralFeatures = idResolver
						.createOrderedSetOfAll(
								MlstorypatternsTables.ORD_CLSSid_EStructuralFeature,
								eAllStructuralFeatures);
				final /*@NonInvalid*/ EStructuralFeature feature = this
						.getFeature();
				final /*@Thrown*/ boolean includes = CollectionIncludesOperation.INSTANCE
						.evaluate(BOXED_eAllStructuralFeatures, feature)
						.booleanValue();
				CAUGHT_includes = includes;
			} catch (Exception e) {
				CAUGHT_includes = ValueUtil.createInvalidValue(e);
			}
			final /*@Thrown*/ Boolean implies = BooleanImpliesOperation.INSTANCE
					.evaluate(CAUGHT_and, CAUGHT_includes);
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_feature_32_of_32_story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_belong_32_to_32_its_32_source_32_object_39_s_32_type);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkSourceTypeFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternLinkSourceType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternLinkSourceType:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternLink::StoryPatternLinkSourceType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.source <> null and self.source.type <> null implies
		 *             self.source.type.oclIsKindOf(ecore::EClass)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The type of the source of story pattern link ' +
		 *               self.toString() + ' must be an EClass.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternLink::StoryPatternLinkSourceType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkSourceType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject source_0 = this
					.getSource();
			final /*@NonInvalid*/ EClassifier type_0 = source_0.getType();
			final /*@NonInvalid*/ boolean ne = type_0 != null;
			/*@Thrown*/ boolean implies;
			if (ne) {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EClass, null);
				final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
						.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0)
						.booleanValue();
				implies = oclIsKindOf;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_type_32_of_32_the_32_source_32_of_32_story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_an_32_EClass);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkSourceType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternLinkOrderedFeature(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternLinkOrderedFeature:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternLink::StoryPatternLinkOrderedFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.linkPositionConstraint <> LinkPositionConstraintEnum::UNCONSTRAINED and self.feature <> null implies self.feature.ordered
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The feature of story pattern link ' +
		 *               self.toString() + ' with a link position constraint must be ordered.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternLink::StoryPatternLinkOrderedFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkOrderedFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ LinkPositionConstraintEnum linkPositionConstraint = this
					.getLinkPositionConstraint();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_linkPositionConstraint = MlstorypatternsTables.ENUMid_LinkPositionConstraintEnum
					.getEnumerationLiteralId(ClassUtil
							.nonNullState(linkPositionConstraint.getName()));
			final /*@NonInvalid*/ boolean ne = BOXED_linkPositionConstraint != MlstorypatternsTables.ELITid_UNCONSTRAINED;
			/*@NonInvalid*/ boolean and;
			if (ne) {
				and = ValueUtil.TRUE_VALUE;
			} else {
				and = ValueUtil.FALSE_VALUE;
			}
			/*@NonInvalid*/ boolean implies;
			if (and) {
				final /*@NonInvalid*/ EStructuralFeature feature = this
						.getFeature();
				final /*@NonInvalid*/ boolean ordered = feature.isOrdered();
				implies = ordered;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_feature_32_of_32_story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_with_32_a_32_link_32_position_32_constraint_32_must_32_be_32_ordered);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkOrderedFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternLinkFeature(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternLinkFeature:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternLink::StoryPatternLinkFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.feature <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Feature of story pattern link ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternLink::StoryPatternLinkFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternLinkPositionConstraint(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternLinkPositionConstraint:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternLink::StoryPatternLinkPositionConstraint'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.linkPositionConstraint <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Link position constraint of story pattern link ' +
		 *               self.toString() + ' must be specified. For unconstrained links use literal \'UNCONSTRAINED\'.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternLink::StoryPatternLinkPositionConstraint'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkPositionConstraint);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkPositionConstraint,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternLinkTargetType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternLinkTargetType:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternLink::StoryPatternLinkTargetType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.target <> null and self.target.type <> null implies self.feature.eType = self.target.type or
		 *             self.target.type.oclIsKindOf(ecore::EClass) and
		 *             (
		 *               self.target.type.oclAsType(ecore::EClass)
		 *               .eAllSuperTypes->includes(self.feature.eType) or self.feature.eType.name = 'EObject'
		 *             )
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The type of the target of story pattern link ' +
		 *               self.toString() + ' must match its feature\'s type.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternLink::StoryPatternLinkTargetType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkTargetType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ AbstractStoryPatternObject target = this
					.getTarget();
			final /*@NonInvalid*/ EClassifier type = target.getType();
			final /*@NonInvalid*/ boolean ne = type != null;
			/*@Thrown*/ Boolean implies;
			if (ne) {
				final /*@NonInvalid*/ EStructuralFeature feature = this
						.getFeature();
				final /*@NonInvalid*/ EClassifier eType = feature.getEType();
				final /*@NonInvalid*/ boolean eq = (eType != null)
						? eType.equals(type)
						: (type == null);
				/*@Thrown*/ Boolean or_0;
				if (eq) {
					or_0 = ValueUtil.TRUE_VALUE;
				} else {
					/*@Caught*/ /*@NonNull*/ Object CAUGHT_oclIsKindOf;
					try {
						final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_0 = idResolver
								.getClass(MlstorypatternsTables.CLSSid_EClass,
										null);
						final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
								.evaluate(executor, type,
										TYP_ecore_c_c_EClass_0)
								.booleanValue();
						CAUGHT_oclIsKindOf = oclIsKindOf;
					} catch (Exception e) {
						CAUGHT_oclIsKindOf = ValueUtil.createInvalidValue(e);
					}
					/*@Caught*/ /*@Nullable*/ Object CAUGHT_or;
					try {
						/*@Caught*/ /*@NonNull*/ Object CAUGHT_includes;
						try {
							final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass_1 = idResolver
									.getClass(
											MlstorypatternsTables.CLSSid_EClass,
											null);
							final /*@Thrown*/ EClass oclAsType = ClassUtil
									.nonNullState(
											(EClass) OclAnyOclAsTypeOperation.INSTANCE
													.evaluate(executor, type,
															TYP_ecore_c_c_EClass_1));
							final /*@Thrown*/ List<EClass> eAllSuperTypes = oclAsType
									.getEAllSuperTypes();
							final /*@Thrown*/ OrderedSetValue BOXED_eAllSuperTypes = idResolver
									.createOrderedSetOfAll(
											MlstorypatternsTables.ORD_CLSSid_EClass,
											eAllSuperTypes);
							final /*@Thrown*/ boolean includes = CollectionIncludesOperation.INSTANCE
									.evaluate(BOXED_eAllSuperTypes, eType)
									.booleanValue();
							CAUGHT_includes = includes;
						} catch (Exception e) {
							CAUGHT_includes = ValueUtil.createInvalidValue(e);
						}
						/*@Caught*/ /*@NonNull*/ Object CAUGHT_eq_0;
						try {
							if (eType == null) {
								throw new InvalidValueException(
										"Null source for \'\'http://www.eclipse.org/emf/2002/Ecore\'::ENamedElement::name\'");
							}
							final /*@Thrown*/ String name = eType.getName();
							final /*@Thrown*/ boolean eq_0 = MlstorypatternsTables.STR_EObject
									.equals(name);
							CAUGHT_eq_0 = eq_0;
						} catch (Exception e) {
							CAUGHT_eq_0 = ValueUtil.createInvalidValue(e);
						}
						final /*@Thrown*/ Boolean or = BooleanOrOperation.INSTANCE
								.evaluate(CAUGHT_includes, CAUGHT_eq_0);
						CAUGHT_or = or;
					} catch (Exception e) {
						CAUGHT_or = ValueUtil.createInvalidValue(e);
					}
					final /*@Thrown*/ Boolean and = BooleanAndOperation.INSTANCE
							.evaluate(CAUGHT_oclIsKindOf, CAUGHT_or);
					or_0 = and;
				}
				implies = or_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_type_32_of_32_the_32_target_32_of_32_story_32_pattern_32_link_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_match_32_its_32_feature_39_s_32_type);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternLink_c_c_StoryPatternLinkTargetType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoingLinkOrderConstraints())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncomingLinkOrderConstraints())
						.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				return ((InternalEList<?>) getOutgoingLinkOrderConstraints())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS :
				return ((InternalEList<?>) getIncomingLinkOrderConstraints())
						.basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE :
				if (resolve)
					return getFeature();
				return basicGetFeature();
			case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT :
				return getLinkPositionConstraint();
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				return getOutgoingLinkOrderConstraints();
			case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS :
				return getIncomingLinkOrderConstraints();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE :
				setFeature((EStructuralFeature) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT :
				setLinkPositionConstraint(
						(LinkPositionConstraintEnum) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				getOutgoingLinkOrderConstraints().clear();
				getOutgoingLinkOrderConstraints().addAll(
						(Collection<? extends LinkOrderConstraint>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS :
				getIncomingLinkOrderConstraints().clear();
				getIncomingLinkOrderConstraints().addAll(
						(Collection<? extends LinkOrderConstraint>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE :
				setFeature((EStructuralFeature) null);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT :
				setLinkPositionConstraint(LINK_POSITION_CONSTRAINT_EDEFAULT);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				getOutgoingLinkOrderConstraints().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS :
				getIncomingLinkOrderConstraints().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE :
				return feature != null;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT :
				return linkPositionConstraint != LINK_POSITION_CONSTRAINT_EDEFAULT;
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				return outgoingLinkOrderConstraints != null
						&& !outgoingLinkOrderConstraints.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS :
				return incomingLinkOrderConstraints != null
						&& !incomingLinkOrderConstraints.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternLinkSourceTypeFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternLinkSourceType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_LINK___STORY_PATTERN_LINK_ORDERED_FEATURE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternLinkOrderedFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_LINK___STORY_PATTERN_LINK_FEATURE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternLinkFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_LINK___STORY_PATTERN_LINK_POSITION_CONSTRAINT__DIAGNOSTICCHAIN_MAP :
				return StoryPatternLinkPositionConstraint(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_LINK___STORY_PATTERN_LINK_TARGET_TYPE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternLinkTargetType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (linkPositionConstraint: ");
		result.append(linkPositionConstraint);
		result.append(')');
		return result.toString();
	}

} // StoryPatternLinkImpl
