/**
 */
package de.mdelab.mlstorypatterns.provider;

import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage.Registry;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AbstractStoryPatternObjectItemProvider
		extends
			StoryPatternElementItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AbstractStoryPatternObjectItemProvider(
			AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addTypePropertyDescriptor(object);
			addOutgoingLinksPropertyDescriptor(object);
			addIncomingLinksPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_MLNamedElement_name_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_MLNamedElement_name_feature",
						"_UI_MLNamedElement_type"),
				MlcorePackage.Literals.ML_NAMED_ELEMENT__NAME, true, false,
				false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Type feature. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	protected void addTypePropertyDescriptor(final Object object) {
		// this.itemPropertyDescriptors.add(this.createItemPropertyDescriptor(
		// ((ComposeableAdapterFactory)
		// this.adapterFactory).getRootAdapterFactory(),
		// this.getResourceLocator(),
		// this.getString("_UI_MLTypedElement_type_feature"),
		// this.getString("_UI_PropertyDescriptor_description",
		// "_UI_MLTypedElement_type_feature", "_UI_MLTypedElement_type"),
		// MlcorePackage.Literals.ML_TYPED_ELEMENT__TYPE, true, false, true,
		// null, null, null));
		this.itemPropertyDescriptors.add(new ItemPropertyDescriptor(
				((ComposeableAdapterFactory) this.adapterFactory)
						.getRootAdapterFactory(),
				this.getResourceLocator(),
				this.getString("_UI_MLTypedElement_type_feature"),
				this.getString("_UI_PropertyDescriptor_description",
						"_UI_MLTypedElement_type_feature",
						"_UI_MLTypedElement_type"),
				MlcorePackage.Literals.ML_TYPED_ELEMENT__TYPE, true, false,
				true, null, null, null) {
			@Override
			public Collection<?> getChoiceOfValues(final Object object) {
				Collection<?> result = super.getChoiceOfValues(object);
				if (this.feature instanceof EReference
						&& object instanceof EObject) {
					@SuppressWarnings("unchecked")
					final List<EObject> eObjects = (List<EObject>) (List<?>) new LinkedList<Object>(
							result);
					final Resource resource = ((EObject) object).eResource();
					if (resource != null) {
						final ResourceSet resourceSet = resource
								.getResourceSet();
						if (resourceSet != null) {
							final Collection<EObject> visited = new HashSet<EObject>(
									eObjects);
							final Registry packageRegistry = resourceSet
									.getPackageRegistry();
							for (final String nsURI : packageRegistry
									.keySet()) {
								ItemPropertyDescriptor
										.collectReachableObjectsOfType(visited,
												eObjects,
												packageRegistry
														.getEPackage(nsURI),
												this.feature.getEType());
							}
						}
					}
					result = eObjects;
				}

				return result;
			}
		});
	}

	/**
	 * This adds a property descriptor for the Outgoing Links feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addOutgoingLinksPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString(
						"_UI_AbstractStoryPatternObject_outgoingLinks_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_AbstractStoryPatternObject_outgoingLinks_feature",
						"_UI_AbstractStoryPatternObject_type"),
				MlstorypatternsPackage.Literals.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
				true, false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Incoming Links feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addIncomingLinksPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString(
						"_UI_AbstractStoryPatternObject_incomingLinks_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_AbstractStoryPatternObject_incomingLinks_feature",
						"_UI_AbstractStoryPatternObject_type"),
				MlstorypatternsPackage.Literals.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
				true, false, true, null, null, null));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((AbstractStoryPatternObject) object).getName();
		return label == null || label.length() == 0
				? getString("_UI_AbstractStoryPatternObject_type")
				: getString("_UI_AbstractStoryPatternObject_type") + " "
						+ label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(AbstractStoryPatternObject.class)) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME :
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE :
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS :
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS :
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}
}
