/**
 */
package de.mdelab.mlstorypatterns.provider;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternLink;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlstorypatterns.StoryPatternLink} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class StoryPatternLinkItemProvider
		extends
			AbstractStoryPatternLinkItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StoryPatternLinkItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addFeaturePropertyDescriptor(object);
			addLinkPositionConstraintPropertyDescriptor(object);
			addOutgoingLinkOrderConstraintsPropertyDescriptor(object);
			addIncomingLinkOrderConstraintsPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Feature feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	protected void addFeaturePropertyDescriptor(final Object object) {
		// itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory)
		// adapterFactory).getRootAdapterFactory(),
		// getResourceLocator(),
		// getString("_UI_StoryPatternLink_feature_feature"),
		// getString("_UI_PropertyDescriptor_description",
		// "_UI_StoryPatternLink_feature_feature", "_UI_StoryPatternLink_type"),
		// MlstorypatternsPackage.Literals.STORY_PATTERN_LINK__FEATURE, true,
		// false, true, null, null, null));

		this.itemPropertyDescriptors.add(new ItemPropertyDescriptor(
				((ComposeableAdapterFactory) this.adapterFactory)
						.getRootAdapterFactory(),
				this.getResourceLocator(),
				this.getString("_UI_StoryPatternLink_feature_feature"),
				this.getString("_UI_PropertyDescriptor_description",
						"_UI_StoryPatternLink_feature_feature",
						"_UI_StoryPatternLink_type"),
				MlstorypatternsPackage.Literals.STORY_PATTERN_LINK__FEATURE,
				true, false, true, null, null, null) {
			@Override
			protected Collection<?> getComboBoxObjects(final Object object) {
				assert object instanceof StoryPatternLink;

				final StoryPatternLink link = (StoryPatternLink) object;

				final Collection<Object> result = new ArrayList<Object>();

				if ((link.getSource() != null)
						&& (link.getSource().getType() != null)
						&& (link.getSource().getType() instanceof EClass)
						&& (link.getTarget() != null)
						&& (link.getTarget().getType() != null)) {
					for (final EStructuralFeature feature : ((EClass) link
							.getSource().getType())
									.getEAllStructuralFeatures()) {
						if ((feature.getEType() == link.getTarget().getType())
								|| (feature
										.getEType() == EcorePackage.Literals.EJAVA_OBJECT)
								|| ((link.getTarget()
										.getType() instanceof EClass)
										&& ((EClass) link.getTarget().getType())
												.getEAllSuperTypes().contains(
														feature.getEType()))) {
							result.add(feature);
						}
					}
				}

				return result;
			}
		});
	}

	/**
	 * This adds a property descriptor for the Link Position Constraint feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLinkPositionConstraintPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString(
						"_UI_StoryPatternLink_linkPositionConstraint_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_StoryPatternLink_linkPositionConstraint_feature",
						"_UI_StoryPatternLink_type"),
				MlstorypatternsPackage.Literals.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT,
				true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				null, null));
	}

	/**
	 * This adds a property descriptor for the Outgoing Link Order Constraints feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOutgoingLinkOrderConstraintsPropertyDescriptor(
			Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString(
						"_UI_StoryPatternLink_outgoingLinkOrderConstraints_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_StoryPatternLink_outgoingLinkOrderConstraints_feature",
						"_UI_StoryPatternLink_type"),
				MlstorypatternsPackage.Literals.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
				true, false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Incoming Link Order Constraints feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIncomingLinkOrderConstraintsPropertyDescriptor(
			Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString(
						"_UI_StoryPatternLink_incomingLinkOrderConstraints_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_StoryPatternLink_incomingLinkOrderConstraints_feature",
						"_UI_StoryPatternLink_type"),
				MlstorypatternsPackage.Literals.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
				true, false, true, null, null, null));
	}

	/**
	 * This returns StoryPatternLink.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
				getResourceLocator().getImage("full/obj16/StoryPatternLink"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = this.getString("_UI_StoryPatternLink_type");

		final StoryPatternLink link = (StoryPatternLink) object;

		label += " ";

		final ComposedAdapterFactory factory = new ComposedAdapterFactory(
				EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

		if (link.getSource() != null) {
			label += ((IItemLabelProvider) factory.adapt(link.getSource(),
					IItemLabelProvider.class)).getText(link.getSource());
		} else {
			label += "[null]";
		}

		label += ".";

		if (link.getFeature() != null) {
			label += link.getFeature().getName();
		} else {
			label += "[null]";
		}

		label += " ==> ";

		if (link.getTarget() != null) {
			label += ((IItemLabelProvider) factory.adapt(link.getTarget(),
					IItemLabelProvider.class)).getText(link.getTarget());
		} else {
			label += "[null]";
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(StoryPatternLink.class)) {
			case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE :
			case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT :
			case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
