/**
 */
package de.mdelab.mlstorypatterns.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlstorypatterns.*;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage
 * @generated
 */
public class MlstorypatternsAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static MlstorypatternsPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlstorypatternsAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = MlstorypatternsPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code> if
	 * the object is either the model's package or is an instance object of the
	 * model. <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MlstorypatternsSwitch<Adapter> modelSwitch = new MlstorypatternsSwitch<Adapter>() {
		@Override
		public Adapter caseStoryPattern(StoryPattern object) {
			return createStoryPatternAdapter();
		}
		@Override
		public Adapter caseStoryPatternElement(StoryPatternElement object) {
			return createStoryPatternElementAdapter();
		}
		@Override
		public Adapter caseAbstractStoryPatternObject(
				AbstractStoryPatternObject object) {
			return createAbstractStoryPatternObjectAdapter();
		}
		@Override
		public Adapter caseStoryPatternObject(StoryPatternObject object) {
			return createStoryPatternObjectAdapter();
		}
		@Override
		public Adapter caseAttributeAssignment(AttributeAssignment object) {
			return createAttributeAssignmentAdapter();
		}
		@Override
		public Adapter caseAbstractStoryPatternLink(
				AbstractStoryPatternLink object) {
			return createAbstractStoryPatternLinkAdapter();
		}
		@Override
		public Adapter caseStoryPatternLink(StoryPatternLink object) {
			return createStoryPatternLinkAdapter();
		}
		@Override
		public Adapter caseContainmentLink(ContainmentLink object) {
			return createContainmentLinkAdapter();
		}
		@Override
		public Adapter caseExpressionLink(ExpressionLink object) {
			return createExpressionLinkAdapter();
		}
		@Override
		public Adapter caseMapEntryLink(MapEntryLink object) {
			return createMapEntryLinkAdapter();
		}
		@Override
		public Adapter caseLinkOrderConstraint(LinkOrderConstraint object) {
			return createLinkOrderConstraintAdapter();
		}
		@Override
		public Adapter caseMLElementWithUUID(MLElementWithUUID object) {
			return createMLElementWithUUIDAdapter();
		}
		@Override
		public Adapter caseMLAnnotatedElement(MLAnnotatedElement object) {
			return createMLAnnotatedElementAdapter();
		}
		@Override
		public Adapter caseMLNamedElement(MLNamedElement object) {
			return createMLNamedElementAdapter();
		}
		@Override
		public Adapter caseMLTypedElement(MLTypedElement object) {
			return createMLTypedElementAdapter();
		}
		@Override
		public Adapter defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.StoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.StoryPattern
	 * @generated
	 */
	public Adapter createStoryPatternAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.StoryPatternElement <em>Story Pattern Element</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.StoryPatternElement
	 * @generated
	 */
	public Adapter createStoryPatternElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject <em>Abstract Story Pattern Object</em>}'.
	 * <!-- begin-user-doc --> This
	 * default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases
	 * anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject
	 * @generated
	 */
	public Adapter createAbstractStoryPatternObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.StoryPatternObject <em>Story Pattern Object</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject
	 * @generated
	 */
	public Adapter createStoryPatternObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.AttributeAssignment <em>Attribute Assignment</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.AttributeAssignment
	 * @generated
	 */
	public Adapter createAttributeAssignmentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink <em>Abstract Story Pattern Link</em>}'.
	 * <!-- begin-user-doc --> This
	 * default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases
	 * anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink
	 * @generated
	 */
	public Adapter createAbstractStoryPatternLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.StoryPatternLink <em>Story Pattern Link</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.StoryPatternLink
	 * @generated
	 */
	public Adapter createStoryPatternLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.ContainmentLink <em>Containment Link</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.ContainmentLink
	 * @generated
	 */
	public Adapter createContainmentLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.ExpressionLink <em>Expression Link</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.ExpressionLink
	 * @generated
	 */
	public Adapter createExpressionLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.MapEntryLink <em>Map Entry Link</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.MapEntryLink
	 * @generated
	 */
	public Adapter createMapEntryLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlstorypatterns.LinkOrderConstraint <em>Link Order Constraint</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlstorypatterns.LinkOrderConstraint
	 * @generated
	 */
	public Adapter createLinkOrderConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlcore.MLAnnotatedElement <em>ML Annotated Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLAnnotatedElement
	 * @generated
	 */
	public Adapter createMLAnnotatedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlcore.MLElementWithUUID <em>ML Element With UUID</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLElementWithUUID
	 * @generated
	 */
	public Adapter createMLElementWithUUIDAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlcore.MLNamedElement <em>ML Named Element</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLNamedElement
	 * @generated
	 */
	public Adapter createMLNamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link de.mdelab.mlcore.MLTypedElement <em>ML Typed Element</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLTypedElement
	 * @generated
	 */
	public Adapter createMLTypedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // MlstorypatternsAdapterFactory
