/**
 */
package de.mdelab.mlstorypatterns.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.BindingTypeEnum;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.LinkOrderConstraintEnum;
import de.mdelab.mlstorypatterns.LinkPositionConstraintEnum;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsFactory;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.util.MlstorypatternsValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class MlstorypatternsPackageImpl extends EPackageImpl
		implements
			MlstorypatternsPackage {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storyPatternEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storyPatternElementEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractStoryPatternObjectEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storyPatternObjectEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass attributeAssignmentEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractStoryPatternLinkEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storyPatternLinkEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass containmentLinkEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass expressionLinkEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mapEntryLinkEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkOrderConstraintEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum modifierEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum matchTypeEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum bindingTypeEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum linkPositionConstraintEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum linkOrderConstraintEnumEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
	 * package package URI value.
	 * <p>
	 * Note: the correct way to create the package is via the static factory
	 * method {@link #init init()}, which also performs initialization of the
	 * package, or returns the registered package, if one already exists. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private MlstorypatternsPackageImpl() {
		super(eNS_URI, MlstorypatternsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link MlstorypatternsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static MlstorypatternsPackage init() {
		if (isInited)
			return (MlstorypatternsPackage) EPackage.Registry.INSTANCE
					.getEPackage(MlstorypatternsPackage.eNS_URI);

		// Obtain or create and register package
		MlstorypatternsPackageImpl theMlstorypatternsPackage = (MlstorypatternsPackageImpl) (EPackage.Registry.INSTANCE
				.get(eNS_URI) instanceof MlstorypatternsPackageImpl
						? EPackage.Registry.INSTANCE.get(eNS_URI)
						: new MlstorypatternsPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();
		MlcorePackage.eINSTANCE.eClass();
		MlexpressionsPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theMlstorypatternsPackage.createPackageContents();

		// Initialize created meta-data
		theMlstorypatternsPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put(theMlstorypatternsPackage,
				new EValidator.Descriptor() {
					public EValidator getEValidator() {
						return MlstorypatternsValidator.INSTANCE;
					}
				});

		// Mark meta-data to indicate it can't be changed
		theMlstorypatternsPackage.freeze();

		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(MlstorypatternsPackage.eNS_URI,
				theMlstorypatternsPackage);
		return theMlstorypatternsPackage;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getStoryPattern() {
		return storyPatternEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPattern_StoryPatternLinks() {
		return (EReference) storyPatternEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPattern_StoryPatternObjects() {
		return (EReference) storyPatternEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPattern_LinkOrderConstraints() {
		return (EReference) storyPatternEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPattern_Constraints() {
		return (EReference) storyPatternEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPattern_NegativeApplicationConditions() {
		return (EReference) storyPatternEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPattern_ContainingPattern() {
		return (EReference) storyPatternEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPattern__StoryPatternNotEmpty__DiagnosticChain_Map() {
		return storyPatternEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPattern__StoryPatternBoundNode__DiagnosticChain_Map() {
		return storyPatternEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getStoryPatternElement() {
		return storyPatternElementEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getStoryPatternElement_Modifier() {
		return (EAttribute) storyPatternElementEClass.getEStructuralFeatures()
				.get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getStoryPatternElement_MatchType() {
		return (EAttribute) storyPatternElementEClass.getEStructuralFeatures()
				.get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternElement__StoryPatternElementOptional__DiagnosticChain_Map() {
		return storyPatternElementEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getAbstractStoryPatternObject() {
		return abstractStoryPatternObjectEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAbstractStoryPatternObject_OutgoingLinks() {
		return (EReference) abstractStoryPatternObjectEClass
				.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAbstractStoryPatternObject_IncomingLinks() {
		return (EReference) abstractStoryPatternObjectEClass
				.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAbstractStoryPatternObject_StoryPattern() {
		return (EReference) abstractStoryPatternObjectEClass
				.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectType__DiagnosticChain_Map() {
		return abstractStoryPatternObjectEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectUniqueName__DiagnosticChain_Map() {
		return abstractStoryPatternObjectEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectName__DiagnosticChain_Map() {
		return abstractStoryPatternObjectEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectAbstractType__DiagnosticChain_Map() {
		return abstractStoryPatternObjectEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternObject__AbstractStoryPatternObjectNACModified__DiagnosticChain_Map() {
		return abstractStoryPatternObjectEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getStoryPatternObject() {
		return storyPatternObjectEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getStoryPatternObject_BindingType() {
		return (EAttribute) storyPatternObjectEClass.getEStructuralFeatures()
				.get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPatternObject_Constraints() {
		return (EReference) storyPatternObjectEClass.getEStructuralFeatures()
				.get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPatternObject_AssignmentExpression() {
		return (EReference) storyPatternObjectEClass.getEStructuralFeatures()
				.get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPatternObject_AttributeAssignments() {
		return (EReference) storyPatternObjectEClass.getEStructuralFeatures()
				.get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectAssignmentBound__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectDataType__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectIncomingLink__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectCreatedUnbound__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectCreatedConstraints__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectDestroyed__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternObject__StoryPatternObjectNACUnbound__DiagnosticChain_Map() {
		return storyPatternObjectEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getAttributeAssignment() {
		return attributeAssignmentEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAttributeAssignment_StoryPatternObject() {
		return (EReference) attributeAssignmentEClass.getEStructuralFeatures()
				.get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAttributeAssignment_AssignmentExpression() {
		return (EReference) attributeAssignmentEClass.getEStructuralFeatures()
				.get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAttributeAssignment_Feature() {
		return (EReference) attributeAssignmentEClass.getEStructuralFeatures()
				.get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAttributeAssignment__AttributeAssignmentFeature__DiagnosticChain_Map() {
		return attributeAssignmentEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAttributeAssignment__AttributeAssignmentExpression__DiagnosticChain_Map() {
		return attributeAssignmentEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAttributeAssignment__AttributeAssignmentType__DiagnosticChain_Map() {
		return attributeAssignmentEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getAbstractStoryPatternLink() {
		return abstractStoryPatternLinkEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAbstractStoryPatternLink_Source() {
		return (EReference) abstractStoryPatternLinkEClass
				.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAbstractStoryPatternLink_Target() {
		return (EReference) abstractStoryPatternLinkEClass
				.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAbstractStoryPatternLink_StoryPattern() {
		return (EReference) abstractStoryPatternLinkEClass
				.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkNACModifier__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSource__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceDestroyed__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkTarget__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceCreated__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceTargetPattern__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetDestroyed__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetCreated__DiagnosticChain_Map() {
		return abstractStoryPatternLinkEClass.getEOperations().get(7);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getStoryPatternLink() {
		return storyPatternLinkEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPatternLink_Feature() {
		return (EReference) storyPatternLinkEClass.getEStructuralFeatures()
				.get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getStoryPatternLink_LinkPositionConstraint() {
		return (EAttribute) storyPatternLinkEClass.getEStructuralFeatures()
				.get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPatternLink_OutgoingLinkOrderConstraints() {
		return (EReference) storyPatternLinkEClass.getEStructuralFeatures()
				.get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryPatternLink_IncomingLinkOrderConstraints() {
		return (EReference) storyPatternLinkEClass.getEStructuralFeatures()
				.get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternLink__StoryPatternLinkSourceTypeFeature__DiagnosticChain_Map() {
		return storyPatternLinkEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternLink__StoryPatternLinkSourceType__DiagnosticChain_Map() {
		return storyPatternLinkEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternLink__StoryPatternLinkOrderedFeature__DiagnosticChain_Map() {
		return storyPatternLinkEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternLink__StoryPatternLinkFeature__DiagnosticChain_Map() {
		return storyPatternLinkEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternLink__StoryPatternLinkPositionConstraint__DiagnosticChain_Map() {
		return storyPatternLinkEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getStoryPatternLink__StoryPatternLinkTargetType__DiagnosticChain_Map() {
		return storyPatternLinkEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getContainmentLink() {
		return containmentLinkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getContainmentLink__ContainmentLinkSourceType__DiagnosticChain_Map() {
		return containmentLinkEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getExpressionLink() {
		return expressionLinkEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExpressionLink_Expression() {
		return (EReference) expressionLinkEClass.getEStructuralFeatures()
				.get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getExpressionLink__ExpressionLinkExpression__DiagnosticChain_Map() {
		return expressionLinkEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getMapEntryLink() {
		return mapEntryLinkEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getMapEntryLink_Feature() {
		return (EReference) mapEntryLinkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getMapEntryLink_ValueTarget() {
		return (EReference) mapEntryLinkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getMapEntryLink__MapEntryLinkFeature__DiagnosticChain_Map() {
		return mapEntryLinkEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getMapEntryLink__MapEntryLinkSourceType__DiagnosticChain_Map() {
		return mapEntryLinkEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getMapEntryLink__MapEntryLinkSourceTypeFeature__DiagnosticChain_Map() {
		return mapEntryLinkEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getLinkOrderConstraint() {
		return linkOrderConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getLinkOrderConstraint_ConstraintType() {
		return (EAttribute) linkOrderConstraintEClass.getEStructuralFeatures()
				.get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getLinkOrderConstraint_PredecessorLink() {
		return (EReference) linkOrderConstraintEClass.getEStructuralFeatures()
				.get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getLinkOrderConstraint_SuccessorLink() {
		return (EReference) linkOrderConstraintEClass.getEStructuralFeatures()
				.get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getLinkOrderConstraint_StoryPattern() {
		return (EReference) linkOrderConstraintEClass.getEStructuralFeatures()
				.get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintPredecessorPosition__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintSuccessor__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintSuccessorPosition__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintPredecessor__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintPredecessorFeature__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintType__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getLinkOrderConstraint__LinkOrderConstraintMatchingFeature__DiagnosticChain_Map() {
		return linkOrderConstraintEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getModifierEnum() {
		return modifierEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getMatchTypeEnum() {
		return matchTypeEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getBindingTypeEnum() {
		return bindingTypeEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getLinkPositionConstraintEnum() {
		return linkPositionConstraintEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getLinkOrderConstraintEnum() {
		return linkOrderConstraintEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MlstorypatternsFactory getMlstorypatternsFactory() {
		return (MlstorypatternsFactory) getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;

		// Create classes and their features
		storyPatternEClass = createEClass(STORY_PATTERN);
		createEReference(storyPatternEClass,
				STORY_PATTERN__STORY_PATTERN_LINKS);
		createEReference(storyPatternEClass,
				STORY_PATTERN__STORY_PATTERN_OBJECTS);
		createEReference(storyPatternEClass,
				STORY_PATTERN__LINK_ORDER_CONSTRAINTS);
		createEReference(storyPatternEClass, STORY_PATTERN__CONSTRAINTS);
		createEReference(storyPatternEClass,
				STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS);
		createEReference(storyPatternEClass, STORY_PATTERN__CONTAINING_PATTERN);
		createEOperation(storyPatternEClass,
				STORY_PATTERN___STORY_PATTERN_NOT_EMPTY__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternEClass,
				STORY_PATTERN___STORY_PATTERN_BOUND_NODE__DIAGNOSTICCHAIN_MAP);

		storyPatternElementEClass = createEClass(STORY_PATTERN_ELEMENT);
		createEAttribute(storyPatternElementEClass,
				STORY_PATTERN_ELEMENT__MODIFIER);
		createEAttribute(storyPatternElementEClass,
				STORY_PATTERN_ELEMENT__MATCH_TYPE);
		createEOperation(storyPatternElementEClass,
				STORY_PATTERN_ELEMENT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP);

		abstractStoryPatternObjectEClass = createEClass(
				ABSTRACT_STORY_PATTERN_OBJECT);
		createEReference(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS);
		createEReference(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS);
		createEReference(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN);
		createEOperation(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_UNIQUE_NAME__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAME__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_ABSTRACT_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternObjectEClass,
				ABSTRACT_STORY_PATTERN_OBJECT___ABSTRACT_STORY_PATTERN_OBJECT_NAC_MODIFIED__DIAGNOSTICCHAIN_MAP);

		storyPatternObjectEClass = createEClass(STORY_PATTERN_OBJECT);
		createEAttribute(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT__BINDING_TYPE);
		createEReference(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT__CONSTRAINTS);
		createEReference(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION);
		createEReference(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_ASSIGNMENT_BOUND__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DATA_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_INCOMING_LINK__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_UNBOUND__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_CONSTRAINTS__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DESTROYED__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternObjectEClass,
				STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_NAC_UNBOUND__DIAGNOSTICCHAIN_MAP);

		attributeAssignmentEClass = createEClass(ATTRIBUTE_ASSIGNMENT);
		createEReference(attributeAssignmentEClass,
				ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT);
		createEReference(attributeAssignmentEClass,
				ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION);
		createEReference(attributeAssignmentEClass,
				ATTRIBUTE_ASSIGNMENT__FEATURE);
		createEOperation(attributeAssignmentEClass,
				ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_FEATURE__DIAGNOSTICCHAIN_MAP);
		createEOperation(attributeAssignmentEClass,
				ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_EXPRESSION__DIAGNOSTICCHAIN_MAP);
		createEOperation(attributeAssignmentEClass,
				ATTRIBUTE_ASSIGNMENT___ATTRIBUTE_ASSIGNMENT_TYPE__DIAGNOSTICCHAIN_MAP);

		abstractStoryPatternLinkEClass = createEClass(
				ABSTRACT_STORY_PATTERN_LINK);
		createEReference(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK__SOURCE);
		createEReference(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK__TARGET);
		createEReference(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_NAC_MODIFIER__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_DESTROYED__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_CREATED__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_SOURCE_TARGET_PATTERN__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_DESTROYED__DIAGNOSTICCHAIN_MAP);
		createEOperation(abstractStoryPatternLinkEClass,
				ABSTRACT_STORY_PATTERN_LINK___ABSTRACT_STORY_PATTERN_LINK_TARGET_CREATED__DIAGNOSTICCHAIN_MAP);

		storyPatternLinkEClass = createEClass(STORY_PATTERN_LINK);
		createEReference(storyPatternLinkEClass, STORY_PATTERN_LINK__FEATURE);
		createEAttribute(storyPatternLinkEClass,
				STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT);
		createEReference(storyPatternLinkEClass,
				STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS);
		createEReference(storyPatternLinkEClass,
				STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS);
		createEOperation(storyPatternLinkEClass,
				STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternLinkEClass,
				STORY_PATTERN_LINK___STORY_PATTERN_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternLinkEClass,
				STORY_PATTERN_LINK___STORY_PATTERN_LINK_ORDERED_FEATURE__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternLinkEClass,
				STORY_PATTERN_LINK___STORY_PATTERN_LINK_FEATURE__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternLinkEClass,
				STORY_PATTERN_LINK___STORY_PATTERN_LINK_POSITION_CONSTRAINT__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyPatternLinkEClass,
				STORY_PATTERN_LINK___STORY_PATTERN_LINK_TARGET_TYPE__DIAGNOSTICCHAIN_MAP);

		containmentLinkEClass = createEClass(CONTAINMENT_LINK);
		createEOperation(containmentLinkEClass,
				CONTAINMENT_LINK___CONTAINMENT_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP);

		expressionLinkEClass = createEClass(EXPRESSION_LINK);
		createEReference(expressionLinkEClass, EXPRESSION_LINK__EXPRESSION);
		createEOperation(expressionLinkEClass,
				EXPRESSION_LINK___EXPRESSION_LINK_EXPRESSION__DIAGNOSTICCHAIN_MAP);

		mapEntryLinkEClass = createEClass(MAP_ENTRY_LINK);
		createEReference(mapEntryLinkEClass, MAP_ENTRY_LINK__FEATURE);
		createEReference(mapEntryLinkEClass, MAP_ENTRY_LINK__VALUE_TARGET);
		createEOperation(mapEntryLinkEClass,
				MAP_ENTRY_LINK___MAP_ENTRY_LINK_FEATURE__DIAGNOSTICCHAIN_MAP);
		createEOperation(mapEntryLinkEClass,
				MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(mapEntryLinkEClass,
				MAP_ENTRY_LINK___MAP_ENTRY_LINK_SOURCE_TYPE_FEATURE__DIAGNOSTICCHAIN_MAP);

		linkOrderConstraintEClass = createEClass(LINK_ORDER_CONSTRAINT);
		createEAttribute(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE);
		createEReference(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK);
		createEReference(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK);
		createEReference(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT__STORY_PATTERN);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_POSITION__DIAGNOSTICCHAIN_MAP);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR__DIAGNOSTICCHAIN_MAP);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR_POSITION__DIAGNOSTICCHAIN_MAP);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR__DIAGNOSTICCHAIN_MAP);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_FEATURE__DIAGNOSTICCHAIN_MAP);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(linkOrderConstraintEClass,
				LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_MATCHING_FEATURE__DIAGNOSTICCHAIN_MAP);

		// Create enums
		modifierEnumEEnum = createEEnum(MODIFIER_ENUM);
		matchTypeEnumEEnum = createEEnum(MATCH_TYPE_ENUM);
		bindingTypeEnumEEnum = createEEnum(BINDING_TYPE_ENUM);
		linkPositionConstraintEnumEEnum = createEEnum(
				LINK_POSITION_CONSTRAINT_ENUM);
		linkOrderConstraintEnumEEnum = createEEnum(LINK_ORDER_CONSTRAINT_ENUM);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model. This
	 * method is guarded to have no affect on any invocation but its first. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		MlcorePackage theMlcorePackage = (MlcorePackage) EPackage.Registry.INSTANCE
				.getEPackage(MlcorePackage.eNS_URI);
		MlexpressionsPackage theMlexpressionsPackage = (MlexpressionsPackage) EPackage.Registry.INSTANCE
				.getEPackage(MlexpressionsPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		storyPatternEClass.getESuperTypes()
				.add(theMlcorePackage.getMLElementWithUUID());
		storyPatternEClass.getESuperTypes()
				.add(theMlcorePackage.getMLAnnotatedElement());
		storyPatternEClass.getESuperTypes()
				.add(theMlcorePackage.getMLNamedElement());
		storyPatternElementEClass.getESuperTypes()
				.add(theMlcorePackage.getMLElementWithUUID());
		storyPatternElementEClass.getESuperTypes()
				.add(theMlcorePackage.getMLAnnotatedElement());
		abstractStoryPatternObjectEClass.getESuperTypes()
				.add(this.getStoryPatternElement());
		abstractStoryPatternObjectEClass.getESuperTypes()
				.add(theMlcorePackage.getMLNamedElement());
		abstractStoryPatternObjectEClass.getESuperTypes()
				.add(theMlcorePackage.getMLTypedElement());
		storyPatternObjectEClass.getESuperTypes()
				.add(this.getAbstractStoryPatternObject());
		attributeAssignmentEClass.getESuperTypes()
				.add(theMlcorePackage.getMLElementWithUUID());
		attributeAssignmentEClass.getESuperTypes()
				.add(theMlcorePackage.getMLAnnotatedElement());
		abstractStoryPatternLinkEClass.getESuperTypes()
				.add(this.getStoryPatternElement());
		storyPatternLinkEClass.getESuperTypes()
				.add(this.getAbstractStoryPatternLink());
		containmentLinkEClass.getESuperTypes()
				.add(this.getAbstractStoryPatternLink());
		expressionLinkEClass.getESuperTypes()
				.add(this.getAbstractStoryPatternLink());
		mapEntryLinkEClass.getESuperTypes()
				.add(this.getAbstractStoryPatternLink());
		linkOrderConstraintEClass.getESuperTypes()
				.add(theMlcorePackage.getMLElementWithUUID());
		linkOrderConstraintEClass.getESuperTypes()
				.add(theMlcorePackage.getMLAnnotatedElement());

		// Initialize classes, features, and operations; add parameters
		initEClass(storyPatternEClass, StoryPattern.class, "StoryPattern",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStoryPattern_StoryPatternLinks(),
				this.getAbstractStoryPatternLink(),
				this.getAbstractStoryPatternLink_StoryPattern(),
				"storyPatternLinks", null, 0, -1, StoryPattern.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				!IS_ORDERED);
		initEReference(getStoryPattern_StoryPatternObjects(),
				this.getAbstractStoryPatternObject(),
				this.getAbstractStoryPatternObject_StoryPattern(),
				"storyPatternObjects", null, 1, -1, StoryPattern.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				!IS_ORDERED);
		initEReference(getStoryPattern_LinkOrderConstraints(),
				this.getLinkOrderConstraint(),
				this.getLinkOrderConstraint_StoryPattern(),
				"linkOrderConstraints", null, 0, -1, StoryPattern.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				!IS_ORDERED);
		initEReference(getStoryPattern_Constraints(),
				theMlexpressionsPackage.getMLExpression(), null, "constraints",
				null, 0, -1, StoryPattern.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStoryPattern_NegativeApplicationConditions(),
				this.getStoryPattern(),
				this.getStoryPattern_ContainingPattern(),
				"negativeApplicationConditions", null, 0, -1,
				StoryPattern.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
				!IS_DERIVED, !IS_ORDERED);
		initEReference(getStoryPattern_ContainingPattern(),
				this.getStoryPattern(),
				this.getStoryPattern_NegativeApplicationConditions(),
				"containingPattern", null, 0, 1, StoryPattern.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);

		EOperation op = initEOperation(
				getStoryPattern__StoryPatternNotEmpty__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternNotEmpty", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		EGenericType g1 = createEGenericType(ecorePackage.getEMap());
		EGenericType g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPattern__StoryPatternBoundNode__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternBoundNode", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(storyPatternElementEClass, StoryPatternElement.class,
				"StoryPatternElement", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStoryPatternElement_Modifier(),
				this.getModifierEnum(), "modifier", null, 1, 1,
				StoryPatternElement.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEAttribute(getStoryPatternElement_MatchType(),
				this.getMatchTypeEnum(), "matchType", null, 1, 1,
				StoryPatternElement.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);

		op = initEOperation(
				getStoryPatternElement__StoryPatternElementOptional__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternElementOptional", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(abstractStoryPatternObjectEClass,
				AbstractStoryPatternObject.class, "AbstractStoryPatternObject",
				IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAbstractStoryPatternObject_OutgoingLinks(),
				this.getAbstractStoryPatternLink(),
				this.getAbstractStoryPatternLink_Source(), "outgoingLinks",
				null, 0, -1, AbstractStoryPatternObject.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAbstractStoryPatternObject_IncomingLinks(),
				this.getAbstractStoryPatternLink(),
				this.getAbstractStoryPatternLink_Target(), "incomingLinks",
				null, 0, -1, AbstractStoryPatternObject.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAbstractStoryPatternObject_StoryPattern(),
				this.getStoryPattern(),
				this.getStoryPattern_StoryPatternObjects(), "storyPattern",
				null, 1, 1, AbstractStoryPatternObject.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AbstractStoryPatternObjectType", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectUniqueName__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternObjectUniqueName", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectName__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AbstractStoryPatternObjectName", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectAbstractType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternObjectAbstractType", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectNACModified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternObjectNACModified", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(storyPatternObjectEClass, StoryPatternObject.class,
				"StoryPatternObject", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStoryPatternObject_BindingType(),
				this.getBindingTypeEnum(), "bindingType", null, 1, 1,
				StoryPatternObject.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getStoryPatternObject_Constraints(),
				theMlexpressionsPackage.getMLExpression(), null, "constraints",
				null, 0, -1, StoryPatternObject.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStoryPatternObject_AssignmentExpression(),
				theMlexpressionsPackage.getMLExpression(), null,
				"assignmentExpression", null, 0, 1, StoryPatternObject.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getStoryPatternObject_AttributeAssignments(),
				this.getAttributeAssignment(),
				this.getAttributeAssignment_StoryPatternObject(),
				"attributeAssignments", null, 0, -1, StoryPatternObject.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				!IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectAssignmentBound__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternObjectAssignmentBound",
				0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectDataType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternObjectDataType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectIncomingLink__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternObjectIncomingLink", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectCreatedUnbound__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternObjectCreatedUnbound",
				0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectCreatedConstraints__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"StoryPatternObjectCreatedConstraints", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectDestroyed__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternObjectDestroyed", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternObject__StoryPatternObjectNACUnbound__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternObjectNACUnbound", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(attributeAssignmentEClass, AttributeAssignment.class,
				"AttributeAssignment", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAttributeAssignment_StoryPatternObject(),
				this.getStoryPatternObject(),
				this.getStoryPatternObject_AttributeAssignments(),
				"storyPatternObject", null, 1, 1, AttributeAssignment.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getAttributeAssignment_AssignmentExpression(),
				theMlexpressionsPackage.getMLExpression(), null,
				"assignmentExpression", null, 1, 1, AttributeAssignment.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getAttributeAssignment_Feature(),
				ecorePackage.getEStructuralFeature(), null, "feature", null, 1,
				1, AttributeAssignment.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(
				getAttributeAssignment__AttributeAssignmentFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AttributeAssignmentFeature", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAttributeAssignment__AttributeAssignmentExpression__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AttributeAssignmentExpression", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAttributeAssignment__AttributeAssignmentType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AttributeAssignmentType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(abstractStoryPatternLinkEClass,
				AbstractStoryPatternLink.class, "AbstractStoryPatternLink",
				IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAbstractStoryPatternLink_Source(),
				this.getAbstractStoryPatternObject(),
				this.getAbstractStoryPatternObject_OutgoingLinks(), "source",
				null, 1, 1, AbstractStoryPatternLink.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAbstractStoryPatternLink_Target(),
				this.getAbstractStoryPatternObject(),
				this.getAbstractStoryPatternObject_IncomingLinks(), "target",
				null, 1, 1, AbstractStoryPatternLink.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAbstractStoryPatternLink_StoryPattern(),
				this.getStoryPattern(),
				this.getStoryPattern_StoryPatternLinks(), "storyPattern", null,
				1, 1, AbstractStoryPatternLink.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkNACModifier__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternLinkNACModifier", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSource__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AbstractStoryPatternLinkSource", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceDestroyed__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternLinkSourceDestroyed", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkTarget__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "AbstractStoryPatternLinkTarget", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceCreated__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternLinkSourceCreated", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceTargetPattern__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternLinkSourceTargetPattern", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetDestroyed__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternLinkTargetDestroyed", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetCreated__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"AbstractStoryPatternLinkTargetCreated", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(storyPatternLinkEClass, StoryPatternLink.class,
				"StoryPatternLink", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStoryPatternLink_Feature(),
				ecorePackage.getEStructuralFeature(), null, "feature", null, 1,
				1, StoryPatternLink.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStoryPatternLink_LinkPositionConstraint(),
				this.getLinkPositionConstraintEnum(), "linkPositionConstraint",
				"UNCONSTRAINED", 1, 1, StoryPatternLink.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getStoryPatternLink_OutgoingLinkOrderConstraints(),
				this.getLinkOrderConstraint(),
				this.getLinkOrderConstraint_PredecessorLink(),
				"outgoingLinkOrderConstraints", null, 0, -1,
				StoryPatternLink.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStoryPatternLink_IncomingLinkOrderConstraints(),
				this.getLinkOrderConstraint(),
				this.getLinkOrderConstraint_SuccessorLink(),
				"incomingLinkOrderConstraints", null, 0, -1,
				StoryPatternLink.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		op = initEOperation(
				getStoryPatternLink__StoryPatternLinkSourceTypeFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternLinkSourceTypeFeature",
				0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternLink__StoryPatternLinkSourceType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternLinkSourceType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternLink__StoryPatternLinkOrderedFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternLinkOrderedFeature", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternLink__StoryPatternLinkFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternLinkFeature", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternLink__StoryPatternLinkPositionConstraint__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"StoryPatternLinkPositionConstraint", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getStoryPatternLink__StoryPatternLinkTargetType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "StoryPatternLinkTargetType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(containmentLinkEClass, ContainmentLink.class,
				"ContainmentLink", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(
				getContainmentLink__ContainmentLinkSourceType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ContainmentLinkSourceType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(expressionLinkEClass, ExpressionLink.class, "ExpressionLink",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExpressionLink_Expression(),
				theMlexpressionsPackage.getMLExpression(), null, "expression",
				null, 1, 1, ExpressionLink.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(
				getExpressionLink__ExpressionLinkExpression__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ExpressionLinkExpression", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(mapEntryLinkEClass, MapEntryLink.class, "MapEntryLink",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMapEntryLink_Feature(),
				ecorePackage.getEStructuralFeature(), null, "feature", null, 1,
				1, MapEntryLink.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMapEntryLink_ValueTarget(),
				this.getAbstractStoryPatternObject(), null, "valueTarget", null,
				0, 1, MapEntryLink.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(
				getMapEntryLink__MapEntryLinkFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "MapEntryLinkFeature", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getMapEntryLink__MapEntryLinkSourceType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "MapEntryLinkSourceType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getMapEntryLink__MapEntryLinkSourceTypeFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "MapEntryLinkSourceTypeFeature", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(linkOrderConstraintEClass, LinkOrderConstraint.class,
				"LinkOrderConstraint", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLinkOrderConstraint_ConstraintType(),
				this.getLinkOrderConstraintEnum(), "constraintType",
				"ANY_SUCCESSOR", 1, 1, LinkOrderConstraint.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getLinkOrderConstraint_PredecessorLink(),
				this.getStoryPatternLink(),
				this.getStoryPatternLink_OutgoingLinkOrderConstraints(),
				"predecessorLink", null, 1, 1, LinkOrderConstraint.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getLinkOrderConstraint_SuccessorLink(),
				this.getStoryPatternLink(),
				this.getStoryPatternLink_IncomingLinkOrderConstraints(),
				"successorLink", null, 1, 1, LinkOrderConstraint.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getLinkOrderConstraint_StoryPattern(),
				this.getStoryPattern(),
				this.getStoryPattern_LinkOrderConstraints(), "storyPattern",
				null, 1, 1, LinkOrderConstraint.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintPredecessorPosition__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"LinkOrderConstraintPredecessorPosition", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintSuccessor__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "LinkOrderConstraintSuccessor", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintSuccessorPosition__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"LinkOrderConstraintSuccessorPosition", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintPredecessor__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "LinkOrderConstraintPredecessor", 0,
				1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintPredecessorFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"LinkOrderConstraintPredecessorFeature", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintType__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "LinkOrderConstraintType", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(
				getLinkOrderConstraint__LinkOrderConstraintMatchingFeature__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(),
				"LinkOrderConstraintMatchingFeature", 0, 1, IS_UNIQUE,
				IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0,
				1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(modifierEnumEEnum, ModifierEnum.class, "ModifierEnum");
		addEEnumLiteral(modifierEnumEEnum, ModifierEnum.NONE);
		addEEnumLiteral(modifierEnumEEnum, ModifierEnum.CREATE);
		addEEnumLiteral(modifierEnumEEnum, ModifierEnum.DESTROY);

		initEEnum(matchTypeEnumEEnum, MatchTypeEnum.class, "MatchTypeEnum");
		addEEnumLiteral(matchTypeEnumEEnum, MatchTypeEnum.DEFAULT);
		addEEnumLiteral(matchTypeEnumEEnum, MatchTypeEnum.OPTIONAL);

		initEEnum(bindingTypeEnumEEnum, BindingTypeEnum.class,
				"BindingTypeEnum");
		addEEnumLiteral(bindingTypeEnumEEnum, BindingTypeEnum.UNBOUND);
		addEEnumLiteral(bindingTypeEnumEEnum, BindingTypeEnum.BOUND);
		addEEnumLiteral(bindingTypeEnumEEnum, BindingTypeEnum.CAN_BE_BOUND);

		initEEnum(linkPositionConstraintEnumEEnum,
				LinkPositionConstraintEnum.class, "LinkPositionConstraintEnum");
		addEEnumLiteral(linkPositionConstraintEnumEEnum,
				LinkPositionConstraintEnum.UNCONSTRAINED);
		addEEnumLiteral(linkPositionConstraintEnumEEnum,
				LinkPositionConstraintEnum.FIRST);
		addEEnumLiteral(linkPositionConstraintEnumEEnum,
				LinkPositionConstraintEnum.LAST);
		addEEnumLiteral(linkPositionConstraintEnumEEnum,
				LinkPositionConstraintEnum.BETWEEN);

		initEEnum(linkOrderConstraintEnumEEnum, LinkOrderConstraintEnum.class,
				"LinkOrderConstraintEnum");
		addEEnumLiteral(linkOrderConstraintEnumEEnum,
				LinkOrderConstraintEnum.ANY_SUCCESSOR);
		addEEnumLiteral(linkOrderConstraintEnumEEnum,
				LinkOrderConstraintEnum.DIRECT_SUCCESSOR);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/GenModel
		createGenModelAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";
		addAnnotation(this, source, new String[]{});
		addAnnotation(storyPatternEClass, source,
				new String[]{"constraints", "StoryPatternBoundNode"});
		addAnnotation(storyPatternElementEClass, source,
				new String[]{"constraints", "StoryPatternElementOptional"});
		addAnnotation(abstractStoryPatternObjectEClass, source, new String[]{
				"constraints", "AbstractStoryPatternObjectNACModified"});
		addAnnotation(storyPatternObjectEClass, source,
				new String[]{"constraints", "StoryPatternObjectNACUnbound"});
		addAnnotation(attributeAssignmentEClass, source,
				new String[]{"constraints", "AttributeAssignmentType"});
		addAnnotation(abstractStoryPatternLinkEClass, source, new String[]{
				"constraints", "AbstractStoryPatternLinkTargetCreated"});
		addAnnotation(storyPatternLinkEClass, source,
				new String[]{"constraints", "StoryPatternLinkTargetType"});
		addAnnotation(containmentLinkEClass, source,
				new String[]{"constraints", "ContainmentLinkSourceType"});
		addAnnotation(expressionLinkEClass, source,
				new String[]{"constraints", "ExpressionLinkExpression"});
		addAnnotation(mapEntryLinkEClass, source,
				new String[]{"constraints", "MapEntryLinkSourceTypeFeature"});
		addAnnotation(linkOrderConstraintEClass, source, new String[]{
				"constraints", "LinkOrderConstraintMatchingFeature"});
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/GenModel</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createGenModelAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/GenModel";
		addAnnotation(storyPatternEClass, source, new String[]{"documentation",
				"A StoryPattern contains a graph transformation rule."});
		addAnnotation(
				getStoryPattern__StoryPatternNotEmpty__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternNotEmpty:\n *   let\n *     severity : Integer[1] = \'StoryPattern::StoryPatternNotEmpty\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if not self.storyPatternObjects->isEmpty()\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else Tuple{message = \'Story pattern \' +\n *               self.toString() + \' may not be empty.\', status = status}\n *           endif\n *       in\n *         \'StoryPattern::StoryPatternNotEmpty\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPattern_c_c_StoryPatternNotEmpty);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>> storyPatternObjects = this.getStoryPatternObjects();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_storyPatternObjects = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternObject, storyPatternObjects);\n\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_storyPatternObjects).booleanValue();\n\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(isEmpty);\n\tif (not == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (not) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_may_32_not_32_be_32_empty);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPattern_c_c_StoryPatternNotEmpty, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPattern__StoryPatternBoundNode__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternBoundNode:\n *   let\n *     severity : Integer[1] = \'StoryPattern::StoryPatternBoundNode\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.containingPattern = null implies\n *             self.storyPatternObjects->select(e |\n *               e.oclIsKindOf(StoryPatternObject))\n *             ->exists(e |\n *               e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::BOUND or\n *               e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::CAN_BE_BOUND) or\n *             self.storyPatternObjects->forAll(e | e.modifier = ModifierEnum::CREATE and e.matchType = MatchTypeEnum::DEFAULT)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern \' +\n *               self.toString() + \' must contain at least one bound or only created objects.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPattern::StoryPatternBoundNode\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPattern_c_c_StoryPatternBoundNode);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> containingPattern = this.getContainingPattern();\n\tfinal /*@NonInvalid*/ boolean eq = containingPattern == null;\n\t/*@Thrown*/ <%java.lang.Boolean%> implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>> storyPatternObjects_0 = this.getStoryPatternObjects();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_storyPatternObjects_0 = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternObject, storyPatternObjects_0);\n\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_exists;\n\t\ttry {\n\t\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue%>.Accumulator accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternObject);\n\t\t\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_storyPatternObjects_0.iterator();\n\t\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\tselect = accumulator;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> e_0 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>)ITERATOR_e_0.next();\n\t\t\t\t/**\n\t\t\t\t * e.oclIsKindOf(StoryPatternObject)\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_StoryPatternObject = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_StoryPatternObject, null);\n\t\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_0, TYP_mlstorypatterns_c_c_StoryPatternObject).booleanValue();\n\t\t\t\t//\n\t\t\t\tif (oclIsKindOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\taccumulator.add(e_0);\n\t\t\t\t}\n\t\t\t}\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = select.iterator();\n\t\t\t/*@Thrown*/ <%java.lang.Boolean%> exists;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\tif (accumulator_0 == null) {\n\t\t\t\t\t\texists = null;\n\t\t\t\t\t}\n\t\t\t\t\telse if (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> e_1 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>)ITERATOR_e_1.next();\n\t\t\t\t/**\n\t\t\t\t *\n\t\t\t\t * e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::BOUND or\n\t\t\t\t * e.oclAsType(StoryPatternObject).bindingType = BindingTypeEnum::CAN_BE_BOUND\n\t\t\t\t */\n\t\t\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_or;\n\t\t\t\ttry {\n\t\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_eq_0;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_StoryPatternObject_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_StoryPatternObject, null);\n\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.StoryPatternObject%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%de.mdelab.mlstorypatterns.StoryPatternObject%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternObject_0));\n\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.BindingTypeEnum%> bindingType = oclAsType.getBindingType();\n\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_bindingType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_BindingTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(bindingType.getName()));\n\t\t\t\t\t\tfinal /*@Thrown*/ boolean eq_0 = BOXED_bindingType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_BOUND;\n\t\t\t\t\t\tCAUGHT_eq_0 = eq_0;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\tCAUGHT_eq_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_eq_1;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_StoryPatternObject_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_StoryPatternObject, null);\n\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.StoryPatternObject%> oclAsType_0 = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%de.mdelab.mlstorypatterns.StoryPatternObject%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternObject_1));\n\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.BindingTypeEnum%> bindingType_0 = oclAsType_0.getBindingType();\n\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_bindingType_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_BindingTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(bindingType_0.getName()));\n\t\t\t\t\t\tfinal /*@Thrown*/ boolean eq_1 = BOXED_bindingType_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CAN_BE_BOUND;\n\t\t\t\t\t\tCAUGHT_eq_1 = eq_1;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\tCAUGHT_eq_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(CAUGHT_eq_0, CAUGHT_eq_1);\n\t\t\t\t\tCAUGHT_or = or;\n\t\t\t\t}\n\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\tCAUGHT_or = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\t//\n\t\t\t\tif (CAUGHT_or == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_or == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_or == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\taccumulator_0 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_or instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\taccumulator_0 = CAUGHT_or;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t}\n\t\t\t}\n\t\t\tCAUGHT_exists = exists;\n\t\t}\n\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\tCAUGHT_exists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t}\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_2 = BOXED_storyPatternObjects_0.iterator();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> forAll;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_2.hasNext()) {\n\t\t\t\tif (accumulator_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_1;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> e_2 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>)ITERATOR_e_2.next();\n\t\t\t/**\n\t\t\t * e.modifier = ModifierEnum::CREATE and e.matchType = MatchTypeEnum::DEFAULT\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = e_2.getModifier();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\t\t\tfinal /*@NonInvalid*/ boolean eq_2 = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\t\t/*@NonInvalid*/ boolean and;\n\t\t\tif (eq_2) {\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.MatchTypeEnum%> matchType = e_2.getMatchType();\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_matchType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_MatchTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(matchType.getName()));\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq_3 = BOXED_matchType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DEFAULT;\n\t\t\t\tand = eq_3;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t}\n\t\t\t//\n\t\t\tif (and == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (and == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator_1 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t}\n\t\t}\n\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or_0 = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(CAUGHT_exists, forAll);\n\t\timplies = or_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_contain_32_at_32_least_32_one_32_bound_32_or_32_only_32_created_32_objects);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPattern_c_c_StoryPatternBoundNode, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getStoryPattern_StoryPatternLinks(), source, new String[]{
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!storyPatternLinks"});
		addAnnotation(getStoryPattern_StoryPatternObjects(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!storyPatternObjects"});
		addAnnotation(getStoryPattern_LinkOrderConstraints(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!linkOrderConstraints"});
		addAnnotation(getStoryPattern_Constraints(), source, new String[]{
				"documentation",
				"Additional constraints that have to be satsified by a valid match.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!constraints"});
		addAnnotation(getStoryPattern_NegativeApplicationConditions(), source,
				new String[]{"documentation",
						"Negative application conditions are story patterns for which no match\nmay be found, so that the whole story pattern can be matched.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!negativeApplicationConditions"});
		addAnnotation(getStoryPattern_ContainingPattern(), source, new String[]{
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPattern!containingPattern"});
		addAnnotation(storyPatternElementEClass, source, new String[]{
				"documentation",
				"Superclass of all elements that may be contained in a StoryPattern, i.e., objects and links."});
		addAnnotation(
				getStoryPatternElement__StoryPatternElementOptional__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternElementOptional:\n *   let\n *     severity : Integer[1] = \'StoryPatternElement::StoryPatternElementOptional\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.matchType = MatchTypeEnum::OPTIONAL implies self.modifier = ModifierEnum::CREATE or self.modifier = ModifierEnum::DESTROY\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Optional story pattern element \' +\n *               self.toString() + \' must be created or destroyed.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternElement::StoryPatternElementOptional\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternElement_c_c_StoryPatternElementOptional);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.MatchTypeEnum%> matchType = this.getMatchType();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_matchType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_MatchTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(matchType.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_matchType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_OPTIONAL;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier_0 = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier_0.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\t/*@NonInvalid*/ boolean or;\n\t\tif (eq_0) {\n\t\t\tor = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ boolean eq_1 = BOXED_modifier_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DESTROY;\n\t\t\tor = eq_1;\n\t\t}\n\t\timplies = or;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Optional_32_story_32_pattern_32_element_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_created_32_or_32_destroyed);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternElement_c_c_StoryPatternElementOptional, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getStoryPatternElement_Modifier(), source, new String[]{
				"documentation",
				"The modifier specifies how the element is modified, when the StoryPattern is applied, i.e., whether the element is created, deleted, or left unchanged.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternElement!modifier"});
		addAnnotation(getStoryPatternElement_MatchType(), source, new String[]{
				"documentation",
				"The match type can be used to specify that the element has to be matched in a special way.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternElement!matchType"});
		addAnnotation(abstractStoryPatternObjectEClass, source,
				new String[]{"documentation",
						"Superclass of all objects in a StoryPattern."});
		addAnnotation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternObjectType:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternObject::AbstractStoryPatternObjectType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.type <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \' must have a type.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternObject::AbstractStoryPatternObjectType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\tfinal /*@NonInvalid*/ boolean ne = type != null;\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (ne) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_have_32_a_32_type);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectUniqueName__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternObjectUniqueName:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternObject::AbstractStoryPatternObjectUniqueName\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if\n *             self.storyPattern.storyPatternObjects->select(e | e.name = self.name)\n *             ->size() = 1\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Name of story pattern object \' +\n *               self.toString() + \' must be unique.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternObject::AbstractStoryPatternObjectUniqueName\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectUniqueName);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern = this.getStoryPattern();\n\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>> storyPatternObjects = storyPattern.getStoryPatternObjects();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_storyPatternObjects = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternObject, storyPatternObjects);\n\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue%>.Accumulator accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternObject);\n\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_storyPatternObjects.iterator();\n\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\twhile (true) {\n\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\tselect = accumulator;\n\t\t\tbreak;\n\t\t}\n\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> e_0 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%>)ITERATOR_e_0.next();\n\t\t/**\n\t\t * e.name = self.name\n\t\t */\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = e_0.getName();\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_0 = this.getName();\n\t\tfinal /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);\n\t\t//\n\t\tif (eq == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\taccumulator.add(e_0);\n\t\t}\n\t}\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select);\n\tfinal /*@NonInvalid*/ boolean eq_0 = size.equals(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_1);\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (eq_0) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Name_32_of_32_story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_unique);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectUniqueName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectName__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternObjectName:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternObject::AbstractStoryPatternObjectName\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.name <> null and self.name <> \'\'\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \' must have a name.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternObject::AbstractStoryPatternObjectName\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectName);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%java.lang.String%> name_0 = this.getName();\n\tfinal /*@NonInvalid*/ boolean ne = name_0 != null;\n\t/*@NonInvalid*/ boolean and;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ boolean ne_0 = !<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_.equals(name_0);\n\t\tand = ne_0;\n\t}\n\telse {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (and) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_have_32_a_32_name);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectAbstractType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternObjectAbstractType:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternObject::AbstractStoryPatternObjectAbstractType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.type <> null and\n *             self.type.oclIsKindOf(ecore::EClass) and self.modifier = ModifierEnum::CREATE implies\n *             not self.type.oclAsType(ecore::EClass).abstract\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Created story pattern object \' +\n *               self.toString() + \' must not have an abstract type.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternObject::AbstractStoryPatternObjectAbstractType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectAbstractTy);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_4;\nif (le) {\n\tsymbol_4 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_and_0;\n\ttry {\n\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_and;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = this.getType();\n\t\t\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t\t\t/*@Thrown*/ boolean and;\n\t\t\tif (ne) {\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass).booleanValue();\n\t\t\t\tand = oclIsKindOf;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t}\n\t\t\tCAUGHT_and = and;\n\t\t}\n\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\tCAUGHT_and = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> and_0 = <%org.eclipse.ocl.pivot.library.logical.BooleanAndOperation%>.INSTANCE.evaluate(CAUGHT_and, eq);\n\t\tCAUGHT_and_0 = and_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_and_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_symbol_0;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_1 = this.getType();\n\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClass%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EClass%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, type_1, TYP_ecore_c_c_EClass_0));\n\t\tfinal /*@Thrown*/ boolean symbol_0 = oclAsType.isAbstract();\n\t\tCAUGHT_symbol_0 = symbol_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(CAUGHT_symbol_0);\n\tfinal /*@Thrown*/ <%java.lang.Boolean%> implies = <%org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation%>.INSTANCE.evaluate(CAUGHT_and_0, not);\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_1 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\n\tif (symbol_1) {\n\t\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Created_32_story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_not_32_have_32_an_32_abstract_32_type);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_3 = symbol_2;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectAbstractTy, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_3, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_4 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_4;"});
		addAnnotation(
				getAbstractStoryPatternObject__AbstractStoryPatternObjectNACModified__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternObjectNACModified:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternObject::AbstractStoryPatternObjectNACModified\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.storyPattern.containingPattern <> null implies self.modifier = ModifierEnum::NONE\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \' in NAC must not be modified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternObject::AbstractStoryPatternObjectNACModified\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectNACModifie);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern = this.getStoryPattern();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> containingPattern = storyPattern.getContainingPattern();\n\tfinal /*@NonInvalid*/ boolean ne = containingPattern != null;\n\t/*@NonInvalid*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_NONE;\n\t\timplies = eq;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_in_32_NAC_32_must_32_not_32_be_32_modified);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternObject_c_c_AbstractStoryPatternObjectNACModifie, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getAbstractStoryPatternObject_OutgoingLinks(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AbstractStoryPatternObject!outgoingLinks"});
		addAnnotation(getAbstractStoryPatternObject_IncomingLinks(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AbstractStoryPatternObject!incomingLinks"});
		addAnnotation(getAbstractStoryPatternObject_StoryPattern(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AbstractStoryPatternObject!storyPattern"});
		addAnnotation(storyPatternObjectEClass, source, new String[]{
				"documentation",
				"A StoryPatternObject is matched to an EObject, when the StoryPattern is executed."});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectAssignmentBound__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectAssignmentBound:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectAssignmentBound\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.assignmentExpression <> null implies self.bindingType = BindingTypeEnum::BOUND\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \' with assignment expression must be bound.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectAssignmentBound\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectAssignmentBound);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlexpressions.MLExpression%> assignmentExpression = this.getAssignmentExpression();\n\tfinal /*@NonInvalid*/ boolean ne = assignmentExpression != null;\n\t/*@NonInvalid*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.BindingTypeEnum%> bindingType = this.getBindingType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_bindingType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_BindingTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(bindingType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_bindingType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_BOUND;\n\t\timplies = eq;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_with_32_assignment_32_expression_32_must_32_be_32_bound);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectAssignmentBound, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectDataType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectDataType:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectDataType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if\n *             self.type.oclIsKindOf(ecore::EDataType) implies\n *             self.attributeAssignments->isEmpty()\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \', whose type is an EDataType, may not have attribute assignments.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectDataType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectDataType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_oclIsKindOf;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EDataType = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EDataType, null);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EDataType).booleanValue();\n\t\tCAUGHT_oclIsKindOf = oclIsKindOf;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_oclIsKindOf = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AttributeAssignment%>> attributeAssignments = this.getAttributeAssignments();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_attributeAssignments = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AttributeAssignment, attributeAssignments);\n\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_attributeAssignments).booleanValue();\n\tfinal /*@Thrown*/ <%java.lang.Boolean%> implies = <%org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation%>.INSTANCE.evaluate(CAUGHT_oclIsKindOf, isEmpty);\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__44_32_whose_32_type_32_is_32_an_32_EDataType_44_32_may_32_not_32_have_32_attribute_32_assignments);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectDataType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectIncomingLink__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectIncomingLink:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectIncomingLink\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.bindingType <> BindingTypeEnum::BOUND and self.modifier <> ModifierEnum::CREATE and self.matchType = MatchTypeEnum::DEFAULT implies\n *             self.incomingLinks->exists(e | e.modifier <> null) or\n *             self.outgoingLinks->exists(e | e.modifier <> ModifierEnum::CREATE and\n *               (\n *                 e.oclIsKindOf(ContainmentLink) or\n *                 e.oclIsKindOf(StoryPatternLink) and\n *                 e.oclAsType(StoryPatternLink)\n *                 .feature.oclIsKindOf(ecore::EReference) and\n *                 (\n *                   e.oclAsType(StoryPatternLink)\n *                   .feature.oclAsType(ecore::EReference).eOpposite <> null or\n *                   e.oclAsType(StoryPatternLink)\n *                   .feature.oclAsType(ecore::EReference).containment\n *                 )\n *               )) or\n *             self.storyPattern.storyPatternLinks->exists(e |\n *               e.oclIsKindOf(MapEntryLink) and\n *               e.oclAsType(MapEntryLink).valueTarget = self)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \' must be reacheable from another object.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectIncomingLink\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectIncomingLink);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.BindingTypeEnum%> bindingType = this.getBindingType();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_bindingType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_BindingTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(bindingType.getName()));\n\tfinal /*@NonInvalid*/ boolean ne = BOXED_bindingType != <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_BOUND;\n\t/*@NonInvalid*/ boolean and;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\t\tfinal /*@NonInvalid*/ boolean ne_0 = BOXED_modifier != <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\tand = ne_0;\n\t}\n\telse {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@NonInvalid*/ boolean and_0;\n\tif (and) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.MatchTypeEnum%> matchType = this.getMatchType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_matchType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_MatchTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(matchType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_matchType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DEFAULT;\n\t\tand_0 = eq;\n\t}\n\telse {\n\t\tand_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@Thrown*/ <%java.lang.Boolean%> implies;\n\tif (and_0) {\n\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_or_1;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%>> incomingLinks = this.getIncomingLinks();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingLinks = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternLink, incomingLinks);\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_incomingLinks.iterator();\n\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%> e_0 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%>)ITERATOR_e_0.next();\n\t\t\t\t/**\n\t\t\t\t * e.modifier <> null\n\t\t\t\t */\n\t\t\t\t//\n\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_exists_0;\n\t\t\ttry {\n\t\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%>> outgoingLinks = this.getOutgoingLinks();\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingLinks = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternLink, outgoingLinks);\n\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = BOXED_outgoingLinks.iterator();\n\t\t\t\t/*@Thrown*/ <%java.lang.Boolean%> exists_0;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\t\tif (accumulator_0 == null) {\n\t\t\t\t\t\t\texists_0 = null;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\texists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%> e_1 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%>)ITERATOR_e_1.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * e.modifier <> ModifierEnum::CREATE and\n\t\t\t\t\t * (\n\t\t\t\t\t *   e.oclIsKindOf(ContainmentLink) or\n\t\t\t\t\t *   e.oclIsKindOf(StoryPatternLink) and\n\t\t\t\t\t *   e.oclAsType(StoryPatternLink)\n\t\t\t\t\t *   .feature.oclIsKindOf(ecore::EReference) and\n\t\t\t\t\t *   (\n\t\t\t\t\t *     e.oclAsType(StoryPatternLink)\n\t\t\t\t\t *     .feature.oclAsType(ecore::EReference).eOpposite <> null or\n\t\t\t\t\t *     e.oclAsType(StoryPatternLink)\n\t\t\t\t\t *     .feature.oclAsType(ecore::EReference).containment\n\t\t\t\t\t *   )\n\t\t\t\t\t * )\n\t\t\t\t\t */\n\t\t\t\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_and_3;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier_0 = e_1.getModifier();\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier_0.getName()));\n\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean ne_1 = BOXED_modifier_0 != <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\t\t\t\t\t/*@Thrown*/ <%java.lang.Boolean%> and_3;\n\t\t\t\t\t\tif (ne_1) {\n\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_ContainmentLink = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_ContainmentLink, null);\n\t\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_ContainmentLink).booleanValue();\n\t\t\t\t\t\t\t/*@Thrown*/ <%java.lang.Boolean%> or_0;\n\t\t\t\t\t\t\tif (oclIsKindOf) {\n\t\t\t\t\t\t\t\tor_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_and_1;\n\t\t\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_StoryPatternLink = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_StoryPatternLink, null);\n\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf_0 = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternLink).booleanValue();\n\t\t\t\t\t\t\t\t\t/*@Thrown*/ boolean and_1;\n\t\t\t\t\t\t\t\t\tif (oclIsKindOf_0) {\n\t\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EReference = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EReference, null);\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%de.mdelab.mlstorypatterns.StoryPatternLink%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternLink));\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = oclAsType.getFeature();\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf_1 = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, feature, TYP_ecore_c_c_EReference).booleanValue();\n\t\t\t\t\t\t\t\t\t\tand_1 = oclIsKindOf_1;\n\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\t\t\tand_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\tCAUGHT_and_1 = and_1;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\t\t\t\tCAUGHT_and_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_or;\n\t\t\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_ne_2;\n\t\t\t\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EReference_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EReference, null);\n\t\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_StoryPatternLink_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_StoryPatternLink, null);\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> oclAsType_0 = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%de.mdelab.mlstorypatterns.StoryPatternLink%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternLink_1));\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature_0 = oclAsType_0.getFeature();\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EReference%> oclAsType_1 = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EReference%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, feature_0, TYP_ecore_c_c_EReference_0));\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EReference%> eOpposite = oclAsType_1.getEOpposite();\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ boolean ne_2 = eOpposite != null;\n\t\t\t\t\t\t\t\t\t\tCAUGHT_ne_2 = ne_2;\n\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\t\t\t\t\tCAUGHT_ne_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_containment;\n\t\t\t\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EReference_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EReference, null);\n\t\t\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_StoryPatternLink_2 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_StoryPatternLink, null);\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> oclAsType_2 = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%de.mdelab.mlstorypatterns.StoryPatternLink%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, e_1, TYP_mlstorypatterns_c_c_StoryPatternLink_2));\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature_1 = oclAsType_2.getFeature();\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EReference%> oclAsType_3 = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EReference%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, feature_1, TYP_ecore_c_c_EReference_1));\n\t\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ boolean containment = oclAsType_3.isContainment();\n\t\t\t\t\t\t\t\t\t\tCAUGHT_containment = containment;\n\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\t\t\t\t\tCAUGHT_containment = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(CAUGHT_ne_2, CAUGHT_containment);\n\t\t\t\t\t\t\t\t\tCAUGHT_or = or;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\t\t\t\tCAUGHT_or = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> and_2 = <%org.eclipse.ocl.pivot.library.logical.BooleanAndOperation%>.INSTANCE.evaluate(CAUGHT_and_1, CAUGHT_or);\n\t\t\t\t\t\t\t\tor_0 = and_2;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tand_3 = or_0;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tand_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tCAUGHT_and_3 = and_3;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\tCAUGHT_and_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\t//\n\t\t\t\t\tif (CAUGHT_and_3 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\texists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t}\n\t\t\t\t\telse if (CAUGHT_and_3 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t}\n\t\t\t\t\telse if (CAUGHT_and_3 == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\taccumulator_0 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\telse if (CAUGHT_and_3 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\t\taccumulator_0 = CAUGHT_and_3;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t\t}\n\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tCAUGHT_exists_0 = exists_0;\n\t\t\t}\n\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\tCAUGHT_exists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t}\n\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or_1 = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(exists, CAUGHT_exists_0);\n\t\t\tCAUGHT_or_1 = or_1;\n\t\t}\n\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\tCAUGHT_or_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t}\n\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_exists_1;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern = this.getStoryPattern();\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%>> storyPatternLinks = storyPattern.getStoryPatternLinks();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_storyPatternLinks = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AbstractStoryPatternLink, storyPatternLinks);\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t/*@NonNull*/ <%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_2 = BOXED_storyPatternLinks.iterator();\n\t\t\t/*@Thrown*/ <%java.lang.Boolean%> exists_1;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_2.hasNext()) {\n\t\t\t\t\tif (accumulator_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\texists_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_1;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%> e_2 = (<%de.mdelab.mlstorypatterns.AbstractStoryPatternLink%>)ITERATOR_e_2.next();\n\t\t\t\t/**\n\t\t\t\t *\n\t\t\t\t * e.oclIsKindOf(MapEntryLink) and\n\t\t\t\t * e.oclAsType(MapEntryLink).valueTarget = self\n\t\t\t\t */\n\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_and_4;\n\t\t\t\ttry {\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlstorypatterns_c_c_MapEntryLink = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_MapEntryLink, null);\n\t\t\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf_2 = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_2, TYP_mlstorypatterns_c_c_MapEntryLink).booleanValue();\n\t\t\t\t\t/*@Thrown*/ boolean and_4;\n\t\t\t\t\tif (oclIsKindOf_2) {\n\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.MapEntryLink%> oclAsType_4 = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%de.mdelab.mlstorypatterns.MapEntryLink%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, e_2, TYP_mlstorypatterns_c_c_MapEntryLink));\n\t\t\t\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> valueTarget = oclAsType_4.getValueTarget();\n\t\t\t\t\t\tfinal /*@Thrown*/ boolean eq_0 = this.equals(valueTarget);\n\t\t\t\t\t\tand_4 = eq_0;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tand_4 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\tCAUGHT_and_4 = and_4;\n\t\t\t\t}\n\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\tCAUGHT_and_4 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\t//\n\t\t\t\tif (CAUGHT_and_4 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\texists_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and_4 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and_4 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\taccumulator_1 = CAUGHT_and_4;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator_1 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t}\n\t\t\t}\n\t\t\tCAUGHT_exists_1 = exists_1;\n\t\t}\n\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\tCAUGHT_exists_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or_2 = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(CAUGHT_or_1, CAUGHT_exists_1);\n\t\timplies = or_2;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_reacheable_32_from_32_another_32_object);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectIncomingLink, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectCreatedUnbound__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectCreatedUnbound:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectCreatedUnbound\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.modifier = ModifierEnum::CREATE implies self.bindingType = BindingTypeEnum::UNBOUND\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Created story pattern object \' +\n *               self.toString() + \' must be unbound.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectCreatedUnbound\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedUnbound);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.BindingTypeEnum%> bindingType = this.getBindingType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_bindingType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_BindingTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(bindingType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_bindingType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_UNBOUND;\n\t\timplies = eq_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Created_32_story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_unbound);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedUnbound, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectCreatedConstraints__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectCreatedConstraints:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectCreatedConstraints\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.modifier = ModifierEnum::CREATE and self.matchType = MatchTypeEnum::DEFAULT implies\n *             self.constraints->isEmpty()\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Created story pattern object \' +\n *               self.toString() + \' may not have constraints.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectCreatedConstraints\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedConstraints);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t/*@NonInvalid*/ boolean and;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.MatchTypeEnum%> matchType = this.getMatchType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_matchType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_MatchTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(matchType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_matchType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DEFAULT;\n\t\tand = eq_0;\n\t}\n\telse {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@NonInvalid*/ boolean implies;\n\tif (and) {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlexpressions.MLExpression%>> constraints = this.getConstraints();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_constraints = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_MLExpression, constraints);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_constraints).booleanValue();\n\t\timplies = isEmpty;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Created_32_story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_may_32_not_32_have_32_constraints);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedConstraints, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectDestroyed__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectDestroyed:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectDestroyed\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.modifier = ModifierEnum::DESTROY implies\n *             self.attributeAssignments->isEmpty()\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Destroyed story pattern object \' +\n *               self.toString() + \' may not have attribute assignments.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectDestroyed\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectDestroyed);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DESTROY;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlstorypatterns.AttributeAssignment%>> attributeAssignments = this.getAttributeAssignments();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_attributeAssignments = idResolver.createSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.SET_CLSSid_AttributeAssignment, attributeAssignments);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_attributeAssignments).booleanValue();\n\t\timplies = isEmpty;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Destroyed_32_story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_may_32_not_32_have_32_attribute_32_assignments);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectDestroyed, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternObject__StoryPatternObjectNACUnbound__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternObjectNACUnbound:\n *   let\n *     severity : Integer[1] = \'StoryPatternObject::StoryPatternObjectNACUnbound\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.storyPattern.containingPattern <> null implies self.bindingType = BindingTypeEnum::UNBOUND\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern object \' +\n *               self.toString() + \' in a NAC must be unbound.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternObject::StoryPatternObjectNACUnbound\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectNACUnbound);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern = this.getStoryPattern();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> containingPattern = storyPattern.getContainingPattern();\n\tfinal /*@NonInvalid*/ boolean ne = containingPattern != null;\n\t/*@NonInvalid*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.BindingTypeEnum%> bindingType = this.getBindingType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_bindingType = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_BindingTypeEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(bindingType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_bindingType == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_UNBOUND;\n\t\timplies = eq;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_object_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_in_32_a_32_NAC_32_must_32_be_32_unbound);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternObject_c_c_StoryPatternObjectNACUnbound, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getStoryPatternObject_BindingType(), source, new String[]{
				"documentation",
				"The binding type specifies, whether an existing binding is used for this object or a new match has to be sought.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternObject!bindingType"});
		addAnnotation(getStoryPatternObject_Constraints(), source, new String[]{
				"documentation",
				"Constraints express additional conditions that have to be fulfilled to match this object.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternObject!constraints"});
		addAnnotation(getStoryPatternObject_AssignmentExpression(), source,
				new String[]{"documentation",
						"An assignment expression has to return an object to which the StoryPatternObject is matched. The StoryPatternObject\'s binding type has to be \'BOUND\'.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternObject!assignmentExpression"});
		addAnnotation(getStoryPatternObject_AttributeAssignments(), source,
				new String[]{"documentation",
						"Attribute assignments specify attribute values to set when the StoryPattern is applied. Attribute assignments are evaluated after matching the pattern but before applying it.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternObject!attributeAssignments"});
		addAnnotation(attributeAssignmentEClass, source, new String[]{
				"documentation",
				"Attribute assignments specify attribute values to set when the StoryPattern is applied. Attribute assignments are evaluated after matching the pattern but before applying it."});
		addAnnotation(
				getAttributeAssignment__AttributeAssignmentFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AttributeAssignmentFeature:\n *   let\n *     severity : Integer[1] = \'AttributeAssignment::AttributeAssignmentFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.feature <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Feature of attribute assignment \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AttributeAssignment::AttributeAssignmentFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AttributeAssignment_c_c_AttributeAssignmentFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AttributeAssignment_c_c_AttributeAssignmentFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getAttributeAssignment__AttributeAssignmentExpression__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AttributeAssignmentExpression:\n *   let\n *     severity : Integer[1] = \'AttributeAssignment::AttributeAssignmentExpression\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.assignmentExpression <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Assignment expression of attribute assignment \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AttributeAssignment::AttributeAssignmentExpression\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AttributeAssignment_c_c_AttributeAssignmentExpression);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AttributeAssignment_c_c_AttributeAssignmentExpression, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getAttributeAssignment__AttributeAssignmentType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AttributeAssignmentType:\n *   let\n *     severity : Integer[1] = \'AttributeAssignment::AttributeAssignmentType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.feature <> null and self.storyPatternObject.type <> null and\n *             self.storyPatternObject.type.oclIsKindOf(ecore::EClass) implies\n *             self.storyPatternObject.type.oclAsType(ecore::EClass)\n *             .eAllStructuralFeatures->includes(self.feature)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Feature of attribute assignment \' +\n *               self.toString() + \' must belong to the story pattern object\\\'s type.\', status = status\n *             }\n *           endif\n *       in\n *         \'AttributeAssignment::AttributeAssignmentType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AttributeAssignment_c_c_AttributeAssignmentType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_and;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternObject%> storyPatternObject_0 = this.getStoryPatternObject();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = storyPatternObject_0.getType();\n\t\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t\t/*@Thrown*/ boolean and;\n\t\tif (ne) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\tCAUGHT_and = and;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_and = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_includes;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternObject%> storyPatternObject_1 = this.getStoryPatternObject();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_1 = storyPatternObject_1.getType();\n\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClass%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EClass%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, type_1, TYP_ecore_c_c_EClass_1));\n\t\tfinal /*@Thrown*/ <%java.util.List%><<%org.eclipse.emf.ecore.EStructuralFeature%>> eAllStructuralFeatures = oclAsType.getEAllStructuralFeatures();\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_eAllStructuralFeatures = idResolver.createOrderedSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ORD_CLSSid_EStructuralFeature, eAllStructuralFeatures);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = this.getFeature();\n\t\tfinal /*@Thrown*/ boolean includes = <%org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation%>.INSTANCE.evaluate(BOXED_eAllStructuralFeatures, feature).booleanValue();\n\t\tCAUGHT_includes = includes;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_includes = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tfinal /*@Thrown*/ <%java.lang.Boolean%> implies = <%org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation%>.INSTANCE.evaluate(CAUGHT_and, CAUGHT_includes);\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Feature_32_of_32_attribute_32_assignment_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_belong_32_to_32_the_32_story_32_pattern_32_object_39_s_32_type);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AttributeAssignment_c_c_AttributeAssignmentType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getAttributeAssignment_StoryPatternObject(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AttributeAssignment!storyPatternObject"});
		addAnnotation(getAttributeAssignment_AssignmentExpression(), source,
				new String[]{"documentation",
						"This expression computes the new attribute value.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AttributeAssignment!assignmentExpression"});
		addAnnotation(getAttributeAssignment_Feature(), source, new String[]{
				"documentation",
				"The feature of the object to set to the new value.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AttributeAssignment!feature"});
		addAnnotation(abstractStoryPatternLinkEClass, source, new String[]{
				"documentation",
				"Superclass of all links in a StoryPattern.\n\nSource and target of a link must be contained in the same story pattern link\nthe link itself or in the containing pattern."});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkNACModifier__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkNACModifier:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkNACModifier\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.storyPattern.containingPattern <> null implies self.modifier = ModifierEnum::NONE\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern link \' +\n *               self.toString() + \' in a NAC may not be modified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkNACModifier\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkNACModifier);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern = this.getStoryPattern();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> containingPattern = storyPattern.getContainingPattern();\n\tfinal /*@NonInvalid*/ boolean ne = containingPattern != null;\n\t/*@NonInvalid*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_NONE;\n\t\timplies = eq;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_in_32_a_32_NAC_32_may_32_not_32_be_32_modified);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkNACModifier, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSource__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkSource:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkSource\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Source of story pattern link \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkSource\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSource);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSource, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceDestroyed__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkSourceDestroyed:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceDestroyed\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.source.modifier = ModifierEnum::DESTROY implies self.modifier = ModifierEnum::DESTROY\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern link \' +\n *               self.toString() + \' must be destroyed because its source is destroyed.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceDestroyed\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceDestroye);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source = this.getSource();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = source.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DESTROY;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier_0 = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier_0.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DESTROY;\n\t\timplies = eq_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_destroyed_32_because_32_its_32_source_32_is_32_destroyed);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceDestroye, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkTarget__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkTarget:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkTarget\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.target <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Target of story pattern link \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkTarget\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTarget);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTarget, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceCreated__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkSourceCreated:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceCreated\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.source.modifier = ModifierEnum::CREATE implies self.modifier = ModifierEnum::CREATE\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern link \' +\n *               self.toString() + \' must be created because its source is created.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceCreated\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceCreated);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source = this.getSource();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = source.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier_0 = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier_0.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\timplies = eq_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_created_32_because_32_its_32_source_32_is_32_created);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceCreated, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkSourceTargetPattern__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkSourceTargetPattern:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceTargetPattern\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.target <> null implies\n *             (self.source.storyPattern = self.storyPattern or self.source.storyPattern = self.storyPattern.containingPattern\n *             ) and\n *             (self.target.storyPattern = self.storyPattern or self.target.storyPattern = self.storyPattern.containingPattern\n *             )\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Source and target of story pattern link \' +\n *               self.toString() + \' must reside in the same story pattern or its containing pattern.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkSourceTargetPattern\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceTargetPa);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_0 = this.getSource();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern_0 = this.getStoryPattern();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern_1 = source_0.getStoryPattern();\n\tfinal /*@NonInvalid*/ boolean eq = storyPattern_1.equals(storyPattern_0);\n\t/*@NonInvalid*/ boolean or;\n\tif (eq) {\n\t\tor = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> containingPattern = storyPattern_0.getContainingPattern();\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = storyPattern_1.equals(containingPattern);\n\t\tor = eq_0;\n\t}\n\t/*@NonInvalid*/ boolean and;\n\tif (or) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> target_0 = this.getTarget();\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> storyPattern_5 = target_0.getStoryPattern();\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = storyPattern_5.equals(storyPattern_0);\n\t\t/*@NonInvalid*/ boolean or_0;\n\t\tif (eq_1) {\n\t\t\tor_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPattern%> containingPattern_0 = storyPattern_0.getContainingPattern();\n\t\t\tfinal /*@NonInvalid*/ boolean eq_2 = storyPattern_5.equals(containingPattern_0);\n\t\t\tor_0 = eq_2;\n\t\t}\n\t\tand = or_0;\n\t}\n\telse {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (and) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Source_32_and_32_target_32_of_32_story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_reside_32_in_32_the_32_same_32_story_32_pattern_32_or_32_its_32_containing_32_pattern);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkSourceTargetPa, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetDestroyed__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkTargetDestroyed:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetDestroyed\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.target <> null and self.target.modifier = ModifierEnum::DESTROY implies self.modifier = ModifierEnum::DESTROY\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern link \' +\n *               self.toString() + \' must be destroyed because its target is destroyed.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetDestroyed\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetDestroye);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> target = this.getTarget();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = target.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DESTROY;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier_0 = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier_0.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_DESTROY;\n\t\timplies = eq_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_destroyed_32_because_32_its_32_target_32_is_32_destroyed);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetDestroye, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getAbstractStoryPatternLink__AbstractStoryPatternLinkTargetCreated__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv AbstractStoryPatternLinkTargetCreated:\n *   let\n *     severity : Integer[1] = \'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetCreated\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.target <> null and self.target.modifier = ModifierEnum::CREATE implies self.modifier = ModifierEnum::CREATE\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Story pattern link \' +\n *               self.toString() + \' must be created because its target is created.\', status = status\n *             }\n *           endif\n *       in\n *         \'AbstractStoryPatternLink::AbstractStoryPatternLinkTargetCreated\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetCreated);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> target = this.getTarget();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier = target.getModifier();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier.getName()));\n\tfinal /*@NonInvalid*/ boolean eq = BOXED_modifier == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t/*@NonInvalid*/ boolean implies;\n\tif (eq) {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.ModifierEnum%> modifier_0 = this.getModifier();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_modifier_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_ModifierEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(modifier_0.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_CREATE;\n\t\timplies = eq_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_Story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_created_32_because_32_its_32_target_32_is_32_created);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_AbstractStoryPatternLink_c_c_AbstractStoryPatternLinkTargetCreated, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getAbstractStoryPatternLink_Source(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AbstractStoryPatternLink!source"});
		addAnnotation(getAbstractStoryPatternLink_Target(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AbstractStoryPatternLink!target"});
		addAnnotation(getAbstractStoryPatternLink_StoryPattern(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!AbstractStoryPatternLink!storyPattern"});
		addAnnotation(storyPatternLinkEClass, source, new String[]{
				"documentation",
				"A StoryPatternLink is matched to an instance of EStructuralFeature."});
		addAnnotation(
				getStoryPatternLink__StoryPatternLinkSourceTypeFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternLinkSourceTypeFeature:\n *   let\n *     severity : Integer[1] = \'StoryPatternLink::StoryPatternLinkSourceTypeFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.source.type <> null and\n *             self.source.type.oclIsKindOf(ecore::EClass) implies\n *             self.source.type.oclAsType(ecore::EClass)\n *             .eAllStructuralFeatures->includes(self.feature)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The feature of story pattern link \' +\n *               self.toString() + \' must belong to its source object\\\'s type.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternLink::StoryPatternLinkSourceTypeFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkSourceTypeFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_and;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_0 = this.getSource();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = source_0.getType();\n\t\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t\t/*@Thrown*/ boolean and;\n\t\tif (ne) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\tCAUGHT_and = and;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_and = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_includes;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_1 = this.getSource();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_1 = source_1.getType();\n\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClass%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EClass%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, type_1, TYP_ecore_c_c_EClass_1));\n\t\tfinal /*@Thrown*/ <%java.util.List%><<%org.eclipse.emf.ecore.EStructuralFeature%>> eAllStructuralFeatures = oclAsType.getEAllStructuralFeatures();\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_eAllStructuralFeatures = idResolver.createOrderedSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ORD_CLSSid_EStructuralFeature, eAllStructuralFeatures);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = this.getFeature();\n\t\tfinal /*@Thrown*/ boolean includes = <%org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation%>.INSTANCE.evaluate(BOXED_eAllStructuralFeatures, feature).booleanValue();\n\t\tCAUGHT_includes = includes;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_includes = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tfinal /*@Thrown*/ <%java.lang.Boolean%> implies = <%org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation%>.INSTANCE.evaluate(CAUGHT_and, CAUGHT_includes);\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_feature_32_of_32_story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_belong_32_to_32_its_32_source_32_object_39_s_32_type);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkSourceTypeFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternLink__StoryPatternLinkSourceType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternLinkSourceType:\n *   let\n *     severity : Integer[1] = \'StoryPatternLink::StoryPatternLinkSourceType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.source.type <> null implies\n *             self.source.type.oclIsKindOf(ecore::EClass)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The type of the source of story pattern link \' +\n *               self.toString() + \' must be an EClass.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternLink::StoryPatternLinkSourceType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkSourceType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_0 = this.getSource();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = source_0.getType();\n\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t/*@Thrown*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\timplies = oclIsKindOf;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_type_32_of_32_the_32_source_32_of_32_story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_an_32_EClass);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkSourceType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternLink__StoryPatternLinkOrderedFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternLinkOrderedFeature:\n *   let\n *     severity : Integer[1] = \'StoryPatternLink::StoryPatternLinkOrderedFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.linkPositionConstraint <> LinkPositionConstraintEnum::UNCONSTRAINED and self.feature <> null implies self.feature.ordered\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The feature of story pattern link \' +\n *               self.toString() + \' with a link position constraint must be ordered.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternLink::StoryPatternLinkOrderedFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkOrderedFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.LinkPositionConstraintEnum%> linkPositionConstraint = this.getLinkPositionConstraint();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_linkPositionConstraint = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_LinkPositionConstraintEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(linkPositionConstraint.getName()));\n\tfinal /*@NonInvalid*/ boolean ne = BOXED_linkPositionConstraint != <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_UNCONSTRAINED;\n\t/*@NonInvalid*/ boolean and;\n\tif (ne) {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@NonInvalid*/ boolean implies;\n\tif (and) {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = this.getFeature();\n\t\tfinal /*@NonInvalid*/ boolean ordered = feature.isOrdered();\n\t\timplies = ordered;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_feature_32_of_32_story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_with_32_a_32_link_32_position_32_constraint_32_must_32_be_32_ordered);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkOrderedFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getStoryPatternLink__StoryPatternLinkFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternLinkFeature:\n *   let\n *     severity : Integer[1] = \'StoryPatternLink::StoryPatternLinkFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.feature <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Feature of story pattern link \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternLink::StoryPatternLinkFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getStoryPatternLink__StoryPatternLinkPositionConstraint__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternLinkPositionConstraint:\n *   let\n *     severity : Integer[1] = \'StoryPatternLink::StoryPatternLinkPositionConstraint\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.linkPositionConstraint <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Link position constraint of story pattern link \' +\n *               self.toString() + \' must be specified. For unconstrained links use literal \\\'UNCONSTRAINED\\\'.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternLink::StoryPatternLinkPositionConstraint\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkPositionConstraint);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkPositionConstraint, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getStoryPatternLink__StoryPatternLinkTargetType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv StoryPatternLinkTargetType:\n *   let\n *     severity : Integer[1] = \'StoryPatternLink::StoryPatternLinkTargetType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.target <> null and self.target.type <> null implies self.feature.eType = self.target.type or\n *             self.target.type.oclIsKindOf(ecore::EClass) and\n *             (\n *               self.target.type.oclAsType(ecore::EClass)\n *               .eAllSuperTypes->includes(self.feature.eType) or self.feature.eType.name = \'EObject\'\n *             )\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The type of the target of story pattern link \' +\n *               self.toString() + \' must match its feature\\\'s type.\', status = status\n *             }\n *           endif\n *       in\n *         \'StoryPatternLink::StoryPatternLinkTargetType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkTargetType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> target = this.getTarget();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = target.getType();\n\tfinal /*@NonInvalid*/ boolean ne = type != null;\n\t/*@Thrown*/ <%java.lang.Boolean%> implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = this.getFeature();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> eType = feature.getEType();\n\t\tfinal /*@NonInvalid*/ boolean eq = (eType != null) ? eType.equals(type) : (type == null);\n\t\t/*@Thrown*/ <%java.lang.Boolean%> or_0;\n\t\tif (eq) {\n\t\t\tor_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_oclIsKindOf;\n\t\t\ttry {\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\t\t\tCAUGHT_oclIsKindOf = oclIsKindOf;\n\t\t\t}\n\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\tCAUGHT_oclIsKindOf = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t}\n\t\t\t/*@Caught*/ /*@Nullable*/ <%java.lang.Object%> CAUGHT_or;\n\t\t\ttry {\n\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_includes;\n\t\t\t\ttry {\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClass%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EClass%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EClass_1));\n\t\t\t\t\tfinal /*@Thrown*/ <%java.util.List%><<%org.eclipse.emf.ecore.EClass%>> eAllSuperTypes = oclAsType.getEAllSuperTypes();\n\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_eAllSuperTypes = idResolver.createOrderedSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ORD_CLSSid_EClass, eAllSuperTypes);\n\t\t\t\t\tfinal /*@Thrown*/ boolean includes = <%org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation%>.INSTANCE.evaluate(BOXED_eAllSuperTypes, eType).booleanValue();\n\t\t\t\t\tCAUGHT_includes = includes;\n\t\t\t\t}\n\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\tCAUGHT_includes = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_eq_0;\n\t\t\t\ttry {\n\t\t\t\t\tif (eType == null) {\n\t\t\t\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null source for \\\'\\\'http://www.eclipse.org/emf/2002/Ecore\\\'::ENamedElement::name\\\'\");\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown*/ <%java.lang.String%> name = eType.getName();\n\t\t\t\t\tfinal /*@Thrown*/ boolean eq_0 = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_EObject.equals(name);\n\t\t\t\t\tCAUGHT_eq_0 = eq_0;\n\t\t\t\t}\n\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\tCAUGHT_eq_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(CAUGHT_includes, CAUGHT_eq_0);\n\t\t\t\tCAUGHT_or = or;\n\t\t\t}\n\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\tCAUGHT_or = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t}\n\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> and = <%org.eclipse.ocl.pivot.library.logical.BooleanAndOperation%>.INSTANCE.evaluate(CAUGHT_oclIsKindOf, CAUGHT_or);\n\t\t\tor_0 = and;\n\t\t}\n\t\timplies = or_0;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_type_32_of_32_the_32_target_32_of_32_story_32_pattern_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_match_32_its_32_feature_39_s_32_type);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_StoryPatternLink_c_c_StoryPatternLinkTargetType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getStoryPatternLink_Feature(), source, new String[]{
				"documentation",
				"The EStructuralFeature to match this link to.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternLink!feature"});
		addAnnotation(getStoryPatternLink_LinkPositionConstraint(), source,
				new String[]{"documentation",
						"In case the feature is ordered, the link position constraint expresses an additional constraint on the position of the target object in the link.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternLink!linkPositionConstraint"});
		addAnnotation(getStoryPatternLink_OutgoingLinkOrderConstraints(),
				source,
				new String[]{"documentation",
						"The LinkOrderConstraints, for which this StoryPatternLink is the preceeding link.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternLink!outgoingLinkOrderConstraints"});
		addAnnotation(getStoryPatternLink_IncomingLinkOrderConstraints(),
				source,
				new String[]{"documentation",
						"The LinkOrderConstraints, for which this StoryPatternLink is the preceeding link.",
						"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!StoryPatternLink!incomingLinkOrderConstraints"});
		addAnnotation(containmentLinkEClass, source, new String[]{
				"documentation",
				"A ContainmentLink expresses a containment relation between two objects, i.e., the target object is contained directly or indirectly in the source object via containment references."});
		addAnnotation(
				getContainmentLink__ContainmentLinkSourceType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv ContainmentLinkSourceType:\n *   let\n *     severity : Integer[1] = \'ContainmentLink::ContainmentLinkSourceType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source.type <> null implies\n *             self.source.type.oclIsKindOf(ecore::EClass)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The type of the source of containment link \' +\n *               self.toString() + \' must be an EClass.\', status = status\n *             }\n *           endif\n *       in\n *         \'ContainmentLink::ContainmentLinkSourceType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_ContainmentLink_c_c_ContainmentLinkSourceType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_0 = this.getSource();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = source_0.getType();\n\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t/*@Thrown*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\timplies = oclIsKindOf;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_type_32_of_32_the_32_source_32_of_32_containment_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_an_32_EClass);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_ContainmentLink_c_c_ContainmentLinkSourceType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(expressionLinkEClass, source, new String[]{
				"documentation",
				"An ExpressionLink uses an expression to determine the set of elements in which a match for the target object is sought."});
		addAnnotation(
				getExpressionLink__ExpressionLinkExpression__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv ExpressionLinkExpression:\n *   let\n *     severity : Integer[1] = \'ExpressionLink::ExpressionLinkExpression\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.expression <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The expression of expression link \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'ExpressionLink::ExpressionLinkExpression\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_ExpressionLink_c_c_ExpressionLinkExpression);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_ExpressionLink_c_c_ExpressionLinkExpression, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(getExpressionLink_Expression(), source, new String[]{
				"documentation",
				"The link\'s expression. The context of the expression is the source object.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!ExpressionLink!expression"});
		addAnnotation(mapEntryLinkEClass, source, new String[]{"documentation",
				"A MapEntryLink is matched to MapEntries. It is a link between a source object that contains a map and a key and a value object that represent a pair of key and value in that map."});
		addAnnotation(
				getMapEntryLink__MapEntryLinkFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv MapEntryLinkFeature:\n *   let\n *     severity : Integer[1] = \'MapEntryLink::MapEntryLinkFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.feature <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The feature of map entry link \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'MapEntryLink::MapEntryLinkFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_MapEntryLink_c_c_MapEntryLinkFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_MapEntryLink_c_c_MapEntryLinkFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getMapEntryLink__MapEntryLinkSourceType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv MapEntryLinkSourceType:\n *   let\n *     severity : Integer[1] = \'MapEntryLink::MapEntryLinkSourceType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.source.type <> null implies\n *             self.source.type.oclIsKindOf(ecore::EClass)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The type of the source of map entry link \' +\n *               self.toString() + \' must be an EClass.\', status = status\n *             }\n *           endif\n *       in\n *         \'MapEntryLink::MapEntryLinkSourceType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_MapEntryLink_c_c_MapEntryLinkSourceType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_0 = this.getSource();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = source_0.getType();\n\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t/*@Thrown*/ boolean implies;\n\tif (ne) {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\timplies = oclIsKindOf;\n\t}\n\telse {\n\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_type_32_of_32_the_32_source_32_of_32_map_32_entry_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_an_32_EClass);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_MapEntryLink_c_c_MapEntryLinkSourceType, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getMapEntryLink__MapEntryLinkSourceTypeFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv MapEntryLinkSourceTypeFeature:\n *   let\n *     severity : Integer[1] = \'MapEntryLink::MapEntryLinkSourceTypeFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.source <> null and self.source.type <> null and\n *             self.source.type.oclIsKindOf(ecore::EClass) implies\n *             self.source.type.oclAsType(ecore::EClass)\n *             .eAllStructuralFeatures->includes(self.feature)\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The feature of map entry link \' +\n *               self.toString() + \' must belong to its source object\\\'s type.\', status = status\n *             }\n *           endif\n *       in\n *         \'MapEntryLink::MapEntryLinkSourceTypeFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_MapEntryLink_c_c_MapEntryLinkSourceTypeFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_and;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_0 = this.getSource();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_0 = source_0.getType();\n\t\tfinal /*@NonInvalid*/ boolean ne = type_0 != null;\n\t\t/*@Thrown*/ boolean and;\n\t\tif (ne) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_0 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type_0, TYP_ecore_c_c_EClass_0).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\tCAUGHT_and = and;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_and = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\t/*@Caught*/ /*@NonNull*/ <%java.lang.Object%> CAUGHT_includes;\n\ttry {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass_1 = idResolver.getClass(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.CLSSid_EClass, null);\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.AbstractStoryPatternObject%> source_1 = this.getSource();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type_1 = source_1.getType();\n\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClass%> oclAsType = <%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState((<%org.eclipse.emf.ecore.EClass%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, type_1, TYP_ecore_c_c_EClass_1));\n\t\tfinal /*@Thrown*/ <%java.util.List%><<%org.eclipse.emf.ecore.EStructuralFeature%>> eAllStructuralFeatures = oclAsType.getEAllStructuralFeatures();\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_eAllStructuralFeatures = idResolver.createOrderedSetOfAll(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ORD_CLSSid_EStructuralFeature, eAllStructuralFeatures);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = this.getFeature();\n\t\tfinal /*@Thrown*/ boolean includes = <%org.eclipse.ocl.pivot.library.collection.CollectionIncludesOperation%>.INSTANCE.evaluate(BOXED_eAllStructuralFeatures, feature).booleanValue();\n\t\tCAUGHT_includes = includes;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_includes = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tfinal /*@Thrown*/ <%java.lang.Boolean%> implies = <%org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation%>.INSTANCE.evaluate(CAUGHT_and, CAUGHT_includes);\n\tif (implies == null) {\n\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (implies) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_feature_32_of_32_map_32_entry_32_link_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_belong_32_to_32_its_32_source_32_object_39_s_32_type);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_MapEntryLink_c_c_MapEntryLinkSourceTypeFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getMapEntryLink_Feature(), source, new String[]{
				"documentation",
				"The map feature of the source model. Its type must be java.util.Map$Entry, it must be many-valued, and it must be a containment.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!MapEntryLink!feature"});
		addAnnotation(getMapEntryLink_ValueTarget(), source, new String[]{
				"documentation",
				"This object is matched to the value of the map entry.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!MapEntryLink!valueTarget"});
		addAnnotation(linkOrderConstraintEClass, source, new String[]{
				"documentation",
				"LinkOrderConstraints specify a relative ordering between two objects in an ordered link. Depending on the value of constraintType, the target object of successorLink must be a direct successor or any successor of the target of predecessorLink."});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintPredecessorPosition__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintPredecessorPosition:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintPredecessorPosition\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.predecessorLink <> null implies self.predecessorLink.linkPositionConstraint <> LinkPositionConstraintEnum::LAST\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The predecessor link of link order constraint \' +\n *               self.toString() + \' may not have the position constraint \\\'LAST\\\'.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintPredecessorPosition\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorPosition);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> predecessorLink = this.getPredecessorLink();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.LinkPositionConstraintEnum%> linkPositionConstraint = predecessorLink.getLinkPositionConstraint();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_linkPositionConstraint = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_LinkPositionConstraintEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(linkPositionConstraint.getName()));\n\tfinal /*@NonInvalid*/ boolean ne = BOXED_linkPositionConstraint != <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_LAST;\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (ne) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_predecessor_32_link_32_of_32_link_32_order_32_constraint_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_may_32_not_32_have_32_the_32_position_32_constraint_32_39_LAST_39_);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorPosition, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintSuccessor__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintSuccessor:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintSuccessor\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.successorLink <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Successor link of link order constraint \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintSuccessor\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessor);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessor, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintSuccessorPosition__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintSuccessorPosition:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintSuccessorPosition\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.successorLink <> null implies self.successorLink.linkPositionConstraint <> LinkPositionConstraintEnum::FIRST\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The successor link of link order constraint \' +\n *               self.toString() + \' may not have the position constraint \\\'FIRST\\\'.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintSuccessorPosition\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessorPosition);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> successorLink = this.getSuccessorLink();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.LinkPositionConstraintEnum%> linkPositionConstraint = successorLink.getLinkPositionConstraint();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_linkPositionConstraint = <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ENUMid_LinkPositionConstraintEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(linkPositionConstraint.getName()));\n\tfinal /*@NonInvalid*/ boolean ne = BOXED_linkPositionConstraint != <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.ELITid_FIRST;\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (ne) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_successor_32_link_32_of_32_link_32_order_32_constraint_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_may_32_not_32_have_32_the_32_position_32_constraint_32_39_FIRST_39_);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessorPosition, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintPredecessor__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintPredecessor:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintPredecessor\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.predecessorLink <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Predecessor link of link order constraint \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintPredecessor\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessor);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessor, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintPredecessorFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintPredecessorFeature:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintPredecessorFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.predecessorLink <> null and self.predecessorLink.feature <> null implies self.predecessorLink.feature.ordered and self.predecessorLink.feature.many\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The feature of the predecessor link of link order constraint \' +\n *               self.toString() + \' must be ordered and many-valued.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintPredecessorFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> predecessorLink_0 = this.getPredecessorLink();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature_0 = predecessorLink_0.getFeature();\n\tfinal /*@NonInvalid*/ boolean ordered = feature_0.isOrdered();\n\t/*@NonInvalid*/ boolean and;\n\tif (ordered) {\n\t\tfinal /*@NonInvalid*/ boolean many = feature_0.isMany();\n\t\tand = many;\n\t}\n\telse {\n\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t}\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (and) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_feature_32_of_32_the_32_predecessor_32_link_32_of_32_link_32_order_32_constraint_32, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_ordered_32_and_32_many_m_valued);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintType__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintType:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintType\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.constraintType <> null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Constraint type of link order constraint \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintType\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintType);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\nif (le) {\n\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintType, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;"});
		addAnnotation(
				getLinkOrderConstraint__LinkOrderConstraintMatchingFeature__DiagnosticChain_Map(),
				source, new String[]{"body",
						"/**\n *\n * inv LinkOrderConstraintMatchingFeature:\n *   let\n *     severity : Integer[1] = \'LinkOrderConstraint::LinkOrderConstraintMatchingFeature\'.getSeverity()\n *   in\n *     if severity <= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.predecessorLink <> null and self.successorLink <> null implies self.predecessorLink.feature = self.successorLink.feature\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'The features of the predecessor and successor link of link order constraint \' +\n *               self.toString() + \' must be the same.\', status = status\n *             }\n *           endif\n *       in\n *         \'LinkOrderConstraint::LinkOrderConstraintMatchingFeature\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n */\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%>.getExecutor(this);\nfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintMatchingFeature);\nfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n/*@NonInvalid*/ <%java.lang.Object%> symbol_3;\nif (le) {\n\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> predecessorLink = this.getPredecessorLink();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature = predecessorLink.getFeature();\n\tfinal /*@NonInvalid*/ <%de.mdelab.mlstorypatterns.StoryPatternLink%> successorLink = this.getSuccessorLink();\n\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EStructuralFeature%> feature_0 = successorLink.getFeature();\n\tfinal /*@NonInvalid*/ boolean eq = feature.equals(feature_0);\n\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\tif (eq) {\n\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tstatus = null;\n\t}\n\tfinal /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (symbol_0) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_The_32_features_32_of_32_the_32_predecessor_32_and_32_successor_32_link_32_of_32_link_32_order, toString);\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR__32_must_32_be_32_the_32_same);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.TUPLid_, sum_0, status);\n\t\tsymbol_2 = symbol_1;\n\t}\n\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.STR_LinkOrderConstraint_c_c_LinkOrderConstraintMatchingFeature, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_2, <%de.mdelab.mlstorypatterns.MlstorypatternsTables%>.INT_0).booleanValue();\n\tsymbol_3 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_3;"});
		addAnnotation(getLinkOrderConstraint_ConstraintType(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!LinkOrderConstraint!constraintType"});
		addAnnotation(getLinkOrderConstraint_PredecessorLink(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!LinkOrderConstraint!predecessorLink"});
		addAnnotation(getLinkOrderConstraint_SuccessorLink(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!LinkOrderConstraint!successorLink"});
		addAnnotation(getLinkOrderConstraint_StoryPattern(), source,
				new String[]{"get",
						"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlstorypatterns/1.0!LinkOrderConstraint!storyPattern"});
		addAnnotation(modifierEnumEEnum, source, new String[]{"documentation",
				"Specifies how an element of a StoryPattern is affected by the pattern\'s application."});
		addAnnotation(matchTypeEnumEEnum, source, new String[]{"documentation",
				"Defines literals for special kinds of matchings."});
		addAnnotation(matchTypeEnumEEnum.getELiterals().get(0), source,
				new String[]{"documentation",
						"The default matching semantics. If no match can be found, the StoryPattern as a whole does not match."});
		addAnnotation(matchTypeEnumEEnum.getELiterals().get(1), source,
				new String[]{"documentation",
						"Optional objects must be combined with a CREATE or DESTROY modifier. For OPTIONAL-CREATE the effect is that the object is only created if it does not exist. For OPTIONAL-DESTROY the object is deleted if it cannot be found. If no match can be found, the matching of the whole StoryPattern is not affected."});
		addAnnotation(bindingTypeEnumEEnum, source, new String[]{
				"documentation",
				"Defines literals for bindings of objects in a StoryPattern."});
		addAnnotation(bindingTypeEnumEEnum.getELiterals().get(0), source,
				new String[]{"documentation",
						"The object is not boud, find a match for it."});
		addAnnotation(bindingTypeEnumEEnum.getELiterals().get(1), source,
				new String[]{"documentation",
						"Use an existing binding for this object."});
		addAnnotation(bindingTypeEnumEEnum.getELiterals().get(2), source,
				new String[]{"documentation",
						"Use an existing binding for this object if one exists. Otherwise, search for a match."});
		addAnnotation(linkPositionConstraintEnumEEnum.getELiterals().get(1),
				source, new String[]{"documentation",
						"The target object of the link must be the first one in the ordered reference."});
		addAnnotation(linkPositionConstraintEnumEEnum.getELiterals().get(2),
				source, new String[]{"documentation",
						"The target object of the link must be the last one in the ordered reference."});
		addAnnotation(linkOrderConstraintEnumEEnum.getELiterals().get(0),
				source, new String[]{"documentation",
						"The successor may be any successor of the predecessor."});
		addAnnotation(linkOrderConstraintEnumEEnum.getELiterals().get(1),
				source, new String[]{"documentation",
						"The successor must be the direct successor of the predecessor."});
	}

} // MlstorypatternsPackageImpl
